{Unit mit Zeichenfunktionen.. fr Escape Paint}
UNIT 	EscPUnit;

INTERFACE

USES 	Tos,Dos,					{BIOS, XBIOS und GEMDOS-Funktionen}
		NewMouse,					{Eigener Maustreiber}
		EscP_Scr;					{Auflsungsverwaltung}
		
CONST	MEM_SIZE		=1000000;

{}{}{}{AUSGABETEXTE LANDESSPRACHE}{}{}{}

		{$I FKT.INC\ALERT_E.I}
		
{}{}{}{ZEICHENWERKZEUGE}{}{}{}
		DRAW			=1;
		LINE			=2;
		RECT			=3;
		CIRC			=4;
		FILL			=5;
		POLY			=6;
		BOX				=7;
		ZOOM			=8;
		BLKCUT			=9;
		BLKPUT			=10;
		TXT				=11;
		
{}{}{}{ZOOM-TYPEN}{}{}{}
		CRACK			=1;
		NEOCHROME		=2;
		
{}{}{}{ZEICHENMODI}{}{}{}
		D_NORM			=0;
		D_NEG			=1;
		D_TRANS			=2;
		D_AND			=3;
		D_OR			=4;
		D_ADD			=5;
		D_SUB			=6;
		
{}{}{}{BLOCK-HINTERGRUNDVERKNPFUNGEN}{}{}{}
		DECK			=1;
		N_DECK			=2;
		BACKGRND		=3;
		COL_ADD			=4;
		COL_SUB			=5;
		TRANS			=6;
		COL_AND			=7;
		COL_OR			=8;
		
		PUT_RED			=1;
		PUT_GREEN		=2;
		PUT_BLUE		=3;
		PUT_ALL			=4;
		
{}{}{}{BLOCKEDIT-FUNKTIONEN}{}{}{}
		NEGATIV			=1;
		ANTIA			=2;
		BLKSIZE			=3;
		MIRR_X			=4;
		MIRR_Y			=5;
		ROTATE			=6;
		BLKCUTBLK		=7;

{}{}{}{FILEFORMATE}{}{}{}
		XGA				=1;
		EPP				=2;
		TGA				=3;
		TRP				=4;
		TRPBLK			=5;
		TRU				=6;
		TRUBLK			=7;
		PI9				=8;
		PAL				=9;
		GEMPAL			=10;		

{}{}{}{PALETTENSPEICHER-OPTIONEN}{}{}{}
		PALSAVE_ALWAYS	=1;
		PALSAVE_ASK		=2;
		PALSAVE_NEVER	=3;
		
TYPE	Settings		=RECORD
							actscr		:LongInt;
							actpcn		:LongInt;
							acttool		:LongInt;
							mousespeed	:LongInt;
							mousetype	:LongInt;
							zoomtype	:LongInt;
							oldztype	:LongInt;
							zoommagn	:LongInt;
							zoomgrid	:LongInt;
							rt_flag		:LongInt;
						 END;
		picture			= RECORD
							rez_x		:LongInt;	{Bildausdehnung in x-Richtung}
							rez_y		:LongInt;	{Bildausdehnung in y-Richtung}
							adr			:Pointer;	{Bildadresse}
							xpos,ypos	:LongInt;	{Bildausschnittspos.}
							pfad		:String;	{Dateipfad des Bildes}
							name		:String[8];	{Dateiname des Bildes}
							extens		:String;	{Dateiextension des Bildes}
							palpfad		:String;	{Dateipfad der Palette}
							palname 	:String[12];{Dateiname der Palette}
							palflag		:Byte;		{Palettenflag}
							flag		:Byte;		{0..leer  1..voll}
							filetype	:Integer;	{Bildformat}
							palftype	:Integer;	{Palettenformat}
							paladr		:Pointer;	{Palettenadresse}
						END;
		module			= ARRAY[1..16] OF RECORD
							modflag		:Integer;	{Flag (1..installiert)}
							epmpath		:String;	{Path of the scriptfile}
							epmname		:String;	{Name of the scriptfile}
							name		:String;	{Modulename}
							coder		:String;	{Moduleauthor}
							version		:String;	{Moduleversion}
							date		:String;	{Releasedate}
							routpath	:String;	{Path of the Routine}
							typ			:Integer;	{Moduletype}
							lodflag		:Integer;	{DSP-use(1)-flag}
							lodfile		:String;	{Path of the DSP-Programm}
							paramtype	:Integer;	{Parameterflag}
							rscfile		:String;	{Path of RSC-file}
						
							anzpicpop	:Integer;	{Pic-Choose-Buttons}
							picpop		:Array[1..2] OF RECORD
								title	:String;
								actpic	:Integer;
							END;
							
							anzslider	:Integer;	{Sliderdata}
							slider		:Array[1..4] OF RECORD
								name	:String;
								min		:Integer;
								max		:Integer;
								num		:Integer;			
							END;

							anztext		:Integer;	{Textfields}
							textin		:Array[1..2] OF RECORD
								input	:String;
								head	:String;
							END;
			
							filesel		:Integer;	{Fileselektorfield}
							fileselhead	:String;
							fileseltype	:String;
							fileselext	:String;
							fileselfile	:String;
						END;


VAR
		{Speicheradressen}
		sysmem			:Array[0..1000000] OF Byte; {Verwaltungsspeich.}
		picmem			:Pointer;		{Adresse des Bildspeicheranf.}
		picmemflag		:Integer;
		zoomscr			:Pointer;		{Adresse des Zoom-Hilfsscreens}
		blkbuf			:Pointer;		{Adresse eines Blockes}
		rscmem			:Pointer;		{Speicher fr RSC-Daten}
		buffer			:Pointer;		{Adresse eines Arbeitsbuffers}
		scr				:Pointer;		{Adresse des Arbeitsscreens}
		modadr			:Pointer;		{Moduladresse}
		paladr			:Pointer;		{aktuelle 128-Farben-Palette}
		mousecurs		:Array[1..10] OF Pointer;
	 	pic				:Array[1..20] OF Picture;
	 	old_syspal		:Array[0..255] OF LongInt;
		
		{For modulestructure}
		x_resolutions	:Array[1..20] OF LongInt;
		y_resolutions	:Array[1..20] OF LongInt;
		pic_adresses	:Array[1..20] OF Pointer;
		pal_adresses	:Array[1..20] OF Pointer;

		{Bildschirm}
		x_rez,y_rez		:LongInt;
		picmemsize		:LongInt;
		
		{Neochrome-Zoom}
		ppx,ppy			:LongInt;		{PicturePosition}
		neotool			:LongInt;		{actual tool in NeoZoom}
		
		{Parameter}
		par				:Settings;		{Parameterstruktur}
		opar			:Settings;		{alte Parameterstruktur}

		{Modul}
		epm				:Module;		{Moduldaten}
		
		{Flags, Parameter}
		anzpic			:LongInt;		{Anzahl der Bilder im  Speicher}
		palflag			:LongInt;		{Palettenflag (0..0-127 1..128-255)}
		mon				:LongInt;		{Monitortyp zum Arbeiten}
		rz_flag			:LongInt;		{RT-Zoompositionsstatus}
		actcol			:LongInt;		{aktuelle Zeichenfarbe}
		blkflag			:LongInt;		{Blockstatus (0 oder 1)}
		blkputmode		:LongInt;		{Block-Einfgemodus (->CONST)}
		blkputcol		:LongInt;		{Block-Einfge-Farbverknpfung}
		blkedmode		:LongInt;		{Block-Editiermodus}
		blkpfad			:String;		{Block-Pfad}
		blkname			:String;		{Block-Name}
		blkfflag		:LongInt;		{Block-File-Flag}
		draw_style		:LongInt;		{Zeichenmodus (Normal,OR,AND..)}
		snapgrid		:LongInt;		{Magnetraster fr Maus}
		actmodnum		:LongInt;		{zuletztgewhltes Modul}
		magxflag		:LongInt;		{1..MagiC installiert}
		key_old			:Byte;			{alter Tastaturmodus (MagiC)}
		actmc			:Integer;		{aktueller Mauscursor}
		palsaveflag		:Integer;		{Paletten-Autosave-flag}
		
		{Koordinaten}
		mx,my			:LongInt;		{Horiz.- und vert. Mausposition}
		omx,omy			:LongInt;		{alte Mauskoordinaten}
		rmx,rmy			:LongInt;		{Hilfskoordinaten}
		mkx,mky			:LongInt;		{Koordinatenanzeigeposition}
		czx,czy			:LongInt;		{Hilfskoordinaten fr C-Art-Zoom}
		czsize			:Integer;		{Gre des Zoom-Feldes (neozoom)}
		rec_x,rec_y		:LongInt;		{Hilfskoordinaten}
		px,py			:LongInt;		{Palette, RT-Zoom}
		dx,dy			:LongInt;		{Breite, Hhe von Rechtecken etc.}
		x,y				:LongInt;		{dummy-Koordinaten}
		realx,realy		:LongInt;		{Wirkliche Mauskoord.ohne grid}
		clipx,clipy		:LongInt;		{Clipping boarders}
		
		{Hilfsvariablen}
		dummy			:LongInt;		{dummy-Variable}
		blond			:LongInt;		{dummy-Variable}
		osup			:LongInt;		{alte Supervisoradr.}
		
		{Tastatur}
		keycode			:LongInt;		{Tastaturcode}
		key				:Char;			{Ascii-Code}

{$I FKT.INC\INTERN.I}


{EXPORTIERTE FUNKTIONEN}				
FUNCTION  SysMemInstall:LongInt;
FUNCTION  PicMemInstall(anz_bytes:LongInt):Integer;
PROCEDURE MemFree;
PROCEDURE MemCopy(sourceadr,destadr:Pointer;anz_long:LongInt);
PROCEDURE MemFlip(adr1,adr2:Pointer;anz_long:LongInt);
PROCEDURE ClearPic(picnum:LongInt);
PROCEDURE Blk_Cut(x1,y1,x2,y2:LongInt;quelle,ziel:Pointer);
PROCEDURE Blked_Paste(dest_x,dest_y:LongInt;blkadr,scradr:Pointer);
FUNCTION  LoadFile(pfd,nam,ext:String):Integer;
PROCEDURE SaveFile(filetyp:Integer;pfad,name:String);
FUNCTION  Load(filename:String;anzbytes:LongInt;destadr:Pointer):Boolean;
PROCEDURE WorkScreen(app_id:Integer);
PROCEDURE OnlyPalette(app_id:Integer);
PROCEDURE OnlyNeoZoom(app_id:Integer);
PROCEDURE BlkEditScreen(app_id:Integer);
PROCEDURE Call_Module(modnum:LongInt);
PROCEDURE Help(helptype:LongInt;helpscreen,origscr:Pointer);
FUNCTION  MakeNewPicture(xsize,ysize:LongInt;picname:String;datadr:Pointer):Pointer;
PROCEDURE Config_Picture(newxsize,newysize:LongInt;newname:String);
FUNCTION  GetFreePicMem:LongInt;
FUNCTION  GetSystempath(filename:String):String;
PROCEDURE SuperOn;
PROCEDURE SuperOff;

IMPLEMENTATION

{$I FKT.INC\INCLUDES.I}

{FUNKTION ZUM GENERIEREN EINES KOMPLETTEN PFADES AUF PFAD UND NAME}
FUNCTION Pfad_Name(pfad,name:String):String;
BEGIN
	Delete(pfad,Length(pfad)-2,20);
	Insert(name,pfad,Length(pfad)+1);
	Pfad_Name:=pfad;
END;



{FUNKTION ZUM ERMITTELN DES TASTATURSTATUS}
FUNCTION PressedKey:Boolean;
BEGIN
	{PressedKey:=KeyPressed;}
	{IF BconStat(2)<>0 THEN PressedKey:=TRUE ELSE PressedKey:=FALSE;}
	IF CconIs<>0 THEN PressedKey:=TRUE ELSE PressedKey:=FALSE;
END;


{$I FKT.INC\RECTS.I}
{$I FKT.INC\MEMORY.I}
{$I FKT.INC\FILELOAD.I}
{$I FKT.INC\FILESAVE.I}
{$I FKT.INC\BLK_EDIT.I}
{$I FKT.INC\PAL_EDIT.I}
{$I FKT.INC\R_T_ZOOM.I}
{$I FKT.INC\NEO_BASE.I}
{$I FKT.INC\PICTURES.I}
{$I FKT.INC\N_DRAW.I}
{$I FKT.INC\N_LINE.I}
{$I FKT.INC\N_POLY.I}
{$I FKT.INC\N_BOX.I}
{$I FKT.INC\N_RECT.I}
{$I FKT.INC\N_FILL.I}
{$I FKT.INC\N_CIRC.I}
{$I FKT.INC\TOOL_SEL.I}
{$I FKT.INC\HELPSCR.I}
{$I FKT.INC\EPM_FKTS.I}
{$I FKT.INC\GET_ADR.I}
{$I FKT.INC\N_PALETT.I}
{$I FKT.INC\MODULES.I}
{$I FKT.INC\NEO_ZOOM.I}
{$I FKT.INC\NEWZOOM.I}


{PROZEDUR BEWIRKT EVENTUELLES NEUZEICHNEN DES BLOCKES}
PROCEDURE Blk_Redraw;
BEGIN
	omx:=1;
	omy:=1;
END;


{SCHALTET AUF EINEN ANDEREN BILDSCHIRM UM (HAT EIGENTLICH HIER}
{NIX ZU SUCHEN, ABER WO SONST?)}
PROCEDURE SwitchToPic(newpicnum:Integer);
BEGIN
	IF (newpicnum<=anzpic) AND (newpicnum<>par.actscr) THEN BEGIN
		RealTimeOff;
		IF par.rt_flag=1 THEN PullPic(newpicnum,zoomscr);
		IF (par.acttool=BLKPUT) THEN PullPic(newpicnum,buffer);
		Hide_Mouse;
		PushPic(par.actscr,scr);
		PullPic(newpicnum,scr);
		IF par.acttool=TXT THEN TakeCursor(@TextCursor);
		RealTimeOn;
		{Zoom-Startwerte}
		WITH pic[newpicnum] DO C_Init(rez_x,rez_y,adr,zoomscr);
		C_Set_Magnify(par.zoommagn);
		C_Set_Grid(par.zoomgrid);
		C_Set_Orig_W(100);
		zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
		zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
		{Palettenadresse setzen}
		IF palflag=0 THEN paladr:=pic[newpicnum].paladr 
				 ELSE paladr:=Pointer(LongInt(pic[newpicnum].paladr)+256);
		Show_Mouse;
		omx:=1;omy:=1;{Blkredraw??? Ok, ziemlich krank.}
		par.actscr:=newpicnum;
	END;
END;


{PROZEDUR VERWALTET ARBEITSBILDSCHIRM}
PROCEDURE WorkScreen(app_id:Integer);
VAR		c		:LongInt;
BEGIN
	{aktuelles Bild in Arbeitsbildschirm kopieren}
{	Writeln('1');}
	PullPic(par.actscr,scr);
{	Writeln('2');}
	IF (par.acttool=BLKPUT) THEN 
		PullPic(par.actscr,buffer);
	{Arbeitsauflsung}							 			
{	Writeln('3');}
	GoToPicRez(mon,scr);
{	Writeln('4');}
	{Maus initialisieren}
{	Writeln('5');}
	IF par.acttool=TXT THEN TakeCursor(@TextCursor) ELSE TakeCursor(mousecurs[actmc]);
{	Writeln('6');}
	SetNewMouse(scr);
{	Writeln('7');}
	SetActPoint(7,7);
	SetMouseRange(320,240);
	SetMouseGrid(snapgrid,snapgrid);
	SetMouseSpeed(par.mousespeed);
	Hide_Mouse;
	{Wenn Realtimelupe aktiv -> Lupenhintergrund sichern/Voreinstellungen}
	IF (par.rt_flag=1) THEN BEGIN
		Hide_Mouse;
		IF MousePosX>159 THEN rz_flag:=1 ELSE rz_flag:=2;
		MemCFast(scr,zoomscr,3200);
		RealTimeOn;
	END;
	WITH par DO IF (acttool<>ZOOM) AND (acttool<>BLKCUT) AND (acttool<>BLKPUT) 
		THEN Show_Mouse ELSE Hide_Mouse;
	{Wenn kein Block vorhanden -> Ausschneidemodus}
	IF (blkflag<>1) AND (par.acttool=BLKPUT) THEN par.acttool:=BLKCUT;
	{Wenn Block-Einfgen aktiv ist -> Block erst einmal zeichnen}
	Blk_Redraw;
	{Farbparameter fr Blockoperationen setzen}
	Blk_Col(actcol);
	{Zoom-Startwerte}
	WITH pic[par.actscr] DO C_Init(rez_x,rez_y,adr,zoomscr);
	C_Set_Magnify(par.zoommagn);
	C_Set_Grid(par.zoomgrid);
	C_Set_Orig_W(100);
	zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
	zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
	{Palettenadresse setzen}
	IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
				 ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
	{Tastaturpuffer lschen}
	WHILE PressedKey DO BEGIN
		keycode:=Crawcin;
		key:=Char(keycode);
	END;
	key:=#255;keycode:=0;
	REPEAT Delay(20) UNTIL mb<>2;
	{Hauptschleife}
	REPEAT

		{Tastendrcke abfangen...}
		IF key<>#27 THEN BEGIN key:=#255;blond:=1;END ELSE blond:=0;
		
		keycode:=0;
		WHILE PressedKey DO BEGIN
			keycode:=Crawcin;
			key:=Char(keycode);
			IF (par.acttool=BLKPUT) AND (blkflag=1) THEN
				Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
		END;
	
		dummy:=KbShift(-1);

		{Alternatetaste prfen}
		IF (dummy=8) THEN WITH pic[par.actscr] DO BEGIN
			IF (par.acttool=BLKPUT) AND (blkflag=1) THEN
				Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
			RealTimeOff;
			Hide_Mouse;
			PushPic(par.actscr,scr);
			os:=Super(NIL);
			IF rez_x<=830 THEN BEGIN
			 	VSync;
			  	SetScrAdr(Pointer(LongInt(adr)+(2*rez_x*ypos)+(2*xpos) ));
			  	SetVRes(rez_x-320);
			END;
			mx:=MousePosX;my:=MousePosY;
			SetMousePos(xpos,ypos);
			SetMouseRange(rez_x-319,rez_y-239);
			REPEAT
				xpos:=2*(MousePosX div 2);ypos:=MousePosY;
				VSync;
				IF rez_x<=830 THEN SetScrAdr(Pointer(LongInt(adr)+(2*rez_x*ypos)+(2*xpos) ))
				ELSE PullPic(par.actscr,scr);
			UNTIL KbShift(-1)<>8;
			IF rez_x<=830 THEN BEGIN
				PullPic(par.actscr,scr);
				VSync;
				SetVRes(0);
				SetScrAdr(scr);
			END;
			IF par.acttool=BLKPUT THEN BEGIN
				PullPic(par.actscr,buffer);
			END;
			Super(Pointer(os));
			SetMouseRange(320,240);
			SetMousePos(mx,my);
			RealTimeOn;
			Show_Mouse;
		END;

		{Shifttasten prfen}	
		IF (dummy AND 3) <> 0 THEN BEGIN
			{Wenn linke Shifttaste gedrckt wird -> Koordinatenanzeige}
			IF (dummy AND 2) <> 0 THEN BEGIN
				{Wenn Shift und Control gedrckt -> Anzeigeposition}
				IF (dummy AND 4) <> 0 THEN BEGIN
					mkx:=mx-6;mky:=my-5;
					IF mkx<8 THEN mkx:=8;
					IF mky<8 THEN mky:=8;
					IF mkx>X_REZ-15 THEN mkx:=X_REZ-15;
					IF mky>Y_REZ-15 THEN mky:=Y_REZ-15;
				END; 
				{omx:=MousePosX;
				omy:=MousePosY;}
				{Mauskoordinaten anzeigen}
				Hide_Mouse;
				Num_Output(mkx,mky,mx+pic[par.actscr].xpos,3,1,scr);
				Num_Output(mkx,mky+7,my+pic[par.actscr].ypos,3,2,scr);
				IF (par.acttool<>BLKPUT) AND 
				   (par.acttool<>BLKCUT) AND 
				   (par.acttool<>ZOOM) AND (key<>#27) THEN BEGIN
				   	IF snapgrid=1 THEN Show_Mouse;
					{warten bis sich die Maus bewegt und Tastendrcke abfangen}
					REPEAT 
						{WHILE PressedKey DO Crawcin;}
					UNTIL PressedKey OR (snapgrid>1) OR (mb<>0) OR (MousePosX<>mx) OR (MousePosY<>my) OR (KbShift(-1)<>dummy);
				END; 
				VSync;
				{Mauskoordinaten vom Bildschirm lschen}
				Hide_Mouse;
				Num_Output(mkx,mky,mx+pic[par.actscr].xpos,3,1,scr);
				Num_Output(mkx,mky+7,my+pic[par.actscr].ypos,3,2,scr);
			END ELSE IF (dummy AND 1) <> 0 THEN BEGIN
			{Wenn rechte Shifttaste gedrckt -> Toolselector}
				SetMouseGrid(1,1);
				IF (par.acttool=BLKPUT) AND (blkflag=1) THEN
					Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
				IF par.rt_flag=1 THEN RealTimeOff;
				Hide_Mouse;
				Tool_Select(mx,my,scr);
				SetMouseGrid(snapgrid,snapgrid);
				IF par.rt_flag=1 THEN RealTimeOn;
			END;
		END;
				
		{Wenn am unteren Bildrand rechte Maustaste -> ' '-Simulierung -> Palette}
		IF (MousePosY>(y_rez-5)) AND (mb=2) AND (par.mousetype<>1) AND (par.acttool<>BLKCUT) THEN BEGIN
			WHILE mb=2 DO BEGIN END;
			key:=' ';keycode:=1;
		END;
		
		{Reaktionen auf Tastendrcke}
		IF (keycode<>0) AND (mb=0) THEN BEGIN
			Hide_Mouse;
			IF Upcase(key)='T' THEN BEGIN
				TakeCursor(@TextCursor); 
			END ELSE BEGIN
				TakeCursor(mousecurs[actmc]);
			END;
			dummy:=par.actscr;
			{...und auswerten}
			WITH par DO CASE Upcase(key) OF
			{Werkzeugwahl}
			  {Zeichentools}
			  'D': acttool:=DRAW;
			  'L': acttool:=LINE;
			  'R': acttool:=RECT;
			  'B': acttool:=BOX;
			  'C': acttool:=CIRC;
			  'F': acttool:=FILL;
			  'P': acttool:=POLY;
			  'T': acttool:=TXT;
			  {Colorgrabbing}
			  'G': BEGIN
			  		VSync;Hide_Mouse;
			  		actcol:=GetPixel(MousePosX,MousePosY,X_REZ,scr);
			  		Show_Mouse;
			  		IF PalSearch(actcol,paladr)>=0 THEN par.actpcn:=PalSearch(actcol,paladr);
			  	END;
			  {Zoommodus}
			  'Z': BEGIN
			  		IF par.zoomtype=CRACK THEN BEGIN
			  			IF rt_flag=1 THEN RealTimeOff;
			  			acttool:=ZOOM;
			  		END;
			  		IF par.zoomtype=NEOCHROME THEN BEGIN
			  			IF rt_flag=1 THEN RealTimeOff;
			  			WITH pic[par.actscr] DO BEGIN
			  				ppx:=xpos;ppy:=ypos;
			  			END;
			  			NeoChromeZoom;
			  			WITH pic[par.actscr] DO BEGIN
			  				xpos:=ppx;ypos:=ppy;
			  				IF xpos+320>rez_x THEN xpos:=rez_x-320;
			  				IF ypos+240>rez_y THEN ypos:=rez_y-240;
			  			END;
			  			PullPic(par.actscr,scr);
						{Screenadr. setzen (Supervisormode)}
			  			blond:=Super(NIL);SetScrAdr(scr);Super(Pointer(blond));
			  			IF rt_flag=1 THEN BEGIN
			  				MemCFast(scr,zoomscr,3200);
			  				RealTimeOn;
			  			END;
			  			TakeCursor(mousecurs[actmc]);
			  			SetMouseScreenAdr(scr);
			  			Show_Mouse;
			  			blond:=1;key:=#0;keycode:=0;
			  		END;
			  	END;
			  {Realtime-Zoom}
			  'W': BEGIN
			  		IF par.rt_flag=0 THEN BEGIN
			  			Hide_Mouse;
			  			MemCFast(scr,zoomscr,3200);
			  			Show_Mouse;
						px:=1;py:=-1;
			  			RealTimeOn;
			  			par.rt_flag:=1;
			  		END ELSE BEGIN
						RealTimeOff;
						par.rt_flag:=0;
			  		END;
			  		IF blond=0 THEN key:=#27;
			  		rmx:=-1;rmy:=-1;
			  	   END;
			   {FastCut}
			   #27: BEGIN
			   			{RealTimeZoom ggf.zeichnen}
			   		 	px:=1;py:=-1;
			   		 	py:=1;
			   		END;
			   {Paletteneditor}
			   'S': BEGIN
			  	Hide_Mouse;
			  	IF par.rt_flag=1 THEN RealTimeOff;
				Hide_Mouse;
			  	{MemCopy(scr,scradr[par.actscr],38400);}
			  	Pal_Edit;
		  		MemCFast(scr,zoomscr,3200);
				IF par.acttool=TXT THEN TakeCursor(@TextCursor) ELSE TakeCursor(mousecurs[actmc]);
			  	IF par.rt_flag=1 THEN RealTimeOn;
			  	Show_Mouse;
			  	Blk_Redraw;
			  END; 
			{vorhergehender Farbwert}
			  ',': BEGIN
					Dec(actpcn);
					IF actpcn<0 THEN actpcn:=127;
					actcol:=SetColor(par.actpcn,paladr);
				  	IF blond=0 THEN key:=#27;
				  END;
			{nchster Farbwert der Palette}
			  '.': BEGIN
				 	Inc(actpcn);
				 	IF actpcn>127 THEN actpcn:=0;
				 	actcol:=SetColor(par.actpcn,paladr);	 	
				  	IF blond=0 THEN key:=#27;
				  END;
			{aktiven Farbwert der Palette wiederherstellen}
			  '-': BEGIN
			    	actcol:=SetColor(par.actpcn,paladr);
				   	IF blond=0 THEN key:=#27;
				   END;
			{128-Farbpaletten umschalten -> gesamt: 256-Farbpalette}
			  '*': BEGIN
					IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
				 				 ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
				   	IF blond=0 THEN key:=#27;
			    END;
			{Block ausschneiden - direkt aktivieren}
			  'X': IF blond<>0 THEN BEGIN
			  		par.acttool:=BLKCUT;
			  		Hide_Mouse;
			  	END;
			{Block einfgen - direkt aktivieren}
			  'V': IF blkflag=1 THEN BEGIN
			  		par.acttool:=BLKPUT;
			  		RealTimeOff;
			  		Hide_Mouse;
			  		MemCFast(scr,buffer,3200);
				  	Blk_Redraw;
			  	END;
			{Palette einblenden}
			  ' ': BEGIN
			  		IF rt_flag=1 THEN RealTimeOff;
					TakeCursor(mousecurs[actmc]);
					ChooseNewColor;
					IF par.acttool=TXT THEN TakeCursor(@TextCursor) ELSE TakeCursor(mousecurs[actmc]);
					IF rt_flag=1 THEN RealTimeOn;			  	  	
				   	IF blond=0 THEN key:=#27;
			  	END;
			{Snapgrid}
			  ')': BEGIN
			  		IF snapgrid<319 THEN Inc(snapgrid);
				   	IF blond=0 THEN key:=#27;
				END;
			  '(': BEGIN
			  		IF snapgrid>1 THEN Dec(snapgrid);
				   	IF blond=0 THEN key:=#27;
				END;
			  '#': BEGIN
   				   	dummy:=FCreate('c:\epscreen.xga',0);
				   	Fwrite(dummy,153600,PhysBase);
				   	Fclose(dummy);
			  END;
			{Center ccreen around the mouseposition}
			  'M': WITH pic[par.actscr] DO BEGIN
				IF (par.acttool=BLKPUT) AND (blkflag=1) THEN
					Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
				RealTimeOff;
				Hide_Mouse;
				PushPic(par.actscr,scr);
				xpos:=xpos+MousePosX-159;
				ypos:=ypos+MousePosY-159;
				IF xpos<0 THEN xpos:=0;
				IF ypos<0 THEN ypos:=0;
				IF xpos+320>rez_x THEN xpos:=rez_x-320;
				IF ypos+240>rez_y THEN ypos:=rez_y-240;
				PullPic(par.actscr,scr);
				IF par.acttool=BLKPUT THEN PullPic(par.actscr,buffer);
				RealTimeOn;
				Show_Mouse;
			  END;				
			{RGB-Modifikation mit der Zehnertastatur}
			{$I FKT.INC\RGB_MODI.I}
			END;
			IF par.acttool=TXT THEN TakeCursor(@TextCursor);
			WITH par DO BEGIN
			{Undo}
				IF keycode=6356992 THEN  BEGIN
					IF rt_flag=1 THEN BEGIN
						RealTimeOff;
						PullPic(actscr,zoomscr);
					END;
					Hide_Mouse;
					FlipPic(actscr,scr);
					IF (par.acttool=BLKPUT) THEN BEGIN
						MemCFast(scr,buffer,3200);
					  	Blk_Redraw;
					END;
					Show_Mouse;
					IF rt_flag=1 THEN RealTimeOn;
					IF blond=0 THEN key:=#27;
				END;
			{Clr-Home -> Hi-res Screen}
				IF keycode=4653056 THEN WITH pic[par.actscr] DO BEGIN
					IF (mon<>2) AND (rez_x>=360) AND (rez_x<=640) AND (rez_y<=480) THEN BEGIN
			  			{Supervisormodus ein}
			  			blond:=Super(NIL);
			  			{In Hi-res schalten und Bildspeicher direkt anzeigen}
						VSync;
						SetScrAdr(adr);
						Set_Hi_RGB(rez_x,rez_y);
						{Aus Maustaste warten}
						REPEAT Delay(50) UNTIL (mb<>0) OR PressedKey;
						REPEAT Delay(50) UNTIL mb=0;
						{Auflsung zurcksetzen}
						VSync;
						Set_FalconRes(@LoTc_RGB_SCP);
						Set_Back_Hi_RGB;
						SetScrAdr(scr);
						{Supervisormodus aus}
			  			Super(Pointer(blond));
						{Tastaturbuffer leeren}
						WHILE PressedKey DO Crawcin;
					END;
				END;
			{'+' -> Increase zoommagnify}
			  	IF keycode=5111851 THEN BEGIN
			 		CASE par.zoommagn OF
			 			3: keycode:=3932160; {->5:1}
			 			5: keycode:=3997696; {->7:1}
			 			7: keycode:=4063232; {->9:1}
			 			9: keycode:=4063232; {->9:1}
			 		END;
			  	END;
			{'-' -> Decrease zoommagnify}
			  	IF keycode=4849709 THEN BEGIN
			 		CASE par.zoommagn OF
			 			3: keycode:=3866624; {->3:1}
			 			5: keycode:=3866624; {->3:1}
			 			7: keycode:=3932160; {->5:1}
			 			9: keycode:=3997696; {->7:1}
			 		END;
			  	END;
			{F1 => 3:1 Zoom-Auflsung}
				IF keycode=3866624 THEN BEGIN
					par.zoommagn:=3;C_Set_Magnify(3);
					zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
					zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
					{Wenn Realtime-Zoom aktiv -> aktualisieren}
					rmx:=-1;rmy:=-1;
					IF (par.acttool<>BLKPUT) THEN RealTimeZoom(mx,my);
					{Wenn Realtime-Zoom aus -> Normalzoom ein}
					IF (rt_flag=0) AND (par.zoomtype=CRACK) THEN acttool:=ZOOM;
					IF blond=0 THEN key:=#27;
				END;
			{F2 => 5:1 Zoom-Auflsung}
				IF keycode=3932160 THEN BEGIN
					par.zoommagn:=5;C_Set_Magnify(5);
					zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
					zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
					{Wenn Realtime-Zoom aktiv -> aktualisieren}
					rmx:=-1;rmy:=-1;
					IF par.acttool<>BLKPUT THEN RealTimeZoom(mx,my);
					{Wenn Realtime-Zoom aus -> Normalzoom ein}
					IF (rt_flag=0) AND (par.zoomtype=CRACK) THEN acttool:=ZOOM;
					IF blond=0 THEN key:=#27;
				END;
			{F3 => 7:1 Zoom-Auflsung}
				IF keycode=3997696 THEN BEGIN
					par.zoommagn:=7;C_Set_Magnify(7);
					zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
					zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
					{Wenn Realtime-Zoom aktiv -> aktualisieren}
					rmx:=-1;rmy:=-1;
					IF par.acttool<>BLKPUT THEN RealTimeZoom(mx,my);
					{Wenn Realtime-Zoom aus -> Normalzoom ein}
					IF (rt_flag=0) AND (par.zoomtype=CRACK) THEN acttool:=ZOOM;
					IF blond=0 THEN key:=#27;
				END;
			{F4 => 9:1 Zoom-Auflsung}
				IF keycode=4063232 THEN BEGIN
					par.zoommagn:=9;C_Set_Magnify(9);
					zoom_width:=C_Get_ZoomWCnt(par.zoommagn);
					zoom_height:=C_Get_ZoomHCnt(par.zoommagn);
					{Wenn Realtime-Zoom aktiv -> aktualisieren}
					rmx:=-1;rmy:=-1;
					IF par.acttool<>BLKPUT THEN RealTimeZoom(mx,my);
					{Wenn Realtime-Zoom aus -> Normalzoom ein}
					IF (rt_flag=0) AND (par.zoomtype=CRACK) THEN acttool:=ZOOM;
					IF blond=0 THEN key:=#27;
				END;
			{^D => Clearscreen}
				IF keycode=2097156 THEN BEGIN
					IF rt_flag=1 THEN RealtimeOff;
					Hide_Mouse;
					PushPic(par.actscr,scr);
					MemDFast(scr,3200);
					MemDFast(zoomscr,3200);
					IF rt_flag=1 THEN RealTimeOn;
					IF par.acttool=BLKPUT THEN MemDFast(buffer,3200);
				END;
			{Help => Hilfescreen}
				IF keycode=6422528 THEN BEGIN
					IF blond=0 THEN key:=#27;
					IF par.acttool<>BLKPUT THEN Help(2,buffer,scr)
					ELSE BEGIN
						IF par.rt_flag=1 THEN RealTimeOff;
						Hide_Mouse;
						Help(2,zoomscr,scr);
						IF par.rt_flag=1 THEN BEGIN
							MemCFast(scr,zoomscr,3200);
							RealTimeOn;
							Hide_Mouse;
						END;
					END;
				END;
			END;
			{Cursortasten -> Maus bewegen}
			{oben..}
			IF keycode=4718592 THEN BEGIN
				IF MousePosY>=snapgrid THEN SetMousePos(MousePosX,MousePosY-snapgrid);
				IF blond=0 THEN key:=#27 ELSE Show_Mouse;
			END;
			{unten...}
			IF keycode=5242880 THEN BEGIN
				IF MousePosY<(y_rez-snapgrid) THEN SetMousePos(MousePosX,MousePosY+snapgrid);
				IF blond=0 THEN key:=#27 ELSE Show_Mouse;
			END;
			{rechts...}
			IF keycode=5046272 THEN BEGIN
				IF MousePosX<(x_rez-snapgrid) THEN SetMousePos(MousePosX+snapgrid,MousePosY);
				IF blond=0 THEN key:=#27 ELSE Show_Mouse;
			END;
			{links...}
			IF keycode=4915200 THEN BEGIN
				IF MousePosX>=snapgrid THEN SetMousePos(MousePosX-snapgrid,MousePosY);
				IF blond=0 THEN key:=#27 ELSE Show_Mouse;
			END;
			{Nummerntasten 1..0 bzw. Cntrl+Nummerntasten -> Bild whlen}
			IF keycode=131121 THEN SwitchToPic(1);
			IF keycode=196658 THEN SwitchToPic(2);
			IF keycode=262195 THEN SwitchToPic(3);
			IF keycode=327732 THEN SwitchToPic(4);
			IF keycode=393269 THEN SwitchToPic(5);
			IF keycode=458806 THEN SwitchToPic(6);
			IF keycode=524343 THEN SwitchToPic(7);
			IF keycode=589880 THEN SwitchToPic(8);
			IF keycode=655417 THEN SwitchToPic(9);
			IF keycode=720944 THEN SwitchToPic(10);
			IF keycode=131089 THEN SwitchToPic(11);
			IF keycode=196608 THEN SwitchToPic(12);
			IF keycode=262163 THEN SwitchToPic(13);
			IF keycode=327700 THEN SwitchToPic(14);
			IF keycode=393237 THEN SwitchToPic(15);
			IF keycode=458782 THEN SwitchToPic(16);
			IF keycode=524311 THEN SwitchToPic(17);
			IF keycode=589848 THEN SwitchToPic(18);
			IF keycode=655385 THEN SwitchToPic(19);
			IF keycode=720912 THEN SwitchToPic(10);

		
   		    IF PalSearch(actcol,paladr)>=0 THEN par.actpcn:=PalSearch(actcol,paladr);
			SetMouseGrid(snapgrid,snapgrid);
			Blk_Col(actcol);
			IF par.acttool=BLKPUT THEN Blk_Redraw;
			IF par.acttool=TXT THEN TakeCursor(@TextCursor);
		END;

		{Wenn Block-Cut-Modus oder EscapeCut-Modus -> Fadenkreuz}
		IF mb=0 THEN BEGIN
		
			{Wenn Crackart-Zoommodus aktiv -> Bereichswahlrechteck}
			IF (par.acttool=ZOOM) AND (key<>#27) THEN BEGIN
				Hide_Mouse;
				omx:=MousePosX;
				omy:=MousePosY;
				IF omx>x_rez-zoom_width-1 THEN omx:=x_rez-zoom_width-1;
				IF omy>y_rez-zoom_height-1 THEN omy:=y_rez-zoom_height-1;
				RubRect(omx,omy,omx+zoom_width,omy+zoom_height,scr);
				VSync;
				RubRect(omx,omy,omx+zoom_width,omy+zoom_height,scr);
			END;
		
			{IF (snapgrid>1) OR (par.acttool=BLKCUT) OR (key=#27) OR (par.acttool=BLKPUT) THEN Hide_Mouse
			ELSE IF (snapgrid=1) AND (par.acttool<>ZOOM) THEN Show_Mouse;}

			mx:=MousePosX;my:=MousePosY;
		
			IF (key=#27) OR (par.acttool=BLKCUT) OR (par.acttool=BLKPUT) OR
			((snapgrid>1) AND (par.acttool<>ZOOM) AND (par.acttool<>BLKPUT)) THEN BEGIN
				Hide_Mouse;
				IF (par.acttool<>BLKPUT) OR (key=#27)  THEN BEGIN
					Faden(mx,my,scr);
					realx:=RealMXPos;realy:=RealMYPos;
					IF snapgrid>1 THEN SetPixel(realx,realy,X_REZ,-1,scr);
					IF MousePosY>7 THEN VSync ELSE Delay(20);
					Faden(mx,my,scr);
					IF snapgrid>1 THEN SetPixel(realx,realy,X_REZ,-1,scr);
				END;
			END ELSE BEGIN
			{eventuell Mauscursor defaultmig einschalten}
				IF par.acttool<>ZOOM THEN Show_Mouse ELSE Hide_Mouse;
			END;
		END;
		
		
		{Verwaltung des Realtime-Zooms}
		RealTimeZoom(mx,my);
		
		{Block verschieben, wenn Block-Einfgen selektiert ist}
		IF key<>#27 THEN BEGIN
			{$I FKT.INC\BLK_DMOV.I}
		END;
		
		{Wenn TXT -> Bildschirmbegrenzung}
		IF par.acttool=TXT THEN BEGIN		
			IF MousePosX<7 THEN SetMousePos(7,MousePosY);
			IF MousePosY<7 THEN SetMousePos(MousePosX,7);
			IF MousePosX>(X_REZ-10) THEN SetMousePos(X_REZ-10,MousePosY);
			IF MousePosY>(Y_REZ-10) THEN SetMousePos(MousePosX,Y_REZ-10);
		END;
		
		{Wenn Maus im Block-Einfge-Modus gedrckt wird}
		IF (mb=1) AND (par.acttool=BLKPUT) AND (key<>#27) THEN BEGIN
			{Arbeitsbildschirm in aktuelles Bild kopieren}
			Hide_Mouse;
 			Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
 			PushPic(par.actscr,buffer);
 			{MemCopy(scr,buffer,38400);}
			{Block solange einfgen bis Maustaste losgelassen wird}
			REPEAT
				mx:=MousePosX;
				my:=MousePosY;
				IF mx>(X_REZ-Blk_GetW(blkbuf)) THEN mx:=X_REZ-Blk_GetW(blkbuf);
				IF my>(Y_REZ-Blk_GetH(blkbuf)) THEN my:=Y_REZ-Blk_GetH(blkbuf);
					SetMousePos(mx,my);
				{Block einfgen}
				Blk_DPut(mx,my,blkbuf,scr);			
				Blk_DPut(mx,my,blkbuf,buffer);			
				IF par.rt_flag=1 THEN Blk_DPut(mx,my,blkbuf,zoomscr);			
			UNTIL mb=0;
			Show_Mouse;
		END;
		
		{Wenn EscCut-Modus und Maustaste oder Maustaste im CUT-Modus}
		IF (mb=1) AND ((par.acttool=BLKCUT) OR (key=#27)) THEN BEGIN
			Hide_Mouse;
			IF (par.acttool=BLKPUT) THEN Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);
			{Arbeitsbildschirm in aktuelles Bild kopieren  (fr UNDO)}
 			IF par.rt_flag=0 THEN PushPic(par.actscr,scr)
 		 	ELSE PushPic(par.actscr,zoomscr);
			mx:=MousePosX;
			my:=MousePosY;
			{IF ((mb=1) AND (key=#27)) OR (key<>#27) THEN }BEGIN
				{$I FKT.INC\BLK_CUT.I}
				key:=#255;
			END;
			IF ((par.acttool=BLKPUT) OR (par.acttool=ZOOM)) AND (par.rt_flag=1) THEN RealtimeOff;
			REPEAT UNTIL mb=0;
			IF par.acttool=TXT THEN TakeCursor(@TextCursor);
		END ELSE
		
		{Wenn linke Maustaste gedrckt -> Editieren}
		IF (mb=1) AND (key<>#27) AND (par.acttool<>BLKCUT) AND (par.acttool<>BLKPUT) THEN BEGIN
		  {Arbeitsbildschirm in aktuelles Bild kopieren  (fr UNDO)}
		  Hide_Mouse;
 		  IF par.rt_flag=0 THEN PushPic(par.actscr,scr)
 		  	ELSE PushPic(par.actscr,zoomscr);
		  IF par.acttool<>ZOOM THEN Show_Mouse;
		  mx:=MousePosX;
		  my:=MousePosY;
		  Blk_Col(actcol);
		  CASE par.acttool OF
		  	DRAW: DrawFkt(0);
		  	LINE: LineFkt(0);
		  	POLY: PolyFkt(0);
		  	RECT: RectFkt(0);
		  	BOX:  BoxFkt(0);
		  	FILL: FillFkt(0);
		  	CIRC: CircFkt(0);
			ZOOM: WITH pic[par.actscr] DO DegasZoom(mx+xpos,my+ypos);
			{I FKT.INC\C_ZOOM.I}
			{$I FKT.INC\N_TEXT.I}
			END;
			Blk_Col(actcol);
			IF par.rt_flag=1 THEN BEGIN px:=1;py:=-1;END;
		END;
		dummy:=0;

		{Wenn Realtime-Zoom und Maustyp 2 aktiv} 
		{-> rechte Maustaste abfangen (Farbwahl)}
		IF (par.rt_flag=1) AND (par.mousetype=1) AND (mb=2) THEN BEGIN
			dummy:=1;
			actcol:=GetPixel(MousePosX,MousePosY,320,scr);
			Blk_Col(actcol);
		END;
		
		{Wenn rechte Maustaste bei EscapeCut-Modus}
		IF (key=#27) AND (mb=2) THEN BEGIN
			key:=#255;
			REPEAT Delay(30) UNTIL mb=0;
			WITH par DO IF (rt_flag=1) AND ((acttool=ZOOM) OR (acttool=BLKCUT) OR (acttool=BLKPUT)) THEN RealTimeOff;
		END;
		
	{verlassen bei rechter Maustaste oder Return}
	UNTIL ((mb=2) AND (dummy=0) AND (key<>#27) AND (MousePosY<(y_rez-4))) OR (key=#13);
	{Wenn Realtimelupe aktiv -> abschalten}
	IF par.rt_flag=1 THEN RealTimeOff;
	{Arbeitsbildschirm in aktuelles Bild kopieren  (fr UNDO)}
	Hide_Mouse;
	{Wenn Block-Einfgen aktiv -> Orginalbild herstellen}
	IF (par.acttool=BLKPUT) THEN PushPic(par.actscr,buffer)
		{Blk_Restore_Bg(mx,my,blkbuf,scr,buffer);}
	ELSE PushPic(par.actscr,scr);
	{Tastaturpuffer lschen}
	WHILE PressedKey DO BEGIN
		keycode:=Crawcin;
		key:=Char(keycode);
	END;
	key:=#255;keycode:=0;
	{Show_Mouse;}
	{Gem-Maus wieder initialisieren}
	WHILE mb<>0 DO Delay(20);
	MouseReset;
	SetOldMouse;
	{Men-Auflsung}
	GoToPrgRez;
END;


{PROZEDUR VERWALTET NUR PALETTENSCREEN}
PROCEDURE OnlyPalette(app_id:Integer);
VAR		key		:Char;
BEGIN
	{scradr[par.actscr] wird fr den Bildschirm mibraucht}
	{(fr einen sauberen Wechsel der Auflsungen}
	{MemClear(scr,38400);
	FlipPic(par.actscr,scr);}
	{Maus initialisieren}
	SetNewMouse(zoomscr);
	TakeCursor(mousecurs[actmc]);
	SetActPoint(7,7);
	SetMouseGrid(1,1);
	SetMouseSpeed(par.mousespeed);
	REPEAT Delay(30) UNTIL mb=0;
	{Arbeitsauflsung}							 			
	{GoToPicRez(mon,pic[par.actscr].adr);}
	GoToPicRez(mon,zoomscr);
	{Paletteneditor aufrufen}
	Pal_Edit;
	{Maus deinitialisieren}
	Hide_Mouse;
	SetOldMouse;
	{Men-Auflsung}
	GoToPrgRez;
	{Bildspeicher wiederherstellen}
	{PushPic(par.actscr,scr);}
	MouseReset;
END;


{PROZEDUR VERWALTET NUR NEOCHROMEZOOM}
PROCEDURE OnlyNeoZoom(app_id:Integer);
VAR		key		:Char;
BEGIN
	{Palettenadresse setzen}
	IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
				 ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
	{scradr[par.actscr] wird fr den Bildschirm mibraucht}
	{(fr einen sauberen Wechsel der Auflsungen}
	MemClear(buffer,38400);
	{PullPic(par.actscr,scr);}
	{Maus initialisieren}
	SetNewMouse(zoomscr);
	TakeCursor(mousecurs[actmc]);
	SetActPoint(7,7);SetMousePos(160,120);
	SetMouseGrid(1,1);
	SetMouseSpeed(par.mousespeed);
	{Arbeitsauflsung}							 			
	GoToPicRez(mon,buffer);
	{Paletteneditor aufrufen}
	NeoChromeZoom;
	REPEAT Delay(20) UNTIL mb=0;
	{Maus deinitialisieren}
	Hide_Mouse;
	SetOldMouse;
	{Men-Auflsung}
	GoToPrgRez;
	{Bildspeicher wiederherstellen}
	{PushPic(par.actscr,scr);}
	MouseReset;
END;


{PROZEDUR VERWALTET BLOCKEDITOR}
PROCEDURE BlkEditScreen(app_id:Integer);
VAR		key		:Char;
		os		:LongInt;
BEGIN
	{Palettenadresse setzen}
	IF palflag=0 THEN paladr:=pic[par.actscr].paladr 
				 ELSE paladr:=Pointer(LongInt(pic[par.actscr].paladr)+256);
	{scradr[par.actscr] wird fr den Bildschirm mibraucht}
	{(fr einen sauberen Wechsel der Auflsungen}
	MemClear(scr,38400);
	
	{Maus initialisieren}
	SetNewMouse(scr);
	TakeCursor(mousecurs[actmc]);
	SetActPoint(7,7);
	SetMouseGrid(1,1);
	SetMouseSpeed(par.mousespeed);
	Show_Mouse;
	
	REPEAT Delay(30) UNTIL mb=0;

	{Arbeitsauflsung}
	GoToPicRez(mon,scr);
	{Blockeditor aufrufen}
	Blk_Edit(blkbuf);
	{Tastaturpuffer lschen}
	WHILE PressedKey DO BEGIN
		keycode:=Crawcin;
		key:=Char(keycode);
	END;
	key:=#255;keycode:=0;

	{Maus deinitialisieren}
	Hide_Mouse;
	SetOldMouse;
	
	{Men-Auflsung}
	GoToPrgRez;
	
	MouseReset;
END;


{INITIALISIERUNG}
BEGIN
	VSync;
	WITH par DO BEGIN
		mx:=160;
		my:=120;
		actscr:=1;
		actpcn:=0;
		acttool:=DRAW;
		mousetype:=0;
		mousespeed:=2;
		zoomtype:=CRACK;
		zoommagn:=5;
		zoomgrid:=1;
		rt_flag:=0;
	END;
	anzpic:=0;
	x_rez:=320;
	y_rez:=240;
	palflag:=0;
	blkflag:=0;
	blkputmode:=N_DECK;
	blkputcol:=PUT_ALL;
	blkedmode:=NEGATIV;
	draw_style:=D_NORM;
	actcol:=0;
	neotool:=0;
	blk_col(actcol);
	blkpfad:='';
	blkname:='BLOCK';
	blkfflag:=0;
	snapgrid:=1;
	rz_flag:=1;
	actmodnum:=-1;
	rec_x:=0;
	rec_y:=0;
	mx:=160;my:=120;
	rmx:=100;rmy:=100;
	mkx:=5;mky:=225;
	ppx:=0;ppy:=0;
	opar:=par;
	clipx:=320;
	clipy:=240;
	zoom_origw:=100;
	palsaveflag:=PALSAVE_NEVER;
	actmc:=1;
	dummy:=Super(NIL);
	magxflag:=MagiCCheck;
	Super(Pointer(dummy));
	SetMagiCFlag(magxflag);
END.