FUNCTION Load(filename:String;anzbytes:LongInt;destadr:Pointer):Boolean;
VAR	fh	:LongInt;
	loaded	:LongInt;
BEGIN
	fh:=FOpen(filename,FO_READ);
	loaded:=FRead(fh,anzbytes,destadr);
	FClose(fh);
	IF loaded=anzbytes THEN Load:=TRUE ELSE Load:=FALSE;
END;


FUNCTION GetSystempath(filename:String):String;
VAR	drive: Integer;	
	path: String;
BEGIN
	drive:=Dgetdrv;
	Dgetpath(path,0);
	GetSystempath:=Chr(Ord('A')+drive)+':'+path+'\'+filename;
END;


{$L PRG.INC\TGA_LOAD.O}
PROCEDURE AnalyseTGA(tgadata,destscr:Pointer);EXTERNAL;
{$L PRG.INC\TRU_LOAD.O}
PROCEDURE AnalyseTRU(trudata,destscr:Pointer);EXTERNAL;
FUNCTION  AnalyseTRUblk(trudata,destscr:Pointer):LongInt;EXTERNAL;
{$L PRG.INC\PI9_LOAD.O}
PROCEDURE MakeTCPalette(quellbild,zielpal:Pointer);EXTERNAL;
PROCEDURE DrawTCPi9(quellbild,zielbild,zielpal:Pointer);EXTERNAL;
{$L PRG.INC\PAL_LOAD.O}
PROCEDURE AnalysePAL(paldata,eppadr:Pointer);EXTERNAL;
PROCEDURE AnalyseIndyPAL(paldata,eppadr:Pointer);EXTERNAL;


FUNCTION FileExist(filename:String):Boolean;
BEGIN
	IF FsFirst(filename,FA_ATTRIB)=0 THEN FileExist:=TRUE ELSE FileExist:=FALSE;
END;


FUNCTION GetFileLength(filename:String):LongInt;
TYPE IceHead	=RECORD
		magic	:LongInt;
		pck_size:LongInt;
		unp_size:LongInt;
	END;
VAR	icehead_data:IceHead;
	filesize	:LongInt;
	filedata_ptr:DTAptr;
	fh			:Integer;
BEGIN
	filesize:=0;
	IF Fsfirst( filename, FA_ATTRIB ) = 0 THEN BEGIN
		filedata_ptr:=Fgetdta;
		filesize:=filedata_ptr^.d_length;
	END;
	fh:=FOpen(filename,FO_READ);
	FRead(fh,12,@icehead_data);
	FClose(fh);
	IF icehead_data.magic=$49434521 
	THEN filesize:=icehead_data.unp_size;
	GetFileLength:=filesize;
END;

TYPE TRP_STRUCT	=RECORD
			magic	:LongInt;
			hsize	:Word;
			vsize	:Word;
		END;


FUNCTION LoadTRP(fh:LongInt;pfd,nam,ext:String):Integer;
VAR		s		:String;
		filesize:LongInt;
		buffer	:Pointer;	{temporary buffer}
		trp_head	:^TRP_STRUCT;
		wd,hi		:Word;
		ix,iy		:LongInt;
		src,dst		:^Word;
BEGIN
	LoadTRP:=-1;
	s:=pfd+nam+ext;
	filesize:=GetFileLength(s);
	buffer:=Malloc(filesize+10);
	IF LongInt(buffer)<>0 THEN BEGIN
		Fread(fh,filesize,buffer);
		Ice_Decrunch_2(buffer);
		{jetzt befindet sich das entpackte TRP im buffer}
		trp_head:=buffer;
		{trp_struct zeigt auf TRP-header}
		wd:=trp_head^.hsize;
		hi:=trp_head^.vsize;
		IF MakeNewPicture(wd,hi,nam,NIL)<>NIL THEN WITH pic[anzpic] DO BEGIN
			src:=Pointer(LongInt(buffer)+8);dst:=adr;
			FOR iy:=0 TO hi-1 DO BEGIN
				FOR ix:=0 TO wd-1 DO BEGIN
					dst^:=src^;
					Inc(LongInt(dst),2);Inc(LongInt(src),2);
				END;
				Inc(LongInt(dst),(rez_x-wd)*2);
			END;

			{Bildstruktur aktualisieren}
			par.actscr:=anzpic;
			pfad:=pfd;
			extens:=ext;
			palpfad:=pfd;
			palname:=nam;
			palftype:=EPP;
			filetype:=TRP;
			flag:=1;
			LoadTRP:=1;
		END;
		Mfree(buffer);
	END;
END;



FUNCTION LoadXGA(fh:LongInt;pfd,nam,ext:String):Integer;
VAR
	offset:LongInt;
	adr:Pointer;
	s:String;
	size:LongInt;
	xsize,ysize:LongInt;
BEGIN
	s:=pfd+nam+ext;
	size:=GetFileLength(s);
	xsize:=320;
	ysize:=size div 640;
	IF MakeNewPicture(xsize,ysize,nam,NIL)<>NIL THEN BEGIN
		WITH pic[anzpic] DO BEGIN
			par.actscr:=anzpic;
	
			{Load File}
			FRead(fh,size,adr);
			Ice_Decrunch_2(adr);
		
			{Bildstruktur fllen}
			pfad:=pfd;
			name:=nam;
			extens:=ext;
			palpfad:=pfd;
			palname:=nam;
			palftype:=EPP;
			filetype:=XGA;
			flag:=1;
		END;
		
		LoadXGA:=1;
	END ELSE LoadXGA:=-1;
END;


{FUNKTION LDT BILD, PALETTE ODER SONSTWAS}
FUNCTION  LoadFile(pfd,nam,ext:String):Integer;
VAR		fh,i,typ	:LongInt;
		s			:String;
		leng		:LongInt;
BEGIN
	
	{Datei in den Pufferspeicher laden}
	s:=pfd+nam+ext;
	fh:=FOpen(pfd+nam+ext,FO_READ);
	IF fh>=0 THEN BEGIN

		{Datei eventuell entpacken}
		{Sentry210(350000,buffer);}

		{Fallunterscheidungen:}
	
		typ:=0;

		IF ext='.EPP' THEN BEGIN
			FRead(fh,350000,buffer);
			Ice_Decrunch_2(buffer);
			{Wenn noch kein Bild existiert -> Bild machen}
			IF anzpic=0 THEN BEGIN
				IF MakeNewPicture(320,240,nam,NIL)<>NIL THEN BEGIN
					par.actscr:=anzpic;
					typ:=1; {Bild}
					pic[par.actscr].pfad:=pfd;
					pic[par.actscr].name:=nam;
					pic[par.actscr].extens:='.XGA';
					pic[par.actscr].filetype:=XGA;
					pic[par.actscr].flag:=1;
				END ELSE typ:=-1;
			END ELSE typ:=2; {Palette}
			{Palette in Bildpalette kopieren}
			MemCopy(buffer,pic[par.actscr].paladr,128);
			{Filetyp setzen}
			{Bildstruktur fllen}
			pic[par.actscr].palpfad:=pfd;
			pic[par.actscr].palname:=nam;
			pic[par.actscr].palftype:=EPP;
		END;	
		
		IF ext='.PAL' THEN BEGIN
			leng:=FRead(fh,350000,buffer);
			Ice_Decrunch_2(buffer);
			{Wenn noch kein Bild existiert -> Bild machen}
			IF anzpic=0 THEN BEGIN
				IF MakeNewPicture(320,240,nam,NIL)<>NIL THEN BEGIN 
					par.actscr:=anzpic;
					typ:=1; {Bild}
					pic[par.actscr].pfad:=pfd;
					pic[par.actscr].name:=nam;
					pic[par.actscr].filetype:=XGA;
					pic[par.actscr].flag:=1;
				END ELSE typ:=-1;
			END ELSE typ:=2; {Palette}
			{Palette in Bildpalette konvertieren}
			IF leng=6*256 THEN AnalysePAL(buffer,pic[par.actscr].paladr)
			ELSE AnalyseIndyPal(buffer,pic[par.actscr].paladr);
			{Bildstruktur fllen}
			pic[par.actscr].palpfad:=pfd;
			pic[par.actscr].palname:=nam;
			pic[par.actscr].extens:=ext;
			pic[par.actscr].palftype:=PAL;
		END;
		
		IF ext='.TGA' THEN BEGIN
			FRead(fh,350000,buffer);
			Ice_Decrunch_2(buffer);
			{Bild machen}
			IF MakeNewPicture(320,240,nam,NIL)<>NIL THEN BEGIN 
				par.actscr:=anzpic;
				{Targadaten in Bildspeicher konvertieren}
				AnalyseTGA(buffer,pic[par.actscr].adr);
				{Filetyp setzen}
				typ:=1;{Bild}
				{Bildstruktur fllen}
				pic[par.actscr].pfad:=pfd;
				pic[par.actscr].name:=nam;
				pic[par.actscr].extens:=ext;
				pic[par.actscr].palpfad:=pfd;
				pic[par.actscr].palname:=nam;
				pic[par.actscr].palftype:=EPP;
				pic[par.actscr].filetype:=XGA;
				pic[par.actscr].flag:=1;
			END ELSE typ:=-1;
		END;
	
		IF ext='.TRU' THEN BEGIN
			FRead(fh,350000,buffer);
			Ice_Decrunch_2(buffer);
			{TRU-Block (1) oder TRU-Bild ?}
			i:=AnalyseTRUblk(buffer,blkbuf);
			{Wenn Block...}
			IF i=1 THEN BEGIN
				blkflag:=1;
				{Filetyp setzen}
				typ:=3; {Block}
			{Wenn Bild...}
			END ELSE BEGIN
				{Bild machen}
				IF MakeNewPicture(320,240,nam,NIL)<>NIL THEN BEGIN
					par.actscr:=anzpic;
					AnalyseTRU(buffer,pic[par.actscr].adr);
					typ:=1; {Bild}
					{Bildstruktur fllen}
					pic[par.actscr].pfad:=pfd;
					pic[par.actscr].name:=nam;
					pic[par.actscr].extens:=ext;
					pic[par.actscr].palpfad:=pfd;
					pic[par.actscr].palname:=nam;
					pic[par.actscr].palftype:=EPP;
					pic[par.actscr].filetype:=XGA;
					pic[par.actscr].flag:=1;
				END ELSE typ:=-1;
			END;
		END;	

		IF ext='.TRP' THEN BEGIN
			typ:=LoadTRP(fh,pfd,nam,ext);
		END;	

		IF ext='.PI9' THEN BEGIN
			Ice_Decrunch_2(buffer);
			FRead(fh,350000,buffer);
			{Bild machen}
			IF MakeNewPicture(320,240,nam,NIL)<>NIL THEN BEGIN
				par.actscr:=anzpic;
				{Palettendaten in Palettenspeicher konvertieren}
				MakeTCPalette(buffer,pic[par.actscr].paladr);
				{Bilddaten in Bildspeicher konvertieren}
				DrawTCPi9(buffer,pic[anzpic].adr,pic[par.actscr].paladr);
				typ:=1; {unspeicherbares Bild}
				{Bildstruktur fllen}
				pic[par.actscr].pfad:=pfd;
				pic[par.actscr].name:=nam;
				pic[par.actscr].extens:=ext;
				pic[par.actscr].palpfad:=pfd;
				pic[par.actscr].palname:=nam;
				pic[par.actscr].palftype:=EPP;
				pic[par.actscr].filetype:=XGA;
				pic[par.actscr].flag:=1;
			END ELSE typ:=-1;
		END;
	
	
		{Wenn Bildformat unbekannt: Daten als reine Screendaten behandeln}
		IF (ext<>'.EPP') AND (ext<>'.PAL') AND (ext<>'.TGA') AND (ext<>'.TRP')
	                 AND (ext<>'.TRU') AND (ext<>'.PI9') THEN BEGIN
			typ:=LoadXGA(fh,pfd,nam,ext);
		END;

		FClose(fh);

	
	END ELSE typ:=-1;
	LoadFile:=typ;
END;

										