{FUNKTION FUELLT EINE MODULSTRUKTUR MIT WERTEN}
FUNCTION EPM_Load_Script(slotnum:Integer;pfd:String):Integer;
VAR		fhandle		:Text;
		err			:Integer;
		line		:String;
		s			:String;
		dummy		:Integer;
		c			:Char;
		
{PROZEDUR LIESST ZEILE AUS SCRIPTDATEI}
PROCEDURE ReadLine;
BEGIN
	Delete(line,0,256);
	ReadLn(fhandle,line);
END;

{FUNCTION ERMITTELT ERSTES WORD EINER EINGELESENEN ZEILE}
FUNCTION KeyWord:String;
VAR	result	:String;	{Ergebnis: Schlsselwort}
	cnt		:Integer;	{Positionszhler im String}
	ch		:Char;		{aktuelles Zeichen}
BEGIN
	{Get first Character}
	ch:=UpCase(line[0]);

	{Solange Zeichen bernehmen bis kein Buchstabe oder keine Zahl auftritt}           	
	cnt:=0;
	REPEAT
		result[cnt]:=ch;
		{Take next character}
	    Inc(cnt);            	
		ch:=UpCase(line[cnt]);
	UNTIL (cnt>80) OR (((ch<'A') OR (ch>'Z')) AND ((ch<'0') OR (ch>'9')));

	{Delete the rest}
	Delete(result,cnt,256);

	KeyWord:=result;
END;


{GET KEYCHARACTER (OLD EPM-VERSION)}
FUNCTION KeyChar:Char;
BEGIN
	KeyChar:=#0;
	IF (line[2]='=') AND (Length(line)>2) THEN KeyChar:=UpCase(line[1]) ELSE KeyChar:=#0;
END;


FUNCTION GetCharParameter:String;
BEGIN
	GetCharParameter:=Copy(line,3,255);
END;


FUNCTION GetParameter(num:LongInt):String;
VAR	pcnt	:Integer;	{Parametercounter}
	chcnt	:Integer;	{Charactercounter}
	rcnt	:Integer;	{Resultcharcounter}
	ch		:Char;
	result	:String;
BEGIN

	{Searching for wanted parameterbegin}
	pcnt:=0;
	chcnt:=0;
	REPEAT
		ch:=line[chcnt];
		IF ch='[' THEN Inc(pcnt);
		Inc(chcnt);
	UNTIL (chcnt>150) OR (pcnt=num);
	{chcht: Begin of the parameter}

	result:='not found!';	
	{Copy parametercharacters to the resultstring until parameterend}
	rcnt:=0;
	IF chcnt<=150 THEN BEGIN
		REPEAT
			result[rcnt]:=ch;
			ch:=line[chcnt];
			Inc(chcnt);
			Inc(rcnt);
		UNTIL ch=']';
		Delete(result,rcnt,256);
	END;
	GetParameter:=result;
	
END;
		
BEGIN
	{Modulstruktur mit Werten fllen}
	WITH epm[slotnum] DO BEGIN
	
		{Set standartvalues}
		name:='Anything';
		coder:='Unknown';
		version:='0.0';
		date:='11.11.11';
		routpath:='68K_ROUT.O';
		lodflag:=0;
		lodfile:='56K_ROUT.LOD';
		paramtype:=0;
		rscfile:='OWN_FORM.RSC';
		anzpicpop:=0;
		anzslider:=0;
		anztext:=0;
		filesel:=0;
		
		{Open scriptfile}
		err:=0;
		Assign(fhandle,pfd);
		Reset(fhandle);
		{Wenn file geffnet werden konnte...lesen, sonst Fehlercode}
		IF IOResult<>0 THEN err:=-1 ELSE BEGIN
		
			{Read script line by line and fill modulestructure}
			WHILE not Eof(fhandle) DO BEGIN
				
				{Read one line}
				ReadLine;
				s:=KeyWord;
				c:=KeyChar;
				
				{Analyse Character-Parameters (old version)}
				IF c='N' THEN name:=GetCharParameter;
				IF c='A' THEN coder:=GetCharParameter;
				IF c='V' THEN version:=GetCharParameter;
				IF c='D' THEN date:=GetCharParameter;
				IF c='P' THEN routpath:=GetCharParameter;
				IF c='T' THEN Val(GetCharParameter,typ,dummy);
				
				{Analyse line}
				IF s='NAME' THEN name:=GetParameter(1);
				IF s='DATE' THEN date:=GetParameter(1);				
				IF s='TYPE' THEN Val(GetParameter(1),typ,dummy);
				IF s='VERSION' THEN version:=GetParameter(1);
				IF s='CODER' THEN coder:=GetParameter(1);
				IF s='ROUTINE' THEN routpath:=GetParameter(1);
				IF s='PARAMETER' THEN Val(GetParameter(1),paramtype,dummy);
				IF s='LODFILE' THEN BEGIN
					lodflag:=1;
					lodfile:=GetParameter(1);
				END;
				IF s='RSCFILE' THEN rscfile:=GetParameter(1);
				IF s='SLIDER' THEN BEGIN
					Inc(anzslider);
					slider[anzslider].name:=GetParameter(1);
					Val(GetParameter(2),slider[anzslider].min,dummy);
					Val(GetParameter(3),slider[anzslider].max,dummy);
					Val(GetParameter(4),slider[anzslider].num,dummy);
				END;
				IF s='TEXTFIELD' THEN BEGIN
					Inc(anztext);
					textin[anztext].head:=GetParameter(1);
					textin[anztext].input:=GetParameter(2);
				END;
				IF s='FILESEL' THEN BEGIN
					filesel:=1;
					fileselhead:=GetParameter(1);
					fileseltype:=GetParameter(2);
					fileselext:=GetParameter(3);
				END;
				IF s='PICPOPUP' THEN BEGIN
					Inc(anzpicpop);
					picpop[anzpicpop].title:=GetParameter(1);
					picpop[anzpicpop].actpic:=1;
				END;		
			END;
		
			{Datei schlieen}
			Close(fhandle);
			modflag:=1;
		
		END;
		
		EPM_Load_Script:=err;
	END;
END;




{PROZEDUR LAED MODUL IN EINEN MODULSLOT}
PROCEDURE Load_Module(modnum:LongInt);
VAR		result		:Integer;
		obj			:Integer;
		s			:String;
		x,y,w,h		:Integer;
		obj_tree	:AESTreePtr;
		shortname	:String[17];
BEGIN
	IF modnum=actmodnum THEN actmodnum:=-1;
	CASE modnum OF
		1: obj:=EPM_NAME1;
		2: obj:=EPM_NAME2;
		3: obj:=EPM_NAME3;
		4: obj:=EPM_NAME4;
		5: obj:=EPM_NAME5;
		6: obj:=EPM_NAME6;
		7: obj:=EPM_NAME7;
		8: obj:=EPM_NAME8;
		9: obj:=EPM_NAME9;
		10: obj:=EPM_NAME10;
		11: obj:=EPM_NAME11;
		12: obj:=EPM_NAME12;
		13: obj:=EPM_NAME13;
		14: obj:=EPM_NAME14;
		15: obj:=EPM_NAME15;
		16: obj:=EPM_NAME16;
	END;
	WITH epm[modnum] DO BEGIN
		{Dateiauswahlbox aufrufen}
		IF dummy<>-1 THEN BEGIN
			Wind_Update(BEG_UPDATE);
			Fsel_ExInput(epmpath,epmname,result,'EPM-Modul laden');
			{result: angeklickter Button}
			Wind_Update(END_UPDATE);
			{Fenster erstma restaurieren}
			Wait_Win;
		END ELSE result:=1;
		{Wenn OK angeklickt -> Laden}
		IF (result=1) THEN BEGIN
			Graf_Mouse(BUSYBEE,NIL);
			FSplit( epmpath, mdir, mnam, mext );
			{Modul-Flag erst einmal lschen}
			modflag:=0;
			{ASCII-EPM-File laden und Auswerten}
			{gesamten Pfad generieren}
			s:=mdir+epmname;
			{s:Ergebnispfad+datei}
			typ:=0;routpath:='';modflag:=0;name:=' empty slot ';
			EPM_Load_Script(modnum,s);
			Graf_Mouse(ARROW,NIL);
			obj_tree:=GetRSCAdr(R_TREE,MODULES);
			{eingelesene Werte in Dialogboxstruktur eintragen}
			shortname:=name;
			SetFreeString(obj_tree,obj,shortname);
			IF dummy<>-1 THEN Redraw_Obj(obj_tree,win[MODWIN].handle,obj);
		END;
	END;
END;


{PROZEDUR UM MODULINFORMATIONEN DARZUSTELLEN}
PROCEDURE Info_Module(modnum:LongInt);
VAR		x,y,w,h,result:Integer;
		old_tree:AESTreePtr;
BEGIN
	old_tree:=obj_tree;
	obj_tree:=GetRSCAdr(R_TREE,MODULE_INFO);
	{Strings setzen}
	SetFreeString(obj_tree,EPM_AUTOR,epm[modnum].coder);
	SetFreeString(obj_tree,EPM_VERSION,epm[modnum].version);
	SetFreeString(obj_tree,EPM_DATE,epm[modnum].date);
	{Dialog zeichnen}
	Form_Center(obj_tree,x,y,w,h);
	Form_Dial(FMD_START,x,y,w,h,x,y,w,h);
	Objc_Draw(obj_tree,0,30,x,y,w,h);
	result:=Form_Do(obj_tree,0);
	Form_Dial(FMD_FINISH,x,y,w,h,x,y,w,h);
	{Exit-Button deselektieren}
	Set_Obj_State(obj_tree,result,NORMAL);
	obj_tree:=old_tree;
END;