export blk_dput					;Fgt einen Block deckend ein
export blk_dmov					;Bewegt einen Block deckend
export blk_col					;Setzt Farbe als Parameter zum Einfgen
globl  blkputmode
globl  blkputcol

TEXT

;FGT EINEN BLOCK IN EIN BILD EIN
blk_dput:
	movem.l	d0-d7/a0-a7, -(sp)
	;d0:	x-Position	(linke obere Ecke des Blockes)
	;d1:	y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse der alten Position bestimmen
	adda.l	d1, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_put_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_put_x_loop:
	bsr		blk_d_pixcopy
	addq.l	#2, a0
	addq.l	#2, a1
	dbf		d3, blk_put_x_loop
	adda.l	d0, a1
	dbf		d5, blk_put_y_loop
	
	movem.l	(sp)+, d0-d7/a0-a7
rts


;BEWEGT EINEN BLOCK DECKEND
blk_dmov:

	move.l	4(sp), d3
	move.l	8(sp), a2
	;d0:	alte x-Position	(linke obere Ecke des Blockes)
	;d1:	alte y-Position	(	"	"		"	"	"	 )
	;d2:	neue x-Position	(	"	"		"	"	"	 )
	;d3:	neue y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	;a2:	Bildspeicher
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der alten Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse der alten Position bestimmen
	move.l	a1, a3
	adda.l	d1, a3
	
	;Adresse der alten Position im Bildspeicher bestimmen
	adda.l	d1, a2
		
	;Adressoffset der neuen Position bestimmen
	lsl.l	d2
	mulu.l	#640, d3
	add.l	d2, d3
	;d3:	Adressoffset der alten Position
	;Adresse der neuen Position bestimmen
	adda.l	d3, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset

	;Vergleich der beiden Positions-Offsets
	cmp.l	d1, d3
	bgt		oldpos_kleiner
	
	;Die neue Position ist kleiner
newpos_kleiner:
	
	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_cut_y_loop2:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_cut_x_loop2:
	move.w	(a2)+, (a3)+
	bsr		blk_d_pixcopy
	addq.l	#2, a0
	addq.l	#2, a1
	dbf		d3, blk_cut_x_loop2
	adda.l	d0, a1
	adda.l	d0, a2
	adda.l	d0, a3
	dbf		d5, blk_cut_y_loop2
	
	bra		blk_dmov_end
	
	;Der alte Adressoffset ist kleiner 
oldpos_kleiner:

	;Gre des Blockes ausrechnen
	move.l	d4, d1
	move.l	d5, d2
	mulu.l	d2, d1
	lsl.l	d1
	
	;Gre des Blockes zur Block-Adresse addieren
	adda.l	d1, a0
	
	;Offsets fr die brigen Adressen berechnen
	move.l	d5, d1
	move.l	d4, d2
	subq.l	#1, d1
	;addq.l	#1, d1
	;addq.l	#1, d2
	lsl.l	d2
	mulu.l	#640, d1
	add.l	d2, d1
	;d1: Offset
	
	adda.l	d1, a1
	adda.l	d1, a2
	adda.l	d1, a3

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_cut_y_loop:
	;Breite als x-Counter
	move.l	d4, d3
	subq.l	#1, d3
blk_cut_x_loop:
	subq.l	#2, a0
	subq.l	#2, a1
	
	move.w	-(a2), -(a3)
	dbf		d3, blk_cut_x_loop
	suba.l	d0, a1
	suba.l	d0, a2
	suba.l	d0, a3
	dbf		d5, blk_cut_y_loop


	
blk_dmov_end:


rts


;SETZT FARBWERT ALS PARAMETER FR DAS EINFGEN
blk_col:
	;d0:	Farbwert
	move.w	d0, col
rts


;KOPIERT EIN PIXEL IM R-G-B-Modus
blk_rgb_pixcopy:

	;Fallunterscheidung
	;deckend
	cmpi.l	#1, blkputmode
	beq		draw_deck
	;nicht deckend
	cmpi.l	#2, blkputmode
	beq		draw_n_deck
	;hinter Bild einfgen
	cmpi.l	#3, blkputmode
	beq		draw_b_g
	
	bra		draw_end

;deckend zeichnen	
draw_deck:
	move.w	(a0), (a1)
	bra		draw_end
;nicht deckend zeichnen
draw_n_deck:
	move.w	(a0), d6
	move.w	col, d1
	cmp.w	d6, d1
	beq		draw_end
	move.w	(a0), (a1)
	bra		draw_end
;hinter Bild zeichnen
draw_b_g:
	move.w	(a1), d6
	move.w	col, d1
	cmp.w	d6, d1
	bne		draw_end
	move.w	(a0), (a1)
	bra		draw_end

draw_end:

rts

BSS

col:	ds.w	1


END