;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM EINFGEN VON BLCKEN MIT HINTERGRUNDVERKNPFUNGEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

;Ein Block besteht aus 1 Wort fr die Breite, 1 Wort fr die Hhe
;und einer Anzahl von Pixel-Daten-Worten (Anz.= 2*Breite*Hhe)

export blk_dput					;Fgt einen Block deckend ein
export blk_dmov					;Bewegt einen Block deckend
export blk_col					;Setzt Farbe als Parameter zum Einfgen
globl  blkputmode				;Einfgemodus
globl  blkputcol				;Bezug: R,G,B,ALL


TEXT

;FGT EINEN BLOCK IN EIN BILD EIN
blk_dput:
	movem.l	d0-d7/a0-a7, -(sp)
	;d0:	x-Position	(linke obere Ecke des Blockes)
	;d1:	y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der Bild-Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse der alten Position bestimmen
	adda.l	d1, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset
	
	;Verzweigung in Abhngigkeit vom Farbmodus
	cmpi.l	#1, blkputcol
	beq			put_red
	cmpi.l	#2, blkputcol
	beq			put_green
	cmpi.l	#3, blkputcol
	beq			put_blue
	cmpi.l	#4, blkputcol
	beq			put_all
	bra blk_put_end
	
	;Nur Rot bercksichtigen	
put_red:
	lea			blk_r_pixcopy,a4
	bra			blk_put_mode_ok
	;Nur Grn bercksichtigen
put_green:
	lea			blk_g_pixcopy,a4
	bra			blk_put_mode_ok
	;Nur Blau bercksichtigen
put_blue:
	lea			blk_b_pixcopy,a4
	bra			blk_put_mode_ok
	;Alle Farben bercksichtigen
put_all:
	lea			blk_rgb_pixcopy, a4
	bra			blk_put_mode_ok

blk_put_mode_ok:

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_put_y_loop:
	;Breite als x-Counter
	move.l	d4, d7
	subq.l	#1, d7
blk_put_x_loop:
	jsr		(a4)
	addq.l	#2, a0
	addq.l	#2, a1
	dbf		d7, blk_put_x_loop
	adda.l	d0, a1
	dbf		d5, blk_put_y_loop

blk_put_end:
	movem.l	(sp)+, d0-d7/a0-a7
rts


;BEWEGT EINEN BLOCK DECKEND VON ALTER ZU NEUER BILDSCHIRMPOSITION
blk_dmov:
	;bergabewerte
	move.l	4(sp), d3
	move.l	8(sp), a2
	;d0:	alte x-Position	(linke obere Ecke des Blockes)
	;d1:	alte y-Position	(	"	"		"	"	"	 )
	;d2:	neue x-Position	(	"	"		"	"	"	 )
	;d3:	neue y-Position	(	"	"		"	"	"	 )
	;a0:	Blockbuffer
	;a1:	Screen
	;a2:	Bildspeicher
	
	;Blockbreite und Blockhhe bestimmen
	move.w	(a0)+, d4
	;d4:	Breite des Blockes
	move.w	(a0)+, d5
	;d5:	Hhe des Blockes
	
	;Adressoffset der alten Position bestimmen
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	;d1:	Adressoffset der alten Position
	;Adresse der alten Position bestimmen
	move.l	a1, a3
	adda.l	d1, a3
	
	;Adresse der alten Position im Bildspeicher bestimmen
	adda.l	d1, a2
		
	;Adressoffset der neuen Position bestimmen
	lsl.l	d2
	mulu.l	#640, d3
	add.l	d2, d3
	;d3:	Adressoffset der alten Position
	;Adresse der neuen Position bestimmen
	adda.l	d3, a1
	
	;Line-Offset bestimmen
	move.l	#320, d0			;x-Auflsung
	sub.l	d4, d0				;Breite subtrahieren
	lsl.l	d0					;1 Pixel = 2 Bytes
	;d0:	Line-Offset
	
	;Verzweigung in Abhngigkeit vom Farbmodus
	cmpi.l	#1, blkputcol
	beq			mov_red
	cmpi.l	#2, blkputcol
	beq			mov_green
	cmpi.l	#3, blkputcol
	beq			mov_blue
	cmpi.l	#4, blkputcol
	beq			mov_all
	bra blk_mov_end
	
	;Nur Rot-Anteil bercksichtigen
mov_red:
	lea			blk_r_pixcopy,a4
	bra			blk_move_mode_ok
	;Nur Grn-Anteil bercksichtigen
mov_green:
	lea			blk_g_pixcopy,a4
	bra			blk_move_mode_ok
	;Nur Blau-Anteil bercksichtigen
mov_blue:
	lea			blk_b_pixcopy,a4
	bra			blk_move_mode_ok
	;Alle Farben bercksichtigen
mov_all:
	lea			blk_rgb_pixcopy, a4
	bra			blk_move_mode_ok
blk_move_mode_ok:
	;Pixelcopy-Sprungadresse ist festgelegt in steht in a4

	;Vergleich der beiden Positions-Offsets und Verzweigung in 2 Routinen
	cmp.l	d1, d3
	bgt		oldpos_kleiner
	
	
;Die Hauptroutine wird in zwei Unterroutinen aufgespalten um ein
;Flackern des Blockes mglichst gering zu halten. Ist die neue
;Blockposition unterhalb der alten wird der Block von oben nach
;unten kopiert und gleichzeitig dir alte Position restauriert.
;Ist die neue Blockposition oberhalb der alten wird der Block
;von unten gezeichnet und die alte Position restauriert

	;ANFANG DER 1.ROUTINE
	
	;Die neue Position ist kleiner
newpos_kleiner:
	
	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_mov_y_loop1:
	;Breite als x-Counter
	move.l	d4, d7
	subq.l	#1, d7
blk_mov_x_loop1:
	;alte Position restaurieren
	move.w	(a2)+, (a3)+
	;Pixelcopy-Routine anspringen (abh. vom Einfgemodus)
	jsr		(a4)
	;Pixel-Adressen weiterzhlen
	addq.l	#2, a0
	addq.l	#2, a1
	dbf		d7, blk_mov_x_loop1
	;Line-Offset zu Pixeladresse des Zieles...
	adda.l	d0, a1
	;..Pixeladresse des Orginalbildes...
	adda.l	d0, a2
	;..und Pixeladresse der alten Position auf Zielscreen addieren.
	adda.l	d0, a3
	dbf		d5, blk_mov_y_loop1
	
	bra		blk_mov_end
	
	;ENDE DER 1.ROUTINE
	
	
	;ANFANG DER 2.ROUTINE
	
	;Der alte Adressoffset ist kleiner 
oldpos_kleiner:

	;Gre des Blockes ausrechnen
	;Anz_Bytes = x*y*2
	move.l	d4, d1
	move.l	d5, d2
	mulu.l	d2, d1
	lsl.l	d1
	
	;Gre des Blockes zur Block-Adresse addieren
	adda.l	d1, a0
	
	;Offsets fr die brigen Adressen berechnen
	move.l	d5, d1
	move.l	d4, d2
	subq.l	#1, d1
	lsl.l	d2
	mulu.l	#640, d1
	add.l	d2, d1
	;d1: Offset
	
	;Offsets addieren
	adda.l	d1, a1
	adda.l	d1, a2
	adda.l	d1, a3

	;Block in Screen kopieren
	;x- und y-Zhler
	;Hhe als y-Counter
	subq.l	#1, d5
blk_mov_y_loop2:
	;Breite als x-Counter
	move.l	d4, d7
	subq.l	#1, d7
blk_mov_x_loop2:
	subq.l	#2, a0
	subq.l	#2, a1
	;Pixel an neue Position kopieren (a4 ist abh.vom Einfgemodus)
	jsr		(a4)
	;alte Pos. restaurieren
	move.w	-(a2), -(a3)
	dbf		d7, blk_mov_x_loop2
	;Lineoffsets zu allen Pixeladressen addieren
	suba.l	d0, a1
	suba.l	d0, a2
	suba.l	d0, a3
	dbf		d5, blk_mov_y_loop2

	;ENDE DER 2.ROUNTINE
	
blk_mov_end:


rts


;SETZT FARBWERT ALS PARAMETER FR DAS EINFGEN
blk_col:
	;d0:	Farbwert
	move.w	d0, col
rts


;KOPIERT EIN PIXEL IM R-G-B-Modus
blk_rgb_pixcopy:
	;a0:	Blockadresse
	;a1:	Ziel-Pixeladresse
	;es werden die Register d1,d2,d3 benutzt und nicht wiederhergestellt.
	
	;Fallunterscheidung
	
	;deckend
	cmpi.l	#1, blkputmode
	beq		rgb_draw_deck
	;nicht deckend
	cmpi.l	#2, blkputmode
	beq		rgb_draw_n_deck
	;hinter Bild einfgen
	cmpi.l	#3, blkputmode
	beq		rgb_draw_b_g
	;Farben addieren
	cmpi.l	#4, blkputmode
	beq		rgb_draw_add
	;Farben subtrahieren
	cmpi.l	#5, blkputmode
	beq		rgb_draw_sub
	;Farben mischen (transparenz)
	cmpi.l	#6, blkputmode
	beq		rgb_draw_trans
	;and-Verknpfung
	cmpi.l	#7, blkputmode
	beq		rgb_draw_and
	;or-Verknpfung
	cmpi.l	#8, blkputmode
	beq		rgb_draw_or
	
	bra		rgb_draw_end

;deckend zeichnen	
rgb_draw_deck:
	move.w	(a0), (a1)
	bra		rgb_draw_end
;nicht deckend zeichnen
rgb_draw_n_deck:
	move.w	(a0), d2
	move.w	col, d1
	cmp.w	d2, d1
	beq		rgb_draw_end
	move.w	(a0), (a1)
	bra		rgb_draw_end
;hinter Bild zeichnen
rgb_draw_b_g:
	move.w	(a1), d2
	move.w	col, d1
	cmp.w	d2, d1
	bne		rgb_draw_end
	move.w	(a0), (a1)
	bra		rgb_draw_end
;and-Verknpfung
rgb_draw_and:
	move.w	(a0), d1
	and.w	d1, (a1)
	bra		rgb_draw_end
;or-Verknpfung
rgb_draw_or:
	move.w	(a0), d1
	or.w	d1, (a1)
	bra		rgb_draw_end
;Farben addieren
rgb_draw_add:
	;Rotwert des Quellpixels isolieren
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;Rotwert des Zielpixels isolieren
	move.w	(a1), d2
	and.w	#%1111100000000000, d2
	;Werte um 5 nach rechts shiften
	lsr.w	#5, d1
	lsr.w	#5, d2
	;Rotwerte addieren
	add.w	d1, d2
	;Ergebnis auf berlauf testen
	cmpi.w	#%0000011111000000, d2
	blt		rgb_no_r_overfl
	move.w	#%0000011111000000, d2
rgb_no_r_overfl:
	;Wert wieder um 5 nach links shiften
	lsl.w	#5, d2
	;Rot noch einmal filtern
	and.w	#%1111100000000000, d2
	;Rotwerte aus Ziel entfernen
	and.w	#%0000011111111111, (a1)
	;neuen Rotwert eintragen
	add.w	d2, (a1)
		
	;Grnanteile von Quelle und Ziel filtern
	;Block = Quelle
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;Bild = Ziel
	move.w	(a1), d2
	and.w	#%0000011111100000, d2
	;Farbwerte addieren
	add.w	d1, d2
	;Bei berlauf den Maximalwert einsetzen
	cmpi.w	#%0000011111100000, d2
	blt		rgb_no_g_overfl
	move.w	#%0000011111100000, d2
rgb_no_g_overfl:
	;Grnanteile nochmal filtern
	and.w	#%0000011111100000, d2
	;Grnanteile des Zielpixels entfernen
	and.w	#%1111100000011111, (a1)
	;Neuen Grnwert bernehmen
	add.w	d2, (a1)

	;Blauanteile aus Quellpixel filtern
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;Blauanteile aus Zielpixel filtern
	move.w	(a1), d2
	and.w	#%0000000000011111, d2
	;Blauanteile addieren
	add.w	d1, d2
	;Bei berlauf -> max. Blauwert
	cmpi.w	#%0000000000011111, d2
	blt		rgb_no_b_overfl
	move.w	#%0000000000011111, d2
rgb_no_b_overfl:
	;d2:	neuer Blauwert
	;Blauwert aus Zielpixel entfernen
	and.w	#%1111111111100000, (a1)
	;neuen Blauwert in Zielpixel einsetzen
	add.w	d2, (a1)
	bra		rgb_draw_end
;Farben subtrahieren
rgb_draw_sub:
	;Rotanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%1111100000000000, d1
	lsr.w	#5, d1
	move.w	(a1), d2
	andi.w	#%1111100000000000, d2
	lsr.w	#5, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		rgb_r_sub_gr_z
	move.w	#%0000000000000000, d2
rgb_r_sub_gr_z:
	;Rot nochmal filtern
	lsl.w	#5, d2
	andi.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	andi.w	#%0000011111111111, (a1)
	;Neuen Rotanteil einfgen
	add.w	d2, (a1)
	
	;Grnanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%0000011111100000, d1
	move.w	(a1), d2
	andi.w	#%0000011111100000, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		rgb_g_sub_gr_z
	move.w	#%0000000000000000, d2
rgb_g_sub_gr_z:
	;Grn nochmal filtern
	andi.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	andi.w	#%1111100000011111, (a1)
	;Neuen Grnanteil einfgen
	add.w	d2, (a1)
	
	;Blauanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%0000000000011111, d1
	move.w	(a1), d2
	andi.w	#%0000000000011111, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		rgb_b_sub_gr_z
	move.w	#%0000000000000000, d2
rgb_b_sub_gr_z:
	;Blau nochmal filtern
	andi.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	andi.w	#%1111111111100000, (a1)
	;Neuen Blauanteil einfgen
	add.w	d2, (a1)
	bra		rgb_draw_end
;Farben transparent einfgen
rgb_draw_trans:
	;Rot isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%1111100000000000, d2
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d2
	;Rotwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen (gleichzeitig zurckshiften)
	lsl.w	#4, d2
	;Rot nochmal isolieren
	and.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	and.w	#%0000011111111111, (a1)
	;neues Rot in Zielpixel einfgen
	add.w	d2, (a1)
	
	;Grn isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%0000011111100000, d2
	;Grnwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Grn nochmal isolieren
	and.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	and.w	#%1111100000011111, (a1)
	;neues Grn in Zielpixel einfgen
	add.w	d2, (a1)

	;Blau isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%0000000000011111, d2
	;Blauwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Blau nochmal isolieren
	and.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	and.w	#%1111111111100000, (a1)
	;neuen Blauanteil in Zielpixel einfgen
	add.w	d2, (a1)
	bra		rgb_draw_end

rgb_draw_end:

rts



;KOPIERT EIN PIXEL IM RED-Modus
blk_r_pixcopy:

	;Fallunterscheidung
	;deckend
	cmpi.l	#1, blkputmode
	beq		r_draw_deck
	;nicht deckend
	cmpi.l	#2, blkputmode
	beq		r_draw_n_deck
	;hinter Bild einfgen
	cmpi.l	#3, blkputmode
	beq		r_draw_b_g
	;Rotanteile addieren
	cmpi.l	#4, blkputmode
	beq		r_draw_add
	;Rotanteile subtrahieren
	cmpi.l	#5, blkputmode
	beq		r_draw_sub
	;Transparent einfgen
	cmpi.l	#6, blkputmode
	beq		r_draw_trans
	;and-Verknpfen
	cmpi.l	#7, blkputmode
	beq		r_draw_and
	;or-Verknpfen
	cmpi.l	#8, blkputmode
	beq		r_draw_or
	
	bra		r_draw_end

;deckend zeichnen	
r_draw_deck:
	move.w	#%1111100000000000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%0000011111111111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		r_draw_end
;nicht deckend zeichnen
r_draw_n_deck:
	move.w	(a0), d2
	move.w	col, d1
	cmp.w	d2, d1
	beq		r_draw_end
	;Pixel kopieren
	move.w	#%1111100000000000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%0000011111111111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		r_draw_end
;hinter Bild zeichnen
r_draw_b_g:
	move.w	(a1), d2
	move.w	col, d1
	cmp.w	d2, d1
	bne		r_draw_end
	;Pixel kopieren
	move.w	#%1111100000000000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%0000011111111111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		r_draw_end
;and-Verknpfung
r_draw_and:
	;Rot-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%1111100000000000, d1
	;die Rot-Anteile logisch and-Verknpfen
	and.w	d1, d2
	;d2:	Ergebnis der and-Verknpfung des Rot-Anteiles
	;Rotanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%0000011111111111, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Rot ersetzen)
	add.w	d2, (a1)
	bra		r_draw_end
;or-Verknpfung
r_draw_or:
	;Rot-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%1111100000000000, d1
	;die Rot-Anteile logisch or-Verknpfen
	or.w	d1, d2
	;d2:	Ergebnis der or-Verknpfung des Rot-Anteiles
	;Rotanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%0000011111111111, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Rot ersetzen)
	add.w	d2, (a1)
	bra		r_draw_end
;Rotanteile addieren
r_draw_add:
	;Rotwert des Quellpixels isolieren
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;Rotwert des Zielpixels isolieren
	move.w	(a1), d2
	and.w	#%1111100000000000, d2
	;Werte um 5 nach rechts shiften
	lsr.w	#5, d1
	lsr.w	#5, d2
	;Rotwerte addieren
	add.w	d1, d2
	;Ergebnis auf berlauf testen
	cmpi.w	#%0000011111000000, d2
	blt		no_r_overfl
	move.w	#%0000011111000000, d2
no_r_overfl:
	;Wert wieder um 5 nach links shiften
	lsl.w	#5, d2
	;Rot noch einmal filtern
	and.w	#%1111100000000000, d2
	;Rotwerte aus Ziel entfernen
	and.w	#%0000011111111111, (a1)
	;neuen Rotwert eintragen
	add.w	d2, (a1)
	bra		r_draw_end
;Rotanteile subtrahieren
r_draw_sub:
	;Rotanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%1111100000000000, d1
	lsr.w	#5, d1
	move.w	(a1), d2
	andi.w	#%1111100000000000, d2
	lsr.w	#5, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		r_sub_gr_z
	move.w	#%0000000000000000, d2
r_sub_gr_z:
	;Rot nochmal filtern
	lsl.w	#5, d2
	andi.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	andi.w	#%0000011111111111, (a1)
	;Neuen Rotanteil einfgen
	add.w	d2, (a1)
	bra		r_draw_end
;transparent Einfgen (Rotdurchschnitt)
r_draw_trans:
	;Rot isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%1111100000000000, d1
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%1111100000000000, d2
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d2
	;Rotwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen (gleichzeitig zurckshiften)
	lsl.w	#4, d2
	;Rot nochmal isolieren
	and.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	and.w	#%0000011111111111, (a1)
	;neues Rot in Zielpixel einfgen
	add.w	d2, (a1)
	bra		r_draw_end

r_draw_end:
rts



;KOPIERT EIN PIXEL IM GREEN-Modus
blk_g_pixcopy:

	;Fallunterscheidung
	;deckend
	cmpi.l	#1, blkputmode
	beq		g_draw_deck
	;nicht deckend
	cmpi.l	#2, blkputmode
	beq		g_draw_n_deck
	;hinter Bild einfgen
	cmpi.l	#3, blkputmode
	beq		g_draw_b_g
	;Farbaddition
	cmpi.l	#4, blkputmode
	beq		g_draw_add
	;Farbsubtraktion
	cmpi.l	#5, blkputmode
	beq		g_draw_sub
	;Tranparent
	cmpi.l	#6, blkputmode
	beq		g_draw_trans
	;and-Verknpfen
	cmpi.l	#7, blkputmode
	beq		g_draw_and
	;or-Verknpfen
	cmpi.l	#8, blkputmode
	beq		g_draw_or
	
	
	bra		g_draw_end

;deckend zeichnen	
g_draw_deck:
	move.w	#%0000011111100000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111100000011111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		g_draw_end
;nicht deckend zeichnen
g_draw_n_deck:
	move.w	(a0), d2
	move.w	col, d1
	cmp.w	d2, d1
	beq		g_draw_end
	move.w	#%0000011111100000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111100000011111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		g_draw_end
;hinter Bild zeichnen
g_draw_b_g:
	move.w	(a1), d2
	move.w	col, d1
	cmp.w	d2, d1
	bne		g_draw_end
	move.w	#%0000011111100000,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111100000011111,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		g_draw_end
;and-Verknpfung
g_draw_and:
	;Grn-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%0000011111100000, d1
	;die Grn-Anteile logisch and-Verknpfen
	and.w	d1, d2
	;d2:	Ergebnis der and-Verknpfung des Grn-Anteiles
	;Grnanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%1111100000011111, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Grn ersetzen)
	add.w	d2, (a1)
	bra		g_draw_end
;or-Verknpfung
g_draw_or:
	;Grn-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%0000011111100000, d1
	;die Grn-Anteile logisch or-Verknpfen
	or.w	d1, d2
	;d2:	Ergebnis der or-Verknpfung des Grn-Anteiles
	;Grnanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%1111100000011111, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Grn ersetzen)
	add.w	d2, (a1)
	bra		g_draw_end
;Addition der Grn-Anteile
g_draw_add:
	;Grnanteile von Quelle und Ziel filtern
	;Block = Quelle
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;Bild = Ziel
	move.w	(a1), d2
	and.w	#%0000011111100000, d2
	;Farbwerte addieren
	add.w	d1, d2
	;Bei berlauf den Maximalwert einsetzen
	cmpi.w	#%0000011111100000, d2
	blt		no_g_overfl
	move.w	#%0000011111100000, d2
no_g_overfl:
	;Grnanteile nochmal filtern
	and.w	#%0000011111100000, d2
	;Grnanteile des Zielpixels entfernen
	and.w	#%1111100000011111, (a1)
	;Neuen Grnwert bernehmen
	add.w	d2, (a1)
	bra		g_draw_end
;Subtraktion der Grnanteile der Farben
g_draw_sub:
	;Grnanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%0000011111100000, d1
	move.w	(a1), d2
	andi.w	#%0000011111100000, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		g_sub_gr_z
	move.w	#%0000000000000000, d2
g_sub_gr_z:
	;Grn nochmal filtern
	andi.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	andi.w	#%1111100000011111, (a1)
	;Neuen Grnanteil einfgen
	add.w	d2, (a1)
	bra		g_draw_end
;transparent Einfgen (Grndurchschnitt)
g_draw_trans:
	;Grn isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%0000011111100000, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%0000011111100000, d2
	;Grnwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Grn nochmal isolieren
	and.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	and.w	#%1111100000011111, (a1)
	;neues Grn in Zielpixel einfgen
	add.w	d2, (a1)
	bra		g_draw_end

g_draw_end:
rts


;KOPIERT EIN PIXEL IM BLUE-Modus
blk_b_pixcopy:

	;Fallunterscheidung
	;deckend
	cmpi.l	#1, blkputmode
	beq		b_draw_deck
	;nicht deckend
	cmpi.l	#2, blkputmode
	beq		b_draw_n_deck
	;hinter Bild einfgen
	cmpi.l	#3, blkputmode
	beq		b_draw_b_g
	;Farbaddition
	cmpi.l	#4, blkputmode
	beq		b_draw_add
	;Farbsubtr.
	cmpi.l	#5, blkputmode
	beq		b_draw_sub
	;Transparent einfgen
	cmpi.l	#6, blkputmode
	beq		b_draw_trans
	;and-Verknpfen
	cmpi.l	#7, blkputmode
	beq		b_draw_and
	;or-Verknpfen
	cmpi.l	#8, blkputmode
	beq		b_draw_or
	
	bra		b_draw_end

;deckend zeichnen	
b_draw_deck:
	move.w	#%0000000000011111,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111111111100000,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		b_draw_end
;nicht deckend zeichnen
b_draw_n_deck:
	move.w	(a0), d2
	move.w	col, d1
	cmp.w	d2, d1
	beq		b_draw_end
	move.w	#%0000000000011111,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111111111100000,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		b_draw_end
;hinter Bild zeichnen
b_draw_b_g:
	move.w	(a1), d2
	move.w	col, d1
	cmp.w	d2, d1
	bne		b_draw_end
	move.w	#%0000000000011111,d1
	move.w	(a0), d3
	and.w	d1, d3
	move.w	#%1111111111100000,d2
	and.w	d2, (a1)
	add.w	d3, (a1)
	bra		b_draw_end
;and-Verknpfung
b_draw_and:
	;Blau-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%0000000000011111, d1
	;die Blau-Anteile logisch and-Verknpfen
	and.w	d1, d2
	;d2:	Ergebnis der and-Verknpfung des Blau-Anteiles
	;Blauanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%1111111111100000, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Blau ersetzen)
	add.w	d2, (a1)
	bra		b_draw_end
;or-Verknpfung
b_draw_or:
	;Blau-Anteil aus den 16-Bit-Pixelinformationen herausfiltern
	;vom Quellpixel..
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;vom Zielpixel..
	move.w	(a1), d2
	and.w	#%0000000000011111, d1
	;die Blau-Anteile logisch or-Verknpfen
	or.w	d1, d2
	;d2:	Ergebnis der or-Verknpfung des Blau-Anteiles
	;Blauanteil aus dem Zielpixel entfernen um ihn durch d2 zu ersetzen
	and.w	#%1111111111100000, (a1)
	;Ergebnis der Verknpfung zum Zielpixel addieren (Blau ersetzen)
	add.w	d2, (a1)
	bra		b_draw_end
;Addition der Blauanteile
b_draw_add:
	;Blauanteile aus Quellpixel filtern
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;Blauanteile aus Zielpixel filtern
	move.w	(a1), d2
	and.w	#%0000000000011111, d2
	;Blauanteile addieren
	add.w	d1, d2
	;Bei berlauf -> max. Blauwert
	cmpi.w	#%0000000000011111, d2
	blt		no_b_overfl
	move.w	#%0000000000011111, d2
no_b_overfl:
	;d2:	neuer Blauwert
	;Blauwert aus Zielpixel entfernen
	and.w	#%1111111111100000, (a1)
	;neuen Blauwert in Zielpixel einsetzen
	add.w	d2, (a1)
	bra		b_draw_end
;Subtraktion der Blauanteile der Farben
b_draw_sub:
	;Blauanteile aus Quelle und Ziel filtern
	move.w	(a0), d1
	andi.w	#%0000000000011111, d1
	move.w	(a1), d2
	andi.w	#%0000000000011111, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		b_sub_gr_z
	move.w	#%0000000000000000, d2
b_sub_gr_z:
	;Blau nochmal filtern
	andi.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	andi.w	#%1111111111100000, (a1)
	;Neuen Blauanteil einfgen
	add.w	d2, (a1)
	bra		b_draw_end
;Blau transparent Einfgen
b_draw_trans:
	;Blau isolieren
	;Quellpixel
	move.w	(a0), d1
	and.w	#%0000000000011111, d1
	;Zielpixel
	move.w	(a1), d2
	and.w	#%0000000000011111, d2
	;Blauwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Blau nochmal isolieren
	and.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	and.w	#%1111111111100000, (a1)
	;neuen Blauanteil in Zielpixel einfgen
	add.w	d2, (a1)
	bra		g_draw_end


b_draw_end:
rts


BSS

col:	ds.w	1


END