export floodfill


TEXT



floodfill:
	movem.l	d3-d7/a2-a6,-(sp)
	;d0:	x (Startpunkt)
	;d1:	y
	;d2:	Fllfarbe
	;a0:	Screenadresse (320x240 16Bit)
	;a1:	Stack

	;neuen Stack initialisieren
	move.l	sp,old_stack
	move.l	a1,new_stack
	adda.l	#200000,a1
	move.l	a1,sp
	
	;Farbe unter Startpunkt ermitteln
	move.l	d1,d3
	mulu.l	#320,d3
	add.l	d0,d3
	move.w (a0,d3.l*2),d7

	cmp.w	d2,d7
	beq		floodfill_end

	;rekursive Routine aufrufen
	bsr		draw_hline

floodfill_end:
	
	;eigenen Stack deinitialisieren (Wow, klingt das gut!)
	move.l	sp,a0
	move.l	old_stack,sp
	
	movem.l	(sp)+,d3-d7/a2-a6
rts


;rekursive Routine arbeitet Zeilenweise
draw_hline:

	;Stackpointer mit Stack-Baseadr. vergleichen und bei Stackberlauf Abbruch
	cmpa.l	new_stack,sp
	bgt		no_stack_overflow
	rts
no_stack_overflow:

	movem.l	d0/d1/d5/a0/a3,-(sp)
	;movem.l	d0-a6,-(sp)

	;d0:	x
	;d1:	y
	;d2:	Fllfarbe
	;d7:	Hintergrundfarbe

dhl_loop:

	;aktive Pixeladresse berechnen
	move.l	d1,d3
	mulu.l	#640,d3
	movea.l	a0,a3
	adda.l	d3,a3

	;linke Seite vom aktiven Pixel abfahren
	move.l	d0,-(sp)
dhl_leftloop:

	;hat Pixel gleiche Farbe wie Startpunkt? Nein->Flchengrenze erreicht.
	cmp.w	(a3,d0.l*2),d7
	bne		dhl_leftloop_end
	;bsr		wait

	;Zeichenfarbe setzen
	move.w	d2,(a3,d0.l*2)

	;hat unteres Pixel gl.Farbe wie Startpunkt?...
	cmp.w	(640,a3,d0.l*2),d7
	bne		dhl_leftloop_nodown
	;...und rechtes, unteres Pixel nicht? -> Flche verzweigt sich!
	cmp.w	(642,a3,d0.l*2),d7
	beq		dhl_leftloop_nodown
	move.l	d1,d5
	addq.l	#1,d1
	cmpi.l	#240+2,d1						;Bildschirmgrenze
	bhs		dhl_leftloop_nodown
	bsr		draw_hline					;Rekursion
	move.l	d5,d1
dhl_leftloop_nodown:

	;hat oberes Pixel gl.Farbe wie Startpunkt?...
	cmp.w	(-640,a3,d0.l*2),d7
	bne		dhl_leftloop_noup
	;...und rechtes, oberes Pixel nicht? -> Flche verzweigt sich!
	cmp.w	(-638,a3,d0.l*2),d7
	beq		dhl_leftloop_noup
	move.l	d1,d5
	subq.l	#1,d1						;neues y>0 ?
	blt		dhl_leftloop_noup
	bsr		draw_hline
	move.l	d5,d1
dhl_leftloop_noup:

	;nchstes Pixel...
	subq.l	#1,d0

	;...oder nicht, wenn Bildrand erreicht ist.
	blt		dhl_leftloop_end
	bra		dhl_leftloop
dhl_leftloop_end:


	;rechte Seite vom aktiven Pixel abfahren
	move.l	(sp),d0
	;X um 1 erhhen, da x schon in der linken Seite enthalten war.
	addq.l	#1,d0
	cmpi.l	#320,d0
	bge		dhl_rightloop_end
dhl_rightloop:

	;hat Pixel gleiche Farbe wie Startpunkt?
	cmp.w	(a3,d0.l*2),d7
	bne		dhl_rightloop_end
	;bsr wait

	;unteres Pixel gleiche Farbe wie Startpunkt und...
	cmp.w	(640,a3,d0.l*2),d7
	bne		dhl_rightloop_nodown
	;unteres, linkes Pixel nicht -> Flche verzweigt sich -> Rekursion
	cmp.w	(638,a3,d0.l*2),d7
	beq		dhl_rightloop_nodown
	move.l	d1,d5
	addq.l	#1,d1
	cmpi.l	#240+2,d1					;neues Y im Bildbereich?
	bhs		dhl_rightloop_nodown
	bsr		draw_hline
	move.l	d5,d1
dhl_rightloop_nodown:

	;hat oberes Pixel gleiche Farbe wie Startpunkt...
	cmp.w	(-640,a3,d0.l*2),d7
	bne		dhl_rightloop_noup
	;...und oberes, linkes Pixel nicht? -> Flche verzweigt sich
	cmp.w	(-642,a3,d0.l*2),d7
	beq		dhl_rightloop_noup
	move.l	d1,d5
	subq.l	#1,d1
	blt		dhl_rightloop_noup
	bsr		draw_hline
	move.l	d5,d1
dhl_rightloop_noup:

	;Pixel zeichnen
	move.w	d2,(a3,d0.l*2)

	;nchstes Pixel
	addq.l	#1,d0
	cmpi.l	#320,d0
	bge		dhl_rightloop_end
	bra		dhl_rightloop
dhl_rightloop_end:

	move.l 	(sp)+,d0
	
	;geht Flche nach unten weiter?
	cmp.w	(640,a3,d0.l*2),d7
	bne		dhl_nodown
	move.l	d1,d5
	addq.l	#1,d1
	cmpi.l	#240+2,d1
	bhs		dhl_nodown
	bsr		draw_hline
	move.l	d5,d1
dhl_nodown:

	;geht Fche nach oben weiter?
	cmp.w	(-640,a3,d0.l*2),d7
	bne		dhl_noup
	move.l	d1,d5
	subq.l	#1,d1
	blt		dhl_noup
	;bsr		draw_hline
	bra		dhl_loop
	move.l	d5,d1
dhl_noup:
	
	;movem.l	(sp)+,d0-a6
	movem.l	(sp)+,d0/d1/d5/a0/a3
rts


wait:
	REPT 1000
	nop
	ENDM
rts


BSS


old_stack:	ds.l	1
new_stack:	ds.l	1

END