;ROUTINE ZEICHNET EINE STYLE-LINIE

export line5

TEXT

INCLUDE "NEWPIXEL.INC"

line5:
	;Parameterbergabebergabe:
	move.l	4(sp), d3
	move.l	8(sp), color
	move.l	12(sp), style
	;d0:	x1
	;d1:	y1
	;d2:	x2
	;d3:	y2
	;color:	Farbe
	;style:	Zeichenmodus
	;a0:	Bildschirmadresse

	;dx,dy berechnen
	move.l	d2, d4
	sub.l	d0, d4
	cmpi.l	#0, d4
	bge		line_dx_positive
	neg.l	d4
line_dx_positive:
	;d4:	dx
	move.l	d3, d5
	sub.l	d1, d5
	cmpi.l	#0, d5
	bge		line_dy_positive
	neg.l	d5
line_dy_positive:
	;d5:	dy
	
	;Fallunterscheidung dx o. dy grer
	cmp.l	d4, d5
	bgt		line_dy_higher_dx

;FALL 1: DY IST KLEINER ALS DX -> ANSTIEG ZWISCHEN 0 UND 1
line_dy_lower__dx:

	;Koordinaten ggf. anpassen
	cmp.l	d0, d2
	bge		line1_xk_ok
	exg.l	d0, d2
	exg.l	d1, d3
line1_xk_ok:

	;Richtung der "Treppe" bestimmen
	move.l	#1, d7
	cmp.l	d1, d3
	bge		line1_yk_ok
	move.l	#-1, d7
line1_yk_ok:

	;x1, y1 merken
	move.l	d0, x1
	move.l	d1, y1
	
	;Schleife zum Zeichnen der Linie
line1_drawloop:

	;Pixel zeichnen
	setpix	d0, d1, color, style, a0
	
	;Bresenham
	sub.l	d5, d4
	subq.l	#1, d4
	
	;berlauf testen
	cmpi.l	#0, d4
	bge		line1_nobreak
	
	;y-Koordinate ndern (je nach "Treppenrichtung")
	add.l	d7, d1
	
	addq.l	#1, d4
	add.l	d2, d4
	sub.l	x1, d4
	
line1_nobreak:
	
	;x-Koordinate hochzhlen
	addq.l	#1, d0

	;Wenn x2 erreicht ist -> Schleife abbrechen
	cmp.l	d0, d2
	blt		line_end
	
	bra		line1_drawloop
	
;FALL 2: DY IST GRSSER ALS DX -> ANSTIEG HHER ALS 1
line_dy_higher_dx:

	;Koordinaten ggf. anpassen
	cmp.l	d1, d3
	bge		line2_xk_ok
	exg.l	d0, d2
	exg.l	d1, d3
line2_xk_ok:

	;Richtung der "Treppe" bestimmen
	move.l	#1, d7
	cmp.l	d0, d2
	bge		line2_yk_ok
	move.l	#-1, d7
line2_yk_ok:

	;x1, y1 merken
	move.l	d0, x1
	move.l	d1, y1
	

	;Schleife zum Zeichnen der Linie
line2_drawloop:

	;Pixel zeichnen
	setpix	d0, d1, color, style, a0
	
	;Bresenham
	sub.l	d4, d5
	subq.l	#1, d5
	
	;berlauf testen
	cmpi.l	#0, d5
	bge		line2_nobreak
	
	;x-Koordinate ndern (je nach "Treppenrichtung")
	add.l	d7, d0
	
	addq.l	#1, d5
	add.l	d3, d5
	sub.l	y1, d5
	
line2_nobreak:
	
	;y-Koordinate weiterzhlen
	addq.l	#1, d1

	;Wenn x2 erreicht ist -> Schleife abbrechen
	cmp.l	d1, d3
	blt		line_end
	
	bra		line2_drawloop


line_end:
rts




BSS

x1:		ds.l	1
y1:		ds.l	1
color:	ds.l	1
style:	ds.l	1

END