export drawneozoom
export neomove
export neopicdraw
export neopicflip
export neopicsave

TEXT

;DRAWS NEOCHROME REALTIME ZOOM
drawneozoom:
	move.l	4(sp), d3
	move.l	8(sp), d7
	move.l	12(sp), linelen
	;d0:	x
	;d1:	y
	;d2:	magnify
	;d3:	grid flag
	;d7:	zoomtype (0..Realtime, 1..Degas)
	;a0:	picture
	;a1:	screen
	
	movem.l	d0-d1, -(sp)		;backup (later used for clipping)
	
	;adress in picture
	mulu.l	linelen, d1
	add.l	d1, d0
	lsl.l	d0
	adda.l	d0, a0
	;a0:	adress in picture
	
	;center position (only realtime zoom)
	tst.l	d7
	bne		no_centerpos
	move.l	#63/2, d0
	divu.l	d2, d0
	move.l	d0, -(sp)			;backup
	move.l	d0, d1
	mulu.l	linelen, d0
	add.l	d0, d1
	lsl.l	#1, d1
	suba.l	d1, a0
	
	;needed for clipping
	move.l	(sp)+, a2			;center diff.

no_centerpos:

	;for clipping...
	movem.l	(sp)+, d0-d1		;cursorposition
	sub.l	a2, d0				;clippingcounter
	move.l	d0, a3
	sub.l	a2, d1

	;adress in screen
	adda.l	#170*640+100, a1
	move.l	a1, a2
	;a1:	adress in screen

	;test magnify
	cmpi.l	#9, d2
	beq		neo9
	cmpi.l	#7, d2
	beq		neo7
	cmpi.l	#5, d2
	beq		neo5
	
neo3:

	move.l	linelen,d2
	sub.l	#21,d2
	lsl.l	d2
	move.l	d2,linelen

	move.l	#20, d2
neo3_y_loop:

	;...clipping...
	addq.l	#1, d1
	move.l	a3, d0

	;x-loop
	move.l	#20, d6
neo3_x_loop:

	move.w	(a0)+, d5

	;clipping
	addq.l	#1, d0				;x-clipping counter
	tst.l	d7					;clipping or not?
	bne		neo3_no_clip		;clip x
	tst.l	d0
	ble		neo3_clip
	cmpi.l	#320, d0
	bgt		neo3_clip
	tst.l	d1					;clip y
	ble		neo3_clip
	cmpi.l	#158, d1
	bgt		neo3_clip
	bra		neo3_no_clip		;no clipping -> 
neo3_clip:	
	move.w	d2, d5				;set clippingcolor
	ror.w	#5, d5				;red
	add.w	d6, d5				;blue
neo3_no_clip:

	move.l	#2, d4
	tst		d3
	beq		neo3_pix
	subq.l	#1, d4
neo3_pix:
	move.w	d5, (a1)
	move.w	d5, 640(a1)
	tst		d3
	bne		neo3_grid
	move.w	d5, 1280(a1)
	bra		neo3_grid_end
neo3_grid:
	clr.w	1280(a1)
neo3_grid_end:

	addq.l	#2, a1
	dbf		d4, neo3_pix

	tst		d3
	beq		neo3_noblack
	clr.w	(a1)
	clr.w	640(a1)
	clr.w	1280(a1)
	addq.l	#2, a1
neo3_noblack:

	dbf		d6, neo3_x_loop

	;Lineoffset (Screen)
	adda.l	#640-63*2, a1	
	adda.l	#640*2, a1
	
	;Lineoffset (Picture)
	adda.l	linelen, a0
	
	dbf		d2, neo3_y_loop

	bra		neo_end


neo5:
	move.l	linelen,d2
	sub.l	#11,d2
	lsl.l	d2
	move.l	d2,linelen

	;some offset shit
	adda.l	#4*640+4*2, a1
	
	tst.l	d7
	bne		neo5_no_offset
	adda.l	#642, a0
neo5_no_offset:

	;y-loop
	move.l	#10, d2
neo5_y_loop:

	;...clipping...
	addq.l	#1, d1
	move.l	a3, d0

	;x-loop
	move.l	#10, d6
neo5_x_loop:

	move.w	(a0)+, d5

	;clipping
	addq.l	#1, d0				;x-clipping counter
	tst.l	d7					;clipping or not?
	bne		neo5_no_clip		;clip x
	tst.l	d0
	blt		neo5_clip
	cmpi.l	#320, d0
	bge		neo5_clip
	tst.l	d1					;clip y
	blt		neo5_clip
	cmpi.l	#158, d1
	bge		neo5_clip
	bra		neo5_no_clip		;no clipping -> 
neo5_clip:	
	move.w	d2, d5				;set clippingcolor
	ror.w	#5, d5				;red
	add.w	#%0001100011100011, d5		
	add.w	d6, d5				;blue
neo5_no_clip:

	move.l	#4, d4
	tst		d3
	beq		neo5_pix
	subq.l	#1, d4
neo5_pix:
	move.w	d5, (a1)
	move.w	d5, 640(a1)
	move.w	d5, 2*640(a1)
	move.w	d5, 3*640(a1)
	tst		d3
	bne		neo5_grid
	move.w	d5, 4*640(a1)
	bra		neo5_nogrid
neo5_grid:
	clr.w	4*640(a1)
neo5_nogrid:
	addq.l	#2, a1
	dbf		d4, neo5_pix

	tst		d3
	beq		neo5_noblack
	clr.w	0*640(a1)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	addq.l	#2, a1
neo5_noblack:

	dbf		d6, neo5_x_loop

	;Lineoffset (Screen)
	adda.l	#640-11*5*2, a1	
	adda.l	#640*4, a1
	
	;Lineoffset (Picture)
	adda.l	linelen, a0
	
	dbf		d2, neo5_y_loop

	bra		neo_end

neo7:
	move.l	linelen,d2
	sub.l	#9,d2
	lsl.l	d2
	move.l	d2,linelen

	;y-loop
	move.l	#9-1, d2
neo7_y_loop:

	;...clipping...
	addq.l	#1, d1
	move.l	a3, d0

	;x-loop
	move.l	#9-1, d6
neo7_x_loop:

	move.w	(a0)+, d5

	;clipping
	addq.l	#1, d0				;x-clipping counter
	tst.l	d7					;clipping or not?
	bne		neo7_no_clip		;clip x
	tst.l	d0
	ble		neo7_clip
	cmpi.l	#320, d0
	bgt		neo7_clip
	tst.l	d1					;clip y
	ble		neo7_clip
	cmpi.l	#158, d1
	bgt		neo7_clip
	bra		neo7_no_clip		;no clipping -> 
neo7_clip:	
	move.w	d2, d5				;set clippingcolor
	ror.w	#5, d5				;red
	add.w	#%0001100011100011, d5		
	add.w	d6, d5				;blue
neo7_no_clip:

	move.l	#6, d4
	tst		d3
	beq		neo7_pix
	subq.l	#1, d4
neo7_pix:
	move.w	d5, 0*640(a1)
	move.w	d5, 1*640(a1)
	move.w	d5, 2*640(a1)
	move.w	d5, 3*640(a1)
	move.w	d5, 4*640(a1)
	move.w	d5, 5*640(a1)
	tst		d3
	bne		neo7_grid
	move.w	d5, 6*640(a1)
	bra		neo7_nogrid
neo7_grid:
	clr.w	6*640(a1)
neo7_nogrid:
	addq.l	#2, a1
	dbf		d4, neo7_pix

	tst		d3
	beq		neo7_noblack
	clr.w	0*640(a1)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	clr.w	5*640(a1)
	clr.w	6*640(a1)
	addq.l	#2, a1
neo7_noblack:

	dbf		d6, neo7_x_loop

	;Lineoffset (Screen)
	adda.l	#640-63*2, a1	
	adda.l	#640*6, a1
	
	;Lineoffset (Picture)
	adda.l	linelen, a0
	
	dbf		d2, neo7_y_loop

	bra		neo_end

neo9:
	move.l	linelen,d2
	sub.l	#7,d2
	lsl.l	d2
	move.l	d2,linelen

	;y-loop
	move.l	#7-1, d2
neo9_y_loop:

	;...clipping...
	addq.l	#1, d1
	move.l	a3, d0

	;x-loop
	move.l	#7-1, d6
neo9_x_loop:

	move.w	(a0)+, d5

	;clipping
	addq.l	#1, d0				;x-clipping counter
	tst.l	d7					;clipping or not?
	bne		neo9_no_clip		;clip x
	tst.l	d0
	ble		neo9_clip
	cmpi.l	#320, d0
	bgt		neo9_clip
	tst.l	d1					;clip y
	ble		neo9_clip
	cmpi.l	#158, d1
	bgt		neo9_clip
	bra		neo9_no_clip		;no clipping -> 
neo9_clip:	
	move.w	d2, d5				;set clippingcolor
	ror.w	#5, d5				;red
	add.w	#%0001100011100011, d5		
	add.w	d6, d5				;blue
neo9_no_clip:

	move.l	#8, d4
	tst		d3
	beq		neo9_pix
	subq.l	#1, d4
neo9_pix:
	move.w	d5, 0*640(a1)
	move.w	d5, 1*640(a1)
	move.w	d5, 2*640(a1)
	move.w	d5, 3*640(a1)
	move.w	d5, 4*640(a1)
	move.w	d5, 5*640(a1)
	move.w	d5, 6*640(a1)
	move.w	d5, 7*640(a1)
	tst		d3
	bne		neo9_grid
	move.w	d5, 8*640(a1)
	bra		neo9_nogrid
neo9_grid:
	clr.w	8*640(a1)
neo9_nogrid:
	addq.l	#2, a1
	dbf		d4, neo9_pix

	tst		d3
	beq		neo9_noblack
	clr.w	0*640(a1)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	clr.w	5*640(a1)
	clr.w	6*640(a1)
	clr.w	7*640(a1)
	clr.w	8*640(a1)
	addq.l	#2, a1
neo9_noblack:

	dbf		d6, neo9_x_loop

	;Lineoffset (Screen)
	adda.l	#640-63*2, a1	
	adda.l	#640*8, a1
	
	;Lineoffset (Picture)
	adda.l	linelen, a0
	
	dbf		d2, neo9_y_loop

neo_end:

	;Draw cursor (only realtime zoom)
	tst.l	d7
	bne		no_cursdraw
	adda.l	#640*31+60, a2
	move.w	#65535, (a2)
	move.w	#0, 642(a2)
no_cursdraw:

rts


;ZEICHNET BILDPOSITIONSPREVIEW
neomove:
	movem.l	d0-a6,-(sp)
	move.l	4(sp),d3
	;d0:	x
	;d1:	y
	;d2:	picture width
	;d3:	picture height
	;a0:	picture
	;a1:	neoscreen (320x158)
	;calculate picture-lineoffset
	move.l	d2, d4
	sub.l	#320,d4
	add.l	d2,d4
	lsl.l	d4
	;d4:	picture-lineoffset
	;calculate first adress in the picture
	mulu.w	d2,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a0
	move.w	#78,d1
neomove_yloop:
	move.w	#160-1,d2
neomove_xloop:
	move.w	(a0), (a1)
	addq.l	#4, a0
	addq.l	#4, a1
	dbf		d2, neomove_xloop
	adda.l	d4, a0					;add lineoffsets
	adda.l	#640,a1
	dbf		d1,neomove_yloop
	movem.l	(sp)+,d0-a6
rts


;ZEICHNET BILD AUF NEO-SCREEN
neopicdraw:
	movem.l	d0-a6,-(sp)
	move.l	4(sp),d3
	;d0:	x
	;d1:	y
	;d2:	picture width
	;d3:	picture height
	;a0:	picture
	;a1:	neoscreen (320x158)
	;calculate picture-lineoffset
	move.l	d2, d4
	sub.l	#320,d4
	lsl.l	d4
	;d4:	picture-lineoffset
	;calculate first adress in the picture
	mulu.w	d2,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a0
	move.w	#157,d1
neomoved_yloop:
	move.w	#160-1,d2
neomoved_xloop:
	move.l	(a0)+, (a1)+
	dbf		d2, neomoved_xloop
	adda.l	d4, a0					;add lineoffsets
	dbf		d1,neomoved_yloop
	movem.l	(sp)+,d0-a6
rts


;VERTAUSCHT BILD UND NEO-SCREEN-BILDAUSSCHNITT
neopicflip:
	movem.l	d0-a6,-(sp)
	move.l	4(sp),d3
	;d0:	x
	;d1:	y
	;d2:	picture width
	;d3:	picture height
	;a0:	picture
	;a1:	neoscreen (320x158)
	;calculate picture-lineoffset
	move.l	d2, d4
	sub.l	#320,d4
	lsl.l	d4
	;d4:	picture-lineoffset
	;calculate first adress in the picture
	mulu.w	d2,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a0
	move.w	#157,d1
neoflip_yloop:
	move.w	#160-1,d2
neoflip_xloop:
	move.l	(a0),d3
	move.l	(a1),(a0)+
	move.l	d3,(a1)+
	dbf		d2, neoflip_xloop
	adda.l	d4, a0					;add lineoffsets
	dbf		d1,neoflip_yloop
	movem.l	(sp)+,d0-a6
rts



;COPIERT NEOSCREEN-BILDAUSSCHNITT IN BILDSPEICHER
neopicsave:
	movem.l	d0-a6,-(sp)
	move.l	4(sp),d3
	;d0:	x
	;d1:	y
	;d2:	picture width
	;d3:	picture height
	;a0:	picture
	;a1:	neoscreen (320x158)
	;calculate picture-lineoffset
	move.l	d2, d4
	sub.l	#320,d4
	lsl.l	d4
	;d4:	picture-lineoffset
	;calculate first adress in the picture
	mulu.w	d2,d1
	add.l	d0,d1
	lsl.l	d1
	adda.l	d1,a0
	move.w	#157,d1
neosave_yloop:
	move.w	#160-1,d2
neosave_xloop:
	move.l	(a1)+,(a0)+
	dbf		d2, neosave_xloop
	adda.l	d4, a0					;add lineoffsets
	dbf		d1,neosave_yloop
	movem.l	(sp)+,d0-a6
rts

BSS

linelen: ds.l 1

END