;export pixel

MACRO setpix x, y, col, mode, adr
	movem.l	d0-d4/a0, -(sp)
	;Register fr die Pixelfunktion prparieren
	move.l	x, d0
	move.l	y, d1
	move.l	col, d2
	move.l	mode, d3
	move.l	adr, a0
	;Pixelzeichenroutine aufrufen
	bsr		pixel
	movem.l	(sp)+, d0-d4/a0
ENDM

;AUFLSUNG
globl	x_rez
globl	y_rez

;CLIPPING
globl	clipx
globl	clipy

;EIGENTLICHE PIXELROUTINE
pixel:
	;d0:	x-Koordinate
	;d1:	y-Koordinate
	;d2:	Farbe oder Steuercode
	;d3:	Zeichenmodus
	;		(0  -> Normal)
	;		(1	-> Negativ)
	;		(2  -> Transparent)
	;		(3	-> AND)
	;		(4  -> OR)
	;		(5  -> Farbaddition)
	;		(6  -> Farbsubtraktion)
	;a0:	Bildadresse

	;PRFEN, OB PIXEL IM BILDBEREICH LIEGT
	;x<0 ?
	cmpi.l	#0, d0
	blt		pix_end
	;y<0 ?
	cmpi.l	#0, d1
	blt		pix_end
	;x>x-Auflsung ?
	cmp.l	clipx, d0
	bge		pix_end
	;y>y-Auflsung ?
	cmp.l	clipy, d1
	bge		pix_end
	
	;PIXELADRESSE BERECHNEN
	;Zeile:
	move.l	x_rez, d4
	lsl.l	d4
	mulu.l	d4, d1
	;Spalte:
	lsl.l	d0
	;Offset:
	add.l	d0, d1
	;Adresse:
	adda.l	d1, a0
	
	;PIXEL UNTER BERCKSICHTIGUNG DES ZEICHENMODUS SETZEN
	
	;Normal
	cmpi.l	#0, d3
	bne		p_norm_end
	move.w	d2, (a0)
	bra		pix_end
p_norm_end:

	;Negativ
	cmpi.l	#1, d3
	bne		p_neg_end
	not.w	(a0)
	bra		pix_end
p_neg_end:

	;Transparent (superlangsam)
	cmpi.l	#2, d3
	bne		p_trans_end
	;Zeichenfarbe sichern
	move.l	d2, d4
	;Rot isolieren
	;Quellpixel
	move.w	d4, d1
	and.w	#%1111100000000000, d1
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d1
	;Zielpixel
	move.w	(a0), d2
	and.w	#%1111100000000000, d2
	;Ergebnis um 5 nach rechts verschieben (berlauf verhindern)
	lsr.w	#5, d2
	;Rotwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen (gleichzeitig zurckshiften)
	lsl.w	#4, d2
	;Rot nochmal isolieren
	and.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	and.w	#%0000011111111111, (a0)
	;neues Rot in Zielpixel einfgen
	add.w	d2, (a0)
	;Grn isolieren
	;Quellpixel
	move.w	d4, d1
	and.w	#%0000011111100000, d1
	;Zielpixel
	move.w	(a0), d2
	and.w	#%0000011111100000, d2
	;Grnwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Grn nochmal isolieren
	and.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	and.w	#%1111100000011111, (a0)
	;neues Grn in Zielpixel einfgen
	add.w	d2, (a0)
	;Blau isolieren
	;Quellpixel
	move.w	d4, d1
	and.w	#%0000000000011111, d1
	;Zielpixel
	move.w	(a0), d2
	and.w	#%0000000000011111, d2
	;Blauwerte addieren...
	add.w	d1, d2
	;...und das Ergebnis durch 2 teilen
	lsr.w	#1, d2
	;Blau nochmal isolieren
	and.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	and.w	#%1111111111100000, (a0)
	;neuen Blauanteil in Zielpixel einfgen
	add.w	d2, (a0)
	
	bra		pix_end
p_trans_end:

	;AND
	cmpi.l	#3, d3
	bne		p_and_end
	and.w	d2, (a0)
	bra		pix_end
p_and_end:
	
	;OR
	cmpi.l	#4, d3
	bne		p_or_end
	or.w	d2, (a0)
	bra		pix_end
p_or_end:

	;Farbaddition
	cmpi.l	#5, d3
	bne		p_add_end
	;Zeichenfarbe sichern
	move.l	d2, d3
	;Rotwert des Quellpixels isolieren
	move.w	d3, d1
	and.w	#%1111100000000000, d1
	;Rotwert des Zielpixels isolieren
	move.w	(a0), d2
	and.w	#%1111100000000000, d2
	;Werte um 5 nach rechts shiften
	lsr.w	#5, d1
	lsr.w	#5, d2
	;Rotwerte addieren
	add.w	d1, d2
	;Ergebnis auf berlauf testen
	cmpi.w	#%0000011111000000, d2
	blt		p_no_r_overfl
	move.w	#%0000011111000000, d2
	p_no_r_overfl:
	;Wert wieder um 5 nach links shiften
	lsl.w	#5, d2
	;Rot noch einmal filtern
	and.w	#%1111100000000000, d2
	;Rotwerte aus Ziel entfernen
	and.w	#%0000011111111111, (a0)
	;neuen Rotwert eintragen
	add.w	d2, (a0)
	;Grnanteile von Quelle und Ziel filtern
	;Block = Quelle
	move.w	d3, d1
	and.w	#%0000011111100000, d1
	;Bild = Ziel
	move.w	(a0), d2
	and.w	#%0000011111100000, d2
	;Farbwerte addieren
	add.w	d1, d2
	;Bei berlauf den Maximalwert einsetzen
	cmpi.w	#%0000011111100000, d2
	blt		p_no_g_overfl
	move.w	#%0000011111100000, d2
	p_no_g_overfl:
	;Grnanteile nochmal filtern
	and.w	#%0000011111100000, d2
	;Grnanteile des Zielpixels entfernen
	and.w	#%1111100000011111, (a0)
	;Neuen Grnwert bernehmen
	add.w	d2, (a0)
	;Blauanteile aus Quellpixel filtern
	move.w	d3, d1
	and.w	#%0000000000011111, d1
	;Blauanteile aus Zielpixel filtern
	move.w	(a0), d2
	and.w	#%0000000000011111, d2
	;Blauanteile addieren
	add.w	d1, d2
	;Bei berlauf -> max. Blauwert
	cmpi.w	#%0000000000011111, d2
	blt		p_no_b_overfl
	move.w	#%0000000000011111, d2
	p_no_b_overfl:
	;d2:	neuer Blauwert
	;Blauwert aus Zielpixel entfernen
	and.w	#%1111111111100000, (a0)
	;neuen Blauwert in Zielpixel einsetzen
	add.w	d2, (a0)
	bra		pix_end
p_add_end:

	;Farbsubtraktion
	cmpi.l	#6, d3
	bne		p_sub_end
	;Zeichenfarbe sichern
	move.l	d2, d3
	;Rotanteile aus Quelle und Ziel filtern
	move.w	d3, d1
	andi.w	#%1111100000000000, d1
	lsr.w	#5, d1
	move.w	(a0), d2
	andi.w	#%1111100000000000, d2
	lsr.w	#5, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		p_r_sub_gr_z
	move.w	#%0000000000000000, d2
	p_r_sub_gr_z:
	;Rot nochmal filtern
	lsl.w	#5, d2
	andi.w	#%1111100000000000, d2
	;Rot aus Zielpixel entfernen
	andi.w	#%0000011111111111, (a0)
	;Neuen Rotanteil einfgen
	add.w	d2, (a0)
	;Grnanteile aus Quelle und Ziel filtern
	move.w	d3, d1
	andi.w	#%0000011111100000, d1
	move.w	(a0), d2
	andi.w	#%0000011111100000, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		p_g_sub_gr_z
	move.w	#%0000000000000000, d2
	p_g_sub_gr_z:
	;Grn nochmal filtern
	andi.w	#%0000011111100000, d2
	;Grn aus Zielpixel entfernen
	andi.w	#%1111100000011111, (a0)
	;Neuen Grnanteil einfgen
	add.w	d2, (a0)
	;Blauanteile aus Quelle und Ziel filtern
	move.w	d3, d1
	andi.w	#%0000000000011111, d1
	move.w	(a0), d2
	andi.w	#%0000000000011111, d2
	;Farbsubtraktion
	sub.w	d1, d2
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d2
	bge		p_b_sub_gr_z
	move.w	#%0000000000000000, d2
	p_b_sub_gr_z:
	;Blau nochmal filtern
	andi.w	#%0000000000011111, d2
	;Blau aus Zielpixel entfernen
	andi.w	#%1111111111100000, (a0)
	;Neuen Blauanteil einfgen
	add.w	d2, (a0)
	bra		pix_end
p_sub_end:

	
pix_end:
	
rts

