export c_init			;general initialisation
export c_set_zoomscr	;set a new zoom output-screen
export c_set_magnify	;set the zoom magnify
export c_set_grid		;set gridflag (1..on 0..off)
export c_set_orig_w		;set width of the original field 
export c_get_orig_w_min	;get the minimal width of the original field
export c_test_area_x	;
export c_test_area_y	;
export c_get_orig_x		;get the real x-coord. in the picture
export c_get_orig_y		;get the real y-coord. in the picture
export c_get_zoomwcnt	;get the number of h. zoompixels of a magnify
export c_get_zoomhcnt	;get the number of v. zoompixels of a magnify
export c_get_mouse_area	;get the number of the screenelement under cursorpos.
export c_draw_all		;draw zoomscreen
export c_draw_centre	;draw zoom around a position
export c_get_rel_x		;get the rel.x-coord.of a pixel under the mouse
export c_get_rel_y		;get the rel.y-coord.of a pixel under the mouse
export c_setpixel		;draw one pixel in zoom- and originalfield
export c_getpixel		;get the color under the pixel under mousepos.
export c_floodfill		;fills an area under mouse with a new color
export c_pushdata		;copy screendata to picture (for undo function)
export c_pulldata		;copy picturedata to screen (undo function)
export c_del_zoom		;clears the screenarea (zoomfield and originalfield)


TEXT


;GENERAL INITIALISATION
c_init:
	;d0:	x resolution
	;d1:	y resolution
	;a0:	picture adress
	;a1:	screenadress
	move.l	d0, xres
	move.l	d1, yres
	move.l	a0, picadr
	move.l	a1, scradr
	move.l	#5, magnify
	move.l	#1, gridflag
	move.l	#110, zoom_x
	move.l	#30, zoom_y
	move.l	#210, zoom_w
	move.l	#210, zoom_h
	move.l	#110*2+30*640, scr_zoom_pos
	move.l	#0, orig_x
	move.l	#30, orig_y
	move.l	#100, orig_w
	move.l	#210, orig_h
	move.l	#30*640, scr_orig_pos
	move.l	#0, orig_dx
	move.l	#0, orig_dy
	move.l	#0, area_x
	move.l	#0, area_y
rts


;SET A NEW OUTPUT SCREENADRESS
c_set_zoomscr:
	;a0:	new screenadress
	move.l	a0, scradr
rts


;SET THE ZOOMMAGNIFY
c_set_magnify:
	;d0:	new magnify
	move.l	d0, magnify
	bsr		c_draw_init
rts


;SET THE GRIDFLAG
c_set_grid:
	;d0:	new gridflag
	move.l	d0, gridflag
rts


;SET WIDTH OF THE ORIGINAL FIELD
c_set_orig_w:
	;d0:	new width
	
	;set values
	bclr.l	#0, d0								;nur gerade Werte -> Long-moves
	move.l	d0, orig_w							;width of the original field
	add.l	#4, d0	
	move.l	d0, zoom_x							;x-position of the zoomfield
	move.l	#320, d1
	sub.l	d0, d1
	move.l	d1, zoom_w							;width of the zoomfield
	
	;calculate new scr.position offset of the zoomfield
	move.l	zoom_y, d1
	mulu.l	#320, d1
	add.l	d0, d1
	lsl.l	d1
	move.l	d1, scr_zoom_pos

	bsr		c_draw_init
rts


;GET THE MINIMAL WIDTH OF THE ORIGINAL FIELD
c_get_orig_w_min:
	move.l	magnify, d1
	addq.l	#1, d1
	move.l	#320, d0
	divu.l	d1, d0
	addq.l	#3, d0
	;d0:	minimal value
rts


;TEST A X-AREAPOSITION COORDINATE
c_test_area_x:
	move.l 	d1, -(sp)
	;d0:	area-x-position
	tst.l	d0
	bge		c_tax_ge
	moveq.l	#0, d0
c_tax_ge:
	move.l	xres, d1
	sub.l	zoom_w_cnt, d1
	cmp.l	d1, d0
	blt		c_tax_lt
	move.l	d1, d0
c_tax_lt:
	move.l  (sp)+,d1
rts


;GET THE REAL X-COORDINATE IN THE PICTURE
c_get_orig_x:
	;d0:	x-mouseposition
	sub.l	orig_x,d0
	add.l	orig_dx,d0
	move.l	zoom_w_cnt, d1
	lsr.l	d1
	sub.l	d1, d0
	
	;test coordinate
	bsr		c_test_area_x
rts


;TEST A Y-AREAPOSITION COORDINATE
c_test_area_y:
	move.l 	d1, -(sp)
	tst.l	d0
	bge		c_tay_ge
	moveq.l	#0, d0
c_tay_ge:
	move.l	yres, d1
	sub.l	zoom_h_cnt, d1
	cmp.l	d1, d0
	blt		c_tay_lt
	move.l	d1, d0
c_tay_lt:
	move.l  (sp)+,d1
rts


;GET THE REAL Y-COORDINATE IN THE PICTURE
c_get_orig_y:
	;d0:	y-mouseposition
	sub.l	orig_y,d0
	add.l	orig_dy,d0
	move.l	zoom_h_cnt, d1
	lsr.l	d1
	sub.l	d1, d0

	;test coordinate
	bsr		c_test_area_y
rts


;GET THE NUMBER OF H.ZOOMED PIXELS OF A MAGNIFY
c_get_zoomwcnt:
	;d0:	magnify
	move.l	d0,d1
	move.l	zoom_w,d0
	divu.l	d1,d0
rts


;GET THE NUMBER OF V.ZOOMED PIXELS OF A MAGNIFY
c_get_zoomhcnt:
	;d0:	magnify
	move.l	d0,d1
	move.l	zoom_h,d0
	divu.l	d1,d0
rts


;GET THE NUMBER OF SCREENELEMENT ON POSITION X,Y
c_get_mouse_area:
	;d0:	x
	;d1:	y
	
	;set result
	moveq.l	#0, d2

	;calculate right boarder of the original field
	move.l	orig_x, d3
	add.l	orig_w, d3
	
	;screenelement = zoomfield?
	cmp.l	zoom_x, d0
	ble		c_gma_no_zoomfield
	cmp.l	zoom_y, d1
	ble		c_gma_no_zoomfield
	moveq.l	#3, d2
	bra		c_gma_finish
c_gma_no_zoomfield:

	;screenelement = h-mover?
	cmp.l	d3, d0
	blt		c_gma_no_h_mover
	cmp.l	zoom_x, d0
	bge		c_gma_no_h_mover
	cmp.l	zoom_y, d1
	ble		c_gma_no_h_mover
	moveq.l	#2, d2
c_gma_no_h_mover:

	;screenelement = original field?
	cmp.l	d3, d0
	bge		c_gma_no_origfield
	cmp.l	orig_y, d1
	ble		c_gma_no_origfield
	moveq.l	#1, d2
c_gma_no_origfield:

c_gma_finish:
	move.l	d2, d0
	;d0:	result (0..nothing,1..orig.field,2..h-mover,3..zoomfield)
rts



;ROUTINE DRAWS ZOOM
c_draw_all:

	;parameters
	;d0:	x
	;d1:	y
	
	;push	registers 
	movem.l	d0-a6, -(sp)

	;initialize
	jsr		c_draw_init

	;draw original-field
	jsr		c_draw_orig
	
	;draw position-rectangle
	jsr		c_draw_rect
	
	;draw zoom-field
	jsr		c_draw_magn

	;pull registers
	movem.l	(sp)+, d0-a6
rts


c_draw_centre:
	;d0: mouse-centre x
	;d1: mouse-centre y
	exg.l	d0, d1
	
	;get relative pixelcoordinate
	bsr		c_get_rel_y
	;d0:	relative y-position
	
	add.l	area_y, d0
	;d0:	absolute y-position
	
	;centre coordinates	
	move.l	zoom_h_cnt,d2
	lsr.l	d2
	sub.l	d2, d0

	;test position
	bsr		c_test_area_y
	
	exg.l	d0, d1

	;get relative pixelcoordinate
	bsr		c_get_rel_x
	;d0:	relative x-position
	
	add.l	area_x, d0
	;d0:	absolute x-position
	
	;centre coordinates	
	move.l	zoom_w_cnt,d2
	lsr.l	d2
	sub.l	d2, d0

	;test position
	bsr		c_test_area_x
	
	;d0:	new x position of the zoomed area
	;d1:	new y position of the zoomed area
	
	bsr		c_draw_all
rts



;DRAW-INITIALISATION
c_draw_init:
	move.l	magnify, d3

	;calculate number of vert. and horiz. magn.pixels
	move.l	zoom_w, d4
	divu.l	d3, d4
	move.l	d4, zoom_w_cnt
	move.l	zoom_h, d5
	divu.l	d3, d5
	move.l	d5, zoom_h_cnt
rts



;ROUTINE DRAWS ORIGINAL FIELD
c_draw_orig:
	movem.l	d0-d1, -(sp)

	movea.l	picadr, a0
	movea.l	scradr, a1
	
	;d0:	x-position of the zoom
	;d1:	y-position of the zoom
	;a0:	picture-adress
	;a1:	screen-adress

	;calculate horizontal position of the originalfield
	move.l	orig_w, d2							;width of originalfield
	sub.l	zoom_w_cnt, d2						;- number of hor.zoomed pixels
	lsr.l	d2									;/ 2
	sub.l	d2, d0								;decrem.xpos.of zoomarea
	;d0:	horizontal position

	;test horizontal position
	bge		c_draw_orig_x_ge					;xpos > 0 ?
	moveq	#0, d0
c_draw_orig_x_ge:
	move.l	xres, d2							;xpos < (xres-orig_w) ?
	sub.l	orig_w, d2
	cmp.l	d2, d0
	blt		c_draw_orig_x_lt
	move.l	d2, d0
c_draw_orig_x_lt:
	move.l	d0, orig_dx
	
	;calculate vertical position of the originalfield
	move.l	orig_h, d2							;height of originalfield
	sub.l	zoom_h_cnt, d2						;- number of vert.zoomed pixels
	lsr.l	d2									;/ 2
	sub.l	d2, d1								;decrem.xpos.of zoomarea
	;d1:	vertical position

	;test vertical position
	bge		c_draw_orig_y_ge					;ypos > 0 ?
	moveq	#0, d1
c_draw_orig_y_ge:
	move.l	yres, d2							;ypos < (yres-orig_h) ?
	sub.l	orig_h, d2
	cmp.l	d2, d1
	blt		c_draw_orig_y_lt
	move.l	d2, d1
c_draw_orig_y_lt:
	move.l	d1, orig_dy

	;calculate startadress in picture
	mulu.l	xres, d1							;y*xres
	add.l	d1, d0								;+x
	lsl.l	d0									;*2 (pixel = word)
	adda.l	d0, a0	
	;a0:	Startadress in the picture

	;calculate picture-lineoffset
	move.l	xres, d2
	sub.l	orig_w, d2
	lsl.l	#1, d2
	
	;calculate screen-lineoffset
	move.l	#320, d4
	sub.l	orig_w, d4
	lsl.l	#1, d4
	
	;calculate startadress in screen (originalfield-position on screen)
	adda.l	scr_orig_pos, a1

	;drawing-loops
	move.l	orig_w, d3
	lsr.l	#1, d3								;move 2 pixels
	subq.l	#1, d3
	move.l	orig_h, d0
	subq.l	#1, d0
c_draw_orig_y:

	move.w	d3, d1
c_draw_orig_x:

	move.l	(a0)+, (a1)+

	dbf		d1, c_draw_orig_x

	;add lineoffsets
	adda.l	d2, a0
	adda.l	d4, a1

	dbf		d0, c_draw_orig_y
	movem.l	(sp)+,d0-d1
rts



;ROUTINE DRAWS RECTANGLE (TO SHOW THE ZOOMED AREA)
c_draw_rect:
	movem.l	d0-d1, -(sp)

	movea.l	picadr, a0
	movea.l	scradr, a1
	
	;d0:	x-position of the zoom
	;d1:	y-position of the zoom
	;a0:	picture-adress
	;a1:	screen-adress

	;calculate koordinates
	sub.l	orig_dx, d0
	sub.l	orig_dy, d1
	subq.l	#1, d0		
	subq.l	#1, d1

	;add position-offset to screenadress
	adda.l	scr_orig_pos, a1
	
	;calculate first adress
	move.l	d1, d2
	mulu.l	#320, d2
	add.l	d0, d2
	lsl.l	d2
	adda.l	d2, a1
	;a1:	first adress of the rect.
	
	;draw horizontal lines
	move.l	a1, a2
	move.l	zoom_h_cnt, d3
	mulu.l	#640, d3

	;draw left line
	tst.l	d0
	blt		c_draw_rect_no_left
	move.l	zoom_h_cnt, d2
	subq.l	#1, d2
	move.l	a1, a2
	adda.l	#2*320, a2
c_draw_rect_left:
	not.w	(a2)
	adda.l	#2*320, a2
	dbf		d2, c_draw_rect_left	
c_draw_rect_no_left:
	
	;draw right line
	add.l	zoom_w_cnt, d0
	addq.l	#1, d0
	cmp.l	orig_w, d0
	bge		c_draw_rect_no_right
	move.l	zoom_h_cnt, d2
	subq.l	#1, d2
	move.l	a1, a2
	adda.l	zoom_w_cnt, a2
	adda.l	zoom_w_cnt, a2
	addq.l	#2, a2
	adda.l	#2*320, a2
c_draw_rect_right:
	not.w	(a2)
	adda.l	#2*320, a2
	dbf		d2, c_draw_rect_right
c_draw_rect_no_right:

	;draw high line
	tst.l	d1
	blt		c_draw_rect_no_high
	move.l	zoom_w_cnt, d2
	subq.l	#1, d2
	move.l	a1, a2
	adda.l	#2, a2
c_draw_rect_high:
	not.w	(a2)+
	dbf		d2, c_draw_rect_high
c_draw_rect_no_high:

	;draw low line
	add.l	zoom_h_cnt, d1
	addq.l	#1, d1
	cmp.l	orig_h, d1
	bge		c_draw_rect_no_low
	move.l	zoom_w_cnt, d2
	subq.l	#1, d2
	move.l	a1, a2
	addq.l	#2, a2	
	move.l	zoom_h_cnt, d1
	addq.l	#1, d1
	mulu.l	#2*320, d1
	adda.l	d1, a2
c_draw_rect_low:
	not.w	(a2)+
	dbf		d2, c_draw_rect_low	
c_draw_rect_no_low:
	movem.l	(sp)+,d0-d1
rts



;ROUTINE DRAWS THA ZOOM-FIELD
c_draw_magn:
	move.l	d7,-(sp)
	movea.l	picadr, a0
	movea.l	scradr, a1
	move.l	gridflag, d2
	move.l	magnify, d3
	
	;d0:	x-position of the zoom
	;d1:	y-position of the zoom
	;d2:	grid-flag
	;d3:	zoom-magnify
	;a0:	picture-adress
	;a1:	screenadress
	
	move.l	d0, area_x
	move.l	d1, area_y

	;calculate startadress in picture
	mulu.l	xres, d1						;y*x_resolution
	add.l	d0,d1							;+x
	lsl.l	#1, d1							;*2 (1 pixel = 1 word)
	adda.l	d1, a0
	;a0:	startadress
	
	;add. startoffset to screen
	adda.l	scr_zoom_pos, a1

	;set counters
	move.l	zoom_w_cnt, d4
	move.l	zoom_h_cnt, d5

	;calculate picture lineoffset
	move.l	xres, d0							;picture size
	sub.w	d4, d0								;-number of zoomed pixels
	lsl.l	#1, d0								;*2 (pixel = word)
	move.l	d0, pic_lineoffset
	
	;calculate screen lineoffset
	move.l	#320, d0							;number of pixels per line
	move.w	d4, d1
	mulu.w	d3, d1
	sub.w	d1, d0								;-number of zoomed pixels * magnify
	lsl.l	#1, d0								;*2 (pixel = word)
	move.l	#320*2, d1							;+(screenlinelength * (magnify-1))
	mulu.l	d3, d1
	sub.l	#320*2, d1
	add.l	d1, d0
	move.l	d0, scr_lineoffset
	
	;set pixelrout-adr.
	bsr		c_set_pix_adr
	;a2:	adress of the current pixeldrawrout.
	move.l	a2,pixadr

	;drawing-loops
	subq.w	#1, d4								;modify x-counter (dbra)
	subq.w	#1, d5								;modify y-counter (dbra)
c_draw_magn_loop_y:
	move.w	d4, d6								;reset x-counter
c_draw_magn_loop_x:	
	;draw zoompixel with the current pixelroutine
	jsr		(a2)
	dbf		d6, c_draw_magn_loop_x
	adda.l	pic_lineoffset, a0					;add lineoffset to picture
	adda.l	scr_lineoffset, a1					;add lineoffset to screen
	dbf		d5, c_draw_magn_loop_y
	move.l	(sp)+,d7
rts



;ROUTINE SETS THE ADRESS OF THE NEEDED PIXELROUTINE
c_set_pix_adr:
	move.l	gridflag, d2
	move.l	magnify, d3
	
	tst.l	d2									;test gridflag
	bne		c_draw_rout_grid
c_draw_rout_nogrid:
	cmpi.l	#3, d3								;test magnify
	bne		c_draw_rout_no_3
	lea		c_draw_3_pix, a2					;magn=3, no grid
	rts
c_draw_rout_no_3:
	cmpi.l	#5, d3
	bne		c_draw_rout_no_5
	lea		c_draw_5_pix, a2					;magn=5, no grid
	rts
c_draw_rout_no_5:
	cmpi.l	#7, d3
	bne		c_draw_rout_no_7
	lea		c_draw_7_pix, a2					;magn=7, no grid
	rts
c_draw_rout_no_7:
	cmpi.l	#9, d3
	bne		c_draw_rout_no_9
	lea		c_draw_9_pix, a2					;magn=9, no grid
	rts
c_draw_rout_no_9:
	
c_draw_rout_grid:
	cmpi.l	#3, d3								;test magnify
	bne		c_draw_rout_no_3g
	lea		c_draw_3g_pix, a2					;magn=3, grid
	rts
c_draw_rout_no_3g:
	cmpi.l	#5, d3
	bne		c_draw_rout_no_5g
	lea		c_draw_5g_pix, a2					;magn=5, grid
	rts
c_draw_rout_no_5g:
	cmpi.l	#7, d3
	bne		c_draw_rout_no_7g
	lea		c_draw_7g_pix, a2					;magn=7, grid
	rts
c_draw_rout_no_7g:
	cmpi.l	#9, d3
	bne		c_draw_rout_no_9g
	lea		c_draw_9g_pix, a2					;magn=9, grid
	rts
c_draw_rout_no_9g:
	;a2:	Adress of the used routine
rts



;DRAWS A 3x3 MAGNIFIED PIXEL WITHOUT GRID
c_draw_3_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	REPT	3									;draw pixelblock
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	addq.l	#2, a1								;inc. destinationadress
	ENDM
rts



;DRAWS A 5x5 MAGNIFIED PIXEL WITHOUT GRID
c_draw_5_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	REPT	5									;draw pixelblock
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	move.w	d0, 3*640(a1)
	move.w	d0, 4*640(a1)
	addq.l	#2, a1								;inc. destinationadress
	ENDM
rts



;DRAWS A 7x7 MAGNIFIED PIXEL WITHOUT GRID
c_draw_7_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	move.l	#7-1,d7
c_draw_7_pix_loop:
	move.w	d0, (0*640,a1,d7.l*2)
	move.w	d0, (1*640,a1,d7.l*2)
	move.w	d0, (2*640,a1,d7.l*2)
	move.w	d0, (3*640,a1,d7.l*2)
	move.w	d0, (4*640,a1,d7.l*2)
	move.w	d0, (5*640,a1,d7.l*2)
	move.w	d0, (6*640,a1,d7.l*2)
	;addq.l	#2, a1								;inc. destinationadress
	dbf		d7, c_draw_7_pix_loop
	adda.l	#7*2, a1							;inc. destinationadress
rts


;DRAWS A 9x9 MAGNIFIED PIXEL WITHOUT GRID
c_draw_9_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	move.w	#9-1,d7
c_draw_9_pix_loop:
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	move.w	d0, 3*640(a1)
	move.w	d0, 4*640(a1)
	move.w	d0, 5*640(a1)
	move.w	d0, 6*640(a1)
	move.w	d0, 7*640(a1)
	move.w	d0, 8*640(a1)
	addq.l	#2, a1								;inc. destinationadress
	dbf		d7,c_draw_9_pix_loop
rts


;DRAWS A 3x3 MAGINIFIED PIXEL WITH GRID
c_draw_3g_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	REPT	2									;draw pixelblock
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	clr.w	2*640(a1)							;grid
	addq.l	#2, a1								;inc. destinationadress
	ENDM
	clr.w	0*640(a1)							;clear vert. line (grid)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	addq.l	#2, a1								;inc. destinationadress
rts



;DRAWS A 5x5 MAGINIFIED PIXEL WITH GRID
c_draw_5g_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	REPT	4									;draw pixelblock
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	move.w	d0, 3*640(a1)
	clr.w	4*640(a1)							;grid
	addq.l	#2, a1								;inc. destinationadress
	ENDM
	clr.w	0*640(a1)							;clear vert. line (grid)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	addq.l	#2, a1								;inc. destinationadress
rts


;DRAWS A 7x7 MAGINIFIED PIXEL WITH GRID
c_draw_7g_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	REPT	6									;draw pixelblock
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	move.w	d0, 3*640(a1)
	move.w	d0, 4*640(a1)
	move.w	d0, 5*640(a1)
	clr.w	6*640(a1)							;grid
	addq.l	#2, a1								;inc. destinationadress
	ENDM
	clr.w	0*640(a1)							;clear vert. line (grid)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	clr.w	5*640(a1)
	clr.w	6*640(a1)
	addq.l	#2, a1								;inc. destinationadress
rts


;DRAWS A 9x9 MAGINIFIED PIXEL WITH GRID
c_draw_9g_pix:
	;a0:	Source (1 pixel)
	;a1:	Destination (magn*magn pixels)
	move.w	(a0)+, d0							;get color
	move.w	#8-1,d7
c_draw_9g_pix_loop:
	move.w	d0, 0*640(a1)
	move.w	d0, 1*640(a1)
	move.w	d0, 2*640(a1)
	move.w	d0, 3*640(a1)
	move.w	d0, 4*640(a1)
	move.w	d0, 5*640(a1)
	move.w	d0, 6*640(a1)
	move.w	d0, 7*640(a1)
	clr.w	8*640(a1)							;grid
	addq.l	#2, a1								;inc. destinationadress
	dbf		d7,c_draw_9g_pix_loop
	clr.w	0*640(a1)							;clear vert. line (grid)
	clr.w	1*640(a1)
	clr.w	2*640(a1)
	clr.w	3*640(a1)
	clr.w	4*640(a1)
	clr.w	5*640(a1)
	clr.w	6*640(a1)
	clr.w	7*640(a1)
	clr.w	8*640(a1)
	addq.l	#2, a1								;inc. destinationadress
rts


;CALCULATES THE RELATIVE PIXELPOSITION OF THE PIXEL UNDER THE MOUSE
c_get_rel_x:
	;d0:	x-mouseposition
	move.l	d3,-(sp)

	;calculate relative pixelcoordinates
	sub.l	zoom_x, d0
	divs.l	magnify, d0							;relative x

	;test coordinates
	tst.l	d0									;x<0 ?
	bge		c_sp_ge_w
	moveq.l	#0, d0								;-> x=0
c_sp_ge_w:
	move.l	zoom_w_cnt,d3
	subq.l	#1, d3
	cmp.l	d3,d0								;x>number of hor.zoomed pixels ?
	blt		c_sp_lt_w
	move.l	d3,d0								;-> x=numb.of.hor.zoomed pixels
c_sp_lt_w:
	move.l	(sp)+,d3
	;d0:	result: relative pixel	x-position
rts


;CALCULATES THE RELATIVE PIXELPOSITION OF THE PIXEL UNDER THE MOUSE
c_get_rel_y:
	;d0:	y-mouseposition
	move.l	d3,-(sp)

	;calculate relative pixelcoordinates
	sub.l	zoom_y, d0
	divs.l	magnify, d0							;relative y

	;test coordinates
	tst.l	d0									;y<0 ?
	bge		c_sp_ge_h
	moveq.l	#0, d0								;-> x=0
c_sp_ge_h:
	move.l	zoom_h_cnt,d3
	subq.l	#1, d3
	cmp.l	d3,d0								;y>number of ver.zoomed pixels ?
	blt		c_sp_lt_h
	move.l	d3,d0								;-> y=numb.of.ver.zoomed pixels
c_sp_lt_h:
	move.l	(sp)+,d3
	;d0:	result: relative pixel	y-position
rts


;DRAWS A SINGLE PIXEL IN ZOOM AND ORIGINALFIELD
c_setpixel:
	;d0:	x-mouseposition
	;d1:	y-mouseposition
	;d2:	color

	bsr		c_get_rel_x
	move.l	d0, d3
	move.l	d1, d0
	bsr		c_get_rel_y
	move.l	d0, d4
	;d3:	relative x-pixelcoord.
	;d4:	relative y-pixelcoord.

	;save coordinates
	move.l	d3,d0
	move.l	d4,d1

	;calculate absolute screen-coordinates of the pixel (originalfield)
	add.l	area_x, d0
	sub.l	orig_dx, d0
	add.l	orig_x, d0
	add.l	area_y, d1
	sub.l	orig_dy, d1
	add.l	orig_y, d1
	
	;set pixel in original-field
	mulu.l	#320, d1
	add.l	d0, d1
	lsl.l	d1
	move.l	scradr, a0
	adda.l	d1, a0
	move.w	d2, (a0)

	;calculate absolute screen-coordinates of the pixel (zoomfield)
	move.l	magnify, d0
	move.l	d0, d1
	mulu.l	d4, d0
	add.l	zoom_y, d0
	mulu.l	#320, d0
	mulu.l	d3, d1
	add.l	zoom_x, d1
	add.l	d1, d0
	lsl.l	d0									;2*magnify*(320*y+x)+zoomposition
	movea.l	scradr, a1
	add.l	d0, a1								;destinationadr.
	
	;a0:	source
	;a1:	destination
	;a2:	zoom-pixelrout.
	
	;set zoompixel
	move.l	pixadr, a2
	jsr		(a2)
rts



;GET COLOR OF THE PIXEL ON MOUSEPOSITION
c_getpixel:
	;d0:	x-mouseposition
	;d1:	y-mouseposition
	
	;get relative pixelcoordinates
	bsr		c_get_rel_x
	exg.l	d0, d1
	bsr		c_get_rel_y
	;d0:	relative y-position
	;d1:	relative x-position
	
	;calculate pixelpostion on the screen (original field)
	add.l	area_x, d1
	sub.l	orig_dx, d1
	add.l	orig_x, d1
	add.l	area_y, d0
	sub.l	orig_dy, d0
	add.l	orig_y, d0
	
	;calculate pixeladress
	mulu.l	#320, d0
	add.l	d1, d0
	lsl.l	d0
	movea.l	scradr, a0
	adda.l	d0, a0
	
	;get pixelcolor
	move.w	(a0), d0
rts




c_floodfill:
	movem.l	d3-d7/a2-a6,-(sp)
	;d0:	x (mouseposition in zoomarea)
	;d1:	y
	;d2:	color
	;a0:	stackadress

	bsr		c_get_rel_x
	move.l	d0, d3
	move.l	d1, d0
	bsr		c_get_rel_y
	move.l	d0, d1
	move.l	d3,d0
	;d0:	relative x-pixelcoord.
	;d1:	relative y-pixelcoord.

	;calculate position of original field
;	move.l	area_y,d3
;	;sub.l	orig_dy,d3
;	;add.l	orig_y,d3
;	mulu.l	#320,d3
;	add.l	area_x,d3
;	;sub.l	orig_dx,d3
;	;add.l	orig_x,d3	
;	lsl.l	d3

move.l	orig_y,d3
add.l	area_y,d3
sub.l	orig_dy,d3
mulu.l	#320,d3
add.l	orig_x,d3
add.l	area_x,d3
sub.l	orig_dx,d3
lsl.l	d3
;add.l	scr_orig_pos,d3


	movea.l	a0,a1
	movea.l	scradr,a0
	add.l	d3,a0
	move.l	a0,a6

	;neuen Stack initialisieren
	move.l	sp,old_stack
	move.l	a1,new_stack
	adda.l	#100000,a1
	move.l	a1,sp
	
	;Farbe unter Startpunkt ermitteln
	move.l	d1,d3
	mulu.l	#320,d3
	add.l	d0,d3
	move.w (a0,d3.l*2),d7

	cmp.w	d2,d7
	beq		c_floodfill_end

	;rekursive Routine aufrufen
	bsr		c_f_draw_hline

	;Zoom neu zeichnen
	move.l	gridflag, d2
	move.l	magnify, d3
	move.l	a6,a0								;source-startadress (original field)
	movea.l	scradr,a1							;add. startoffset to screen
	adda.l	scr_zoom_pos, a1
	move.l	zoom_w_cnt, d4						;set counters
	move.l	zoom_h_cnt, d5
	move.l	#320, d0							;calculate picture lineoffset
	sub.w	d4, d0								;-number of zoomed pixels
	lsl.l	#1, d0								;*2 (pixel = word)
	move.l	d0, pic_lineoffset
	move.l	#320, d0							;calculate screen lineoffset
	move.w	d4, d1								;number of pixels per line
	mulu.w	d3, d1
	sub.w	d1, d0								;-number of zoomed pixels * magnify
	lsl.l	#1, d0								;*2 (pixel = word)
	move.l	#320*2, d1							;+(screenlinelength * (magnify-1))
	mulu.l	d3, d1
	sub.l	#320*2, d1
	add.l	d1, d0
	move.l	d0, scr_lineoffset
	bsr		c_set_pix_adr						;set pixelrout-adr.
	;a2:	adress of the current pixeldrawrout.
	move.l	a2,pixadr
	;drawing-loops
	subq.w	#1, d4								;modify x-counter (dbra)
	subq.w	#1, d5								;modify y-counter (dbra)
c_fill_magn_loop_y:
	move.w	d4, d6								;reset x-counter
c_fill_magn_loop_x:	
	;draw zoompixel with the current pixelroutine
	jsr		(a2)
	dbf		d6, c_fill_magn_loop_x
	adda.l	pic_lineoffset, a0					;add lineoffset to picture
	adda.l	scr_lineoffset, a1					;add lineoffset to screen
	dbf		d5, c_fill_magn_loop_y
	
c_floodfill_end:
	
	;eigenen Stack deinitialisieren (Wow, klingt das gut!)
	move.l	sp,a0
	move.l	old_stack,sp
	
	movem.l	(sp)+,d3-d7/a2-a6
rts


;rekursive Routine arbeitet Zeilenweise
c_f_draw_hline:

	;Stackpointer mit Stack-Baseadr. vergleichen und bei Stackberlauf Abbruch
	cmpa.l	new_stack,sp
	bgt		c_f_no_stack_overflow
	rts
c_f_no_stack_overflow:

	movem.l	d0/d1/d5/a0/a3,-(sp)

	;d0:	x
	;d1:	y
	;d2:	Fllfarbe
	;d7:	Hintergrundfarbe

c_f_dhl_loop:

	;aktive Pixeladresse berechnen
	move.l	d1,d3
	mulu.l	#640,d3
	movea.l	a0,a3
	adda.l	d3,a3

	;linke Seite vom aktiven Pixel abfahren
	move.l	d0,-(sp)
c_f_dhl_leftloop:

	;hat Pixel gleiche Farbe wie Startpunkt? Nein->Flchengrenze erreicht.
	cmp.w	(a3,d0.l*2),d7
	bne		c_f_dhl_leftloop_end

	;Zeichenfarbe setzen
	move.w	d2,(a3,d0.l*2)

	;hat unteres Pixel gl.Farbe wie Startpunkt?...
	cmp.w	(640,a3,d0.l*2),d7
	bne		c_f_dhl_leftloop_nodown
	;...und rechtes, unteres Pixel nicht? -> Flche verzweigt sich!
	cmp.w	(642,a3,d0.l*2),d7
	beq		c_f_dhl_leftloop_nodown
	move.l	d1,d5
	addq.l	#1,d1
	;cmpi.l	#240,d1					;Bildschirmgrenze
	cmp.l	zoom_h_cnt,d1
	bge		c_f_dhl_leftloop_nodown
	bsr		c_f_draw_hline				;Rekursion
	move.l	d5,d1
c_f_dhl_leftloop_nodown:

	;hat oberes Pixel gl.Farbe wie Startpunkt?...
	cmp.w	(-640,a3,d0.l*2),d7
	bne		c_f_dhl_leftloop_noup
	;...und rechtes, oberes Pixel nicht? -> Flche verzweigt sich!
	cmp.w	(-638,a3,d0.l*2),d7
	beq		c_f_dhl_leftloop_noup
	move.l	d1,d5
	subq.l	#1,d1						;neues y>0 ?
	blt		c_f_dhl_leftloop_noup
	bsr		c_f_draw_hline
	move.l	d5,d1
c_f_dhl_leftloop_noup:

	;nchstes Pixel...
	subq.l	#1,d0

	;...oder nicht, wenn Bildrand erreicht ist.
	blt		c_f_dhl_leftloop_end
	bra		c_f_dhl_leftloop
c_f_dhl_leftloop_end:


	;rechte Seite vom aktiven Pixel abfahren
	move.l	(sp),d0
	;X um 1 erhhen, da x schon in der linken Seite enthalten war.
	addq.l	#1,d0
	;cmpi.l	#320,d0
	cmp.l	zoom_w_cnt,d0
	bge		c_f_dhl_rightloop_end
c_f_dhl_rightloop:

	;hat Pixel gleiche Farbe wie Startpunkt?
	cmp.w	(a3,d0.l*2),d7
	bne		c_f_dhl_rightloop_end

	;unteres Pixel gleiche Farbe wie Startpunkt und...
	cmp.w	(640,a3,d0.l*2),d7
	bne		c_f_dhl_rightloop_nodown
	;unteres, linkes Pixel nicht -> Flche verzweigt sich -> Rekursion
	cmp.w	(638,a3,d0.l*2),d7
	beq		c_f_dhl_rightloop_nodown
	move.l	d1,d5
	addq.l	#1,d1
	cmp.l	zoom_h_cnt,d1				;neues Y im Bildbereich?
	bge		c_f_dhl_rightloop_nodown
	bsr		c_f_draw_hline
	move.l	d5,d1
c_f_dhl_rightloop_nodown:

	;hat oberes Pixel gleiche Farbe wie Startpunkt...
	cmp.w	(-640,a3,d0.l*2),d7
	bne		c_f_dhl_rightloop_noup
	;...und oberes, linkes Pixel nicht? -> Flche verzweigt sich
	cmp.w	(-642,a3,d0.l*2),d7
	beq		c_f_dhl_rightloop_noup
	move.l	d1,d5
	subq.l	#1,d1
	blt		c_f_dhl_rightloop_noup
	bsr		c_f_draw_hline
	move.l	d5,d1
c_f_dhl_rightloop_noup:

	;Pixel zeichnen
	move.w	d2,(a3,d0.l*2)

	;nchstes Pixel
	addq.l	#1,d0
	;cmpi.l	#320,d0
	cmp.l	zoom_w_cnt,d0
	bge		c_f_dhl_rightloop_end
	bra		c_f_dhl_rightloop
c_f_dhl_rightloop_end:

	move.l 	(sp)+,d0
	
	;geht Flche nach unten weiter?
	cmp.w	(640,a3,d0.l*2),d7
	bne		c_f_dhl_nodown
	move.l	d1,d5
	addq.l	#1,d1
	;cmpi.l	#240,d1
	cmp.l	zoom_h_cnt,d1
	bge		c_f_dhl_nodown
	bsr		c_f_draw_hline
	move.l	d5,d1
c_f_dhl_nodown:

	;geht Fche nach oben weiter?
	cmp.w	(-640,a3,d0.l*2),d7
	bne		c_f_dhl_noup
	move.l	d1,d5
	subq.l	#1,d1
	blt		c_f_dhl_noup
	bra		c_f_dhl_loop
	move.l	d5,d1
c_f_dhl_noup:
	
	movem.l	(sp)+,d0/d1/d5/a0/a3
rts

old_stack:	ds.l	1
new_stack:	ds.l	1



;COPIES SCREENDATA TO PICTUREMEMORY (FOR UNDO-FUNCTION)
c_pushdata:
	;calculate screenadress of zoomed area (original field)
	move.l	area_x, d0
	sub.l	orig_dx, d0
	add.l	orig_x, d0
	move.l	area_y, d1
	sub.l	orig_dy, d1
	add.l	orig_y, d1
	mulu.l	#320, d1
	add.l	d1, d0
	lsl.l	d0
	;d0:	offset to the first pixel
	movea.l	scradr, a0
	adda.l	d0, a0
	;a0:	first source adress

	;calculate pictureadress of the zoomed area (destination)
	move.l	area_x, d0
	move.l	area_y, d1
	mulu.l	xres, d1
	add.l	d1, d0
	lsl.l	d0
	;d0:	offset to the first pixel
	move.l	picadr, a1
	adda.l	d0, a1
	;a1:	first destination adress
	
	;calculate screen lineoffset
	move.l	#320, d0
	sub.l	zoom_w_cnt, d0
	lsl.l	d0
	;d0:	screen lineoffset
	
	;calculate picture lineoffset
	move.l	xres, d1
	sub.l	zoom_w_cnt, d1
	lsl.l	d1
	;d1:	picture lineoffset

	;get loopcounters
	move.l	zoom_w_cnt, d2
	subq.l	#1, d2
	move.l	zoom_h_cnt, d3
	subq.l	#1, d3								;number of ver.pixels (y-counter)

	;copy loops
c_push_yloop:
	move.l	d2, d4								;number of hor.pixels (x-counter)
c_push_xloop:
	;copy one pixel
	move.w	(a0)+, (a1)+
	dbf		d4, c_push_xloop

	;add lineoffsets
	adda.l	d0, a0
	adda.l	d1, a1
	dbf		d3, c_push_yloop
rts



;UNDO FUNCTION
c_pulldata:
	;redraw zoomfield
	move.l	area_x, d0
	move.l	area_y, d1
	bsr		c_draw_magn

	;calculate screenadress of zoomed area (original field)
	move.l	area_x, d0
	sub.l	orig_dx, d0
	add.l	orig_x, d0
	move.l	area_y, d1
	sub.l	orig_dy, d1
	add.l	orig_y, d1
	mulu.l	#320, d1
	add.l	d1, d0
	lsl.l	d0
	;d0:	offset to the first pixel
	movea.l	scradr, a0
	adda.l	d0, a0
	;a0:	first source adress

	;calculate pictureadress of the zoomed area (destination)
	move.l	area_x, d0
	move.l	area_y, d1
	mulu.l	xres, d1
	add.l	d1, d0
	lsl.l	d0
	;d0:	offset to the first pixel
	move.l	picadr, a1
	adda.l	d0, a1
	;a1:	first destination adress
	
	;calculate screen lineoffset
	move.l	#320, d0
	sub.l	zoom_w_cnt, d0
	lsl.l	d0
	;d0:	screen lineoffset
	
	;calculate picture lineoffset
	move.l	xres, d1
	sub.l	zoom_w_cnt, d1
	lsl.l	d1
	;d1:	picture lineoffset

	;get loopcounters
	move.l	zoom_w_cnt, d2
	subq.l	#1, d2
	move.l	zoom_h_cnt, d3
	subq.l	#1, d3								;number of ver.pixels (y-counter)

	;pull loops
c_pull_yloop:
	move.l	d2, d4								;number of hor.pixels (x-counter)
c_pull_xloop:
	;pull one pixel
	move.w	(a0), d5
	move.w	(a1), (a0)+
	move.w	d5, (a1)+
	dbf		d4, c_pull_xloop

	;add lineoffsets
	adda.l	d0, a0
	adda.l	d1, a1
	dbf		d3, c_pull_yloop
rts


;CLEARS THE ZOOM-SCREENPART
c_del_zoom:
	;a0:	screenadress
	
	;calculate the first adress
	adda.l	scr_orig_pos,a0
	;a0:	first adress
	
	move.l	orig_h,d0
	mulu.l	#160,d0
	subq.l	#1,d0
c_del_zoom_loop:

	clr.l	(a0)+

	dbf		d0,c_del_zoom_loop
rts



BSS

xres:			ds.l	1				;horiz. picture size
yres:			ds.l	1				;vert. picture size
picadr:			ds.l	1				;picture-adress
scradr:			ds.l	1				;screen-adress
magnify:		ds.l	1				;zoom-magnify
gridflag:		ds.l	1				;zoomgrid on/off-flag
pic_lineoffset:	ds.l	1				;picture-lineoffset
scr_lineoffset: ds.l	1				;screen-lineoffset
scr_orig_pos:	ds.l	1				;scr.startoffset (originalfieldpos.)
orig_x:			ds.l	1				;x-scr.position of the originalfield
orig_y:			ds.l	1				;y-scr.position	of the originalfield
orig_w:			ds.l	1				;width of the originalfield
orig_h:			ds.l	1				;height of the originalfield
orig_dx:		ds.l	1				;x-position of the orig-view
orig_dy:		ds.l	1				;y-position of the orig-view
scr_zoom_pos:	ds.l	1				;scr.startoffset (zoomposition)
zoom_x:			ds.l	1				;x-scr.position of the zoomfield
zoom_y:			ds.l	1				;y-scr.position of the zoomfield
zoom_h:			ds.l	1				;height of the zoomfield
zoom_w:			ds.l	1				;width of the zoomfield
zoom_h_cnt:		ds.l	1				;number of magn.pixels per column
zoom_w_cnt:		ds.l	1 				;number of magn.pixels per line
area_x:			ds.l	1				;x-pos. of magnified area
area_y:			ds.l	1				;y-pos. of magnified area
pixadr:			ds.l	1				;adr. of the used zoompixelrout.

END * OF * FILE