export num_output


TEXT



;ROUTINE ZUM AUSGEBEN EINER HCHSTENS 4-STELLIGEN ZAHL AUF DEM BILDSCHIRM
num_output:
	move.l	4(sp), d3
	move.l	8(sp), d4
	;d0:	x
	;d1:	y
	;d2:	Zahl
	;d3:	Anzahl der dargestellten Ziffern
	;d4:	Zusatzzeichen (1..x,2..y,3..dx,4..dy,Bit4..%)
	;a0:	Screen
	
	;Adresse auf dem Bildschirm berechnen
	add.l	d0, d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Adresse
	
	;eventuell Symbol zeichnen
	move.l	d4, d5
	bclr.l	#4, d4
	cmpi.l	#0, d4					;kein Zeichen
	beq		numo_no_symbol
	lea		xdat, a3
	cmpi.l	#1, d4					;x
	beq		numo_draw_symbol
	lea		ydat, a3
	cmpi.l	#2, d4					;y
	beq		numo_draw_symbol
	lea		dxdat, a3
	cmpi.l	#3, d4					;dx
	beq		numo_draw_symbol
	lea		dydat, a3
	cmpi.l	#4, d4					;dy
	beq		numo_draw_symbol
numo_draw_symbol:
	move.l	a0, a2
	jsr		draw_symbol
	adda.l	#16, a0
numo_no_symbol:
	
	;Anzahl der Stellen...
	cmpi.l	#1, d3
	beq		numo_only_1
	cmpi.l	#2, d3
	beq		numo_only_10
	cmpi.l	#3, d3
	beq		numo_only_100
	
	;Erste Ziffer = Tausenderstelle
	divu.w	#1000, d2						;Rest : Hiword
	clr.l	d0
	move.w	d2, d0
	move.l	a0, a2
	jsr		draw_onenum

	;nchste Ziffer -> Positionsadresse erhhen
	addq.l	#8, a0

	;Zweite Ziffer = Hunderterstelle
	swap	d2								;Rest -> Lowword
	andi.l	#$0000FFFF, d2					;Loword ausmaskieren
numo_only_100:
	divu.w	#100, d2
	clr.l	d0
	move.w	d2, d0
	move.l	a0, a2
	jsr		draw_onenum

	;nchste Ziffer
	addq.l	#8, a0
	
	;Dritte Ziffer = Zehnerstelle
	swap	d2
	andi.l	#$0000FFFF, d2
numo_only_10:
	divu.w	#10, d2
	clr.l	d0
	move.w	d2, d0
	move.l	a0, a2
	jsr		draw_onenum

	;nchste Ziffer
	addq.l	#8, a0
	
	;Vierte Ziffer = Einerstelle
	swap	d2
	andi.l	#$0000FFFF, d2
numo_only_1:
	move.l	d2, d0
	move.l	a0, a2
	jsr		draw_onenum

	addq.l	#8, a0

	cmpi.l	#4, d5
	ble		numo_no_percent
	move.l	a0, a2
	lea		pcdat, a3
	jsr		draw_symbol
numo_no_percent:

rts


;ROUTINE ZUM ZEICHNEN EINER ZIFFER
draw_onenum:
	;d0:	Ziffer
	;a2:	Adresse auf dem Bildschirm
	
	;Adresse der Zifferdaten ermitteln
	lea		fntdat, a1
	;asl.l	#3, d0
	mulu.l	#5, d0
	adda.l	d0, a1
	;a1:	Zifferadresse
	
	;Ziffer zeichnen (XOR oder so)
	move.l	#5-1, d0					;Ziffer hat 8 Zeilen
don_y_loop:

	;Bits in den Zifferndaten testen und enspr. Pixel setzen
	move.b	(a1), d1					;Zifferzeile-Daten
	
	btst.b	#0, d1
	beq		don_no_0_bit				;0. Bit gesetzt ?
	not.w	4(a2)
don_no_0_bit:

	btst.b	#1, d1
	beq		don_no_1_bit				;1. Bit ..
	not.w	2(a2)
don_no_1_bit:

	btst.b	#2, d1
	beq		don_no_2_bit				;2. Bit ..
	not.w	0(a2)
don_no_2_bit:

	addq.l	#1, a1						;nchste Ziffernzeile
	adda.l	#2*320, a2					;nchste Screenzeile
	
	dbf		d0, don_y_loop

rts


;ROUTINE ZUM ZEICHNEN EINES EXTRAZEICHENS
draw_symbol:
	;a2:	Zieladresse auf dem Bildschirm
	;a3:	Quelladresse des Zeichens
	
	;Zeichen zeichnen (XOR oder so)
	move.l	#5-1, d0					;Zeichen hat 5 Zeilen
dsy_y_loop:

	;Bits in den Zeichendaten testen und enspr. Pixel setzen
	move.b	(a3), d1					;Zeichenzeile-Daten
	
	btst.b	#0, d1
	beq		dsy_no_0_bit				;0. Bit gesetzt ?
	not.w	12(a2)
dsy_no_0_bit:

	btst.b	#1, d1
	beq		dsy_no_1_bit				;1. Bit ..
	not.w	10(a2)
dsy_no_1_bit:

	btst.b	#2, d1
	beq		dsy_no_2_bit				;2. Bit ..
	not.w	8(a2)
dsy_no_2_bit:

	btst.b	#3, d1
	beq		dsy_no_3_bit				;...
	not.w	6(a2)
dsy_no_3_bit:

	btst.b	#4, d1
	beq		dsy_no_4_bit
	not.w	4(a2)
dsy_no_4_bit:

	btst.b	#5, d1
	beq		dsy_no_5_bit
	not.w	2(a2)
dsy_no_5_bit:

	btst.b	#6, d1
	beq		dsy_no_6_bit
	not.w	0(a2)
dsy_no_6_bit:

	addq.l	#1, a3						;nchste Zeichenzeile
	adda.l	#2*320, a2					;nchste Screenzeile
	
	dbf		d0, dsy_y_loop

rts


DATA


;groe Fontdaten fr die Ziffern 0..9
xfntdat:	dc.b	%000,%111,%101,%101,%101,%101,%101,%111
		dc.b	%000,%010,%010,%010,%010,%010,%010,%010
		dc.b	%000,%111,%001,%001,%111,%100,%100,%111
		dc.b	%000,%111,%001,%001,%111,%001,%001,%111
		dc.b	%000,%100,%100,%101,%111,%001,%001,%001
		dc.b	%000,%111,%100,%100,%111,%001,%001,%111
		dc.b	%000,%110,%100,%100,%111,%101,%101,%111
		dc.b	%000,%111,%001,%001,%001,%001,%001,%001
		dc.b	%000,%111,%101,%101,%111,%101,%101,%111
		dc.b	%000,%111,%101,%101,%111,%001,%001,%011

;kleine Fontdaten fr die Ziffern 0..9
fntdat:	dc.b	%111,%101,%101,%101,%111
		dc.b	%010,%010,%010,%010,%010
		dc.b	%111,%001,%111,%100,%111
		dc.b	%111,%001,%111,%001,%111
		dc.b	%100,%101,%111,%001,%001
		dc.b	%111,%100,%111,%001,%111
		dc.b	%110,%100,%111,%101,%111
		dc.b	%111,%001,%001,%001,%001
		dc.b	%111,%101,%111,%101,%111
		dc.b	%111,%101,%111,%001,%011
		
xdat:	dc.b	%000,%000,%101,%010,%101
ydat:	dc.b	%000,%000,%101,%010,%010
dxdat:	dc.b	%0010000,%0010000,%1110101,%1010010,%1110101
dydat:	dc.b	%0010000,%0010000,%1110101,%1010010,%1110010
pcdat:	dc.b	%1000000,%0010000,%0100000,%1000000,%0010000


END