;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINE ZUM FLLEN VON BEGRENZTEN FLCHEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.

export floodfill

INCLUDE "NEWPIXEL.INC"

;ZUM FLLEN EINES BEGRENZTEN BEREICHES (FLOODFILL)
floodfill:
	move.l	4(sp), style
	;d0:	x-Position des Startpunktes
	;d1:	y-Position des Startpunktes
	;d2:	Farbe der Fllung
	;style:	Zeichenmodus
	;a0:	Bildschirmanfangsadresse


	;FARBE UNTER STARTPUNKT BESTIMMEN
	movem.l	d0-d2/a0, -(sp)			;Register pushen
	lsl.l	d0						;Adresse des Startpunktes berechnen
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	move.w	(a0), d3				;Inhalt der Adresse nach d3
	;d3:	Hintergrundfarbe des Startpunktes
	;move.w	d2, (a0)				;Startpunkt einfrben
	movem.l	(sp)+, d0-d2/a0			;Register pullen

	;STARTPUNKT EINFRBEN
	setpix	d0, d1, d2, style, a0
	
	;RESULTIERENDE FARBE UNTER BERCKSICHTIGUNG DES ZEICHENMODUS ALS ZEICHENFARBE
	move.l	d0, d4
	move.l	d1, d5
	bsr		locate
	move.l	a5, d2

	;Zielfarbe und Ausgangsfarbe vergleichen
	cmp.w	d3, d2
	beq		exit_fill
	
	;STACKADRESSEN IN ADRESSREGISTER
	lea		stack1, a3
	lea		stack2, a4
	
	;ANFANGSWERTE
	move.w	d0, (a3)					;Startpunkt auf Stack
	move.w	d1, 2(a3)
	move.l	#1, d6						;Punktezhler auf 1 (Startpunkt)
	
	move.l	#20000, d0					;Maximalanzahl der Schleifendurchlufe
main_floop:

	;ANFANGSADRESSEN DER STACKS PULLEN
	move.l	a3, a1
	move.l	a4, a2
	move.l	#0, d7
	
floop2:
	cmpi.l	#0, d6					;Wenn alle Punkte des Stacks be-
	beq		leave_floop2			;arbeitet wurden, wird Schleife 
									;verlassen
	;KOORDINATEN VOM STACK NEHMEN
	clr.l	d4
	clr.l	d5
	move.w	(a1), x
	move.w	2(a1), y
	;PUNKT 1 EVNTL. ZEICHNEN
	move.w	x, d4					;Koordinaten holen
	move.w	y, d5
	subq.l	#1, d4					;x dekrementieren -> linkes Pixel
	cmpi.w	#0, d4
	blt		no_left_pix				;x < 0 -> Bildschirmrand
	bsr		locate					;Farbe unter linkem Pixel -> a5
	cmpa.w	d3, a5					
	bne		no_left_pix				;Farbe <> Farbe im Startpunkt -> Rand
	bsr		setpixel				;ansonsten Pixel zeichnen und
	;setpix	d4, d5, d2, style, a0
	move.w	d4, (a2)+				;Koordinaten auf Stack
	move.w	d5, (a2)+
	addq.l	#1, d7					;Anzahl der Punkte auf Stack inkrem.
no_left_pix:
	;PUNKT 2 EVNTL. ZEICHNEN
	clr.l	d4
	clr.l	d5
	move.w	x, d4					;Koordinaten holen
	move.w	y, d5
	subq.l	#1, d5					;y dekrementieren -> oberes Pixel
	cmpi.w	#0, d5
	blt		no_upon_pix				;y < 0 -> Bildschirmrand
	bsr		locate					;Farbe unter oberem Pixel -> a5
	cmpa.w	d3, a5
	bne		no_upon_pix				;Farbe <> Farbe im Startpunkt -> Rand
	bsr		setpixel				;ansonsten Pixel zeichnen und
	;setpix	d4, d5, d2, style, a0
	move.w	d4, (a2)+				;Koordinaten auf Stack
	move.w	d5, (a2)+
	addq.l	#1, d7
no_upon_pix:
	;PUNKT 3 EVNTL. ZEICHNEN
	clr.l	d4
	clr.l	d5
	move.w	x, d4					;Koordinaten holen
	move.w	y, d5
	addq.l	#1, d4					;x inkrementieren -> rechtes Pixel
	cmpi.w	#319, d4
	bgt		no_right_pix			;x > 319 -> Bildschirmrand
	bsr		locate					;Farbe unter rechtem Pixel -> a5
	cmpa.w	d3, a5
	bne		no_right_pix			;Farbe <> Farbe im Startpunkt -> Rand
	bsr		setpixel				;ansonsten Pixel zeichnen und
	;setpix	d4, d5, d2, style, a0
	move.w	d4, (a2)+				;Koordinaten auf Stack
	move.w	d5, (a2)+
	addq.l	#1, d7
no_right_pix:
	;PUNKT 4 EVNTL. ZEICHNEN
	clr.l	d4
	clr.l	d5
	move.w	x, d4					;Koordinaten holen
	move.w	y, d5
	addq.l	#1, d5					;y inkrementieren -> unteres Pixel
	cmpi.w	#239, d5
	bgt		no_under_pix			;y > 239 -> Bildschirmrand
	bsr		locate					;Farbe unter unterem Pixel -> a5
	cmpa.w	d3, a5
	bne		no_under_pix			;Farbe <> Farbe im Startpunkt -> Rand
	bsr		setpixel				;ansonsten Pixel zeichnen und
	;setpix	d4, d5, d2, style, a0
	move.w	d4, (a2)+				;Koordinaten auf Stack
	move.w	d5, (a2)+
	addq.l	#1, d7
no_under_pix:
	
	addq.l	#4, a1					;nchster Punkt des Stacks
	subq.l	#1, d6					;Punkt wurde bearbeitet -> dekrem.
	bra		floop2
leave_floop2:

	cmpi.l	#0, d7					;Schleife verlassen wenn keine weiteren
	ble		exit_fill				;Punkte vorhanden, mehr als 100 Punkte
	cmpi.l	#1000, d7				;vorhandlen (Stackberlauf) oder Anzahl
	bgt		exit_fill				;der Schleifendurchlufe > 3000

	exg.l	a3, a4					;Stacks und Punktezhler tauschen
	exg.l	d6, d7
	
	dbf		d0, main_floop
exit_fill:
rts
;ZUM BESTIMMEN DES FARBWERTES BEI DEN KOORDINATEN X;Y
locate:
	;d4:	x-Koordinate
	;d5:	y-Koordinate
	;a0:	Bildschirmanfang
	movem.l	d4-d5/a0, -(sp)
	lsl.l	d4
	mulu.l	#640, d5
	add.l	d4, d5
	adda.l	d5, a0
	move.w	(a0), a5
	movem.l	(sp)+, d4-d5/a0
	;a5:	Farbwert an x;y
rts
;ZUM SETZEN EINES PIXELS BEI X;Y MIT DER FARBE D2
setpixel:
	;d2:	Farbe
	;d4:	x-Koordinate
	;d5:	y-Koordinate
	;a0:	Bildschirmanfang
	movem.l	d4-d5/a0, -(sp)
	lsl.l	d4
	mulu.l	#640, d5
	add.l	d4, d5
	adda.l	d5, a0
	move.w	d2, (a0)
	movem.l	(sp)+, d4-d5/a0
rts
	
	
bss

stack1:	ds.l	4000
stack2: ds.l	4000
x:		ds.l	1
y:		ds.l	1
style:	ds.l	1
end