;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN FR DEN PALETTEN-EDITOR ZUM VERNDERN VON FARBPALETTEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.



globl  px
globl  py

export setcolor
export drawpalette
export drawpalactcol
export markpalcol
export setnewrgb
export palsearch


text


;ZUM ERMITTELN DES RGB-WERTES EINES PALETTENEINTRAGES
setcolor:
	;d0:	Farbnummer in der Palette
	;a0:	Palettenadresse
	asl.l	d0
	adda.l	d0, a0
	clr.l	d0
	move.w	(a0), d0
	;d0:	16-Bit RGB-Wert
rts


;ZUM EINBLENDEN DER PALETTE
drawpalette:
	;a0:	Bildschirmanfangsadresse
	;a1:	Palettenadresse
	move.l	a1, paladr
	move.l	a0, a3					;Register sichern
	move.l	px, d0					;Bildpositionsoffset aus P(px,py)
	move.l	py, d1					;errechen
	addq.l	#2, d0
	addq.l	#3, d1
	lsl.l	d0
	mulu.w	#640, d1
	add.l	d1, d0
	move.l	d0, picoffset
	adda.l	d0, a0					;Bildpositionsoffset addieren
	movea.l	a1, a4					;Farbregister der Farbe 0
	move.l	#3, d3					;Anzahl der Zeilen -1
pal_draw_loop1:
	move.l	#31, d4					;Anzahl	der Farben pro Zeile -1
pal_draw_loop2:
	move.l	#4, d5					;Anzahl der Spalten pro Farbe
pal_draw_loop3:
	move.w	(a4), (a0)				;Farbe zeichnen
	move.w	(a4), 640(a0)			;(5 Punkte untereinander)
	move.w	(a4), 1280(a0)
	move.w	(a4), 1920(a0)
	;move.w	#0, 2560(a0)
	addq.l	#2, a0					;eine Spalte weiter
	dbf		d5, pal_draw_loop3
	addq.l	#2, a0					;eine Spalte Platz lassen
	addq.l	#2, a4					;nchser Farbwert aus Palette
	dbf		d4, pal_draw_loop2
	adda.l	#2816, a0				;Rest der Screenzeile berspringen
	dbf		d3, pal_draw_loop1
rts

;ZUM ZEICHNEN DER AKTUELLEN FARBE RECHTS NEBEN DER PALETTE
drawpalactcol:
	;d0:	aktuelle  Farbe
	;a0:	Bildschirmanfangsadresse
	adda.l	picoffset, a0
	adda.l	#394, a0				;Bildpositionsoffset
	move.l	#18, d4
draw_ac_loop1:
	move.l	#10, d5
draw_ac_loop2:
	move.w	d0, (a0)+				;Punkt setzen
	dbf		d5, draw_ac_loop2
	adda.l	#618, a0				;Rest der Zeile berspringen
	dbf		d4, draw_ac_loop1
rts


;ZUM MARKIEREN EINER FARBE IN DER PALETTE
markpalcol:
	;d0:	Farbe der Markierung
	;d1:	zu markierender Paletteneintrag
	;a0:	Bildschirmadresse
	suba.l	#642, a0
	move.l	d1, d3
	divu.l	#32, d3					;Spalte in der Palette
	move.l	d1, d4
	move.l	d3, d5
	mulu.l	#32, d5
	sub.l	d5, d4
	mulu.l	#12, d4
	mulu.l	#3200, d3				;Zeile
	add.l	d3, d4
	adda.l	d4, a0
	adda.l	picoffset, a0			;Bildpositionsoffset addieren
	move.w	d0, (a0)				;Markierung zeichnen
	move.w	d0, 2(a0)
	move.w	d0, 640(a0)
	move.w	d0, 10(a0)
	move.w	d0,	12(a0)
	move.w	d0,	652(a0)
	move.w	d0, 2560(a0)
	move.w	d0, 3200(a0)
	move.w	d0,	3202(a0)
	move.w	d0, 2572(a0)
	move.w	d0,	3210(a0)
	move.w	d0, 3212(a0)
rts


;SETZT NEUE FARBE DER PALETTE
setnewrgb:
	;d0:	Nummer des Paletteneintrages
	;d1:	Neue Farbe
	;a0:	Palettenadresse
	lsl.l	d0
	adda.l	d0, a0
	move.w	d1, (a0)
rts


;DURCHSUCHT DIE PALETTE NACH EINER FARBE UND LIEFERT DEN PALETTENINDEX
palsearch:
	;d0:	Farbe
	;a0:	Palettenadresse
	
	move.l	#-1,d2
	
	move.l	#128-1, d1
palsearch_loop:

	cmp.w	(a0,d1.l*2),d0
	bne		palsearch_different
	move.l	d1,d2
palsearch_different:

	dbf		d1,palsearch_loop
	move.l	d2,d0
	;result:	Palettenindex oder -1, wenn nix gefunden
rts



bss

paladr:		ds.l 1
picoffset:  ds.l 1

end