;Norman Feske										30.12.95
;Cmmerswalder Str.19
;01189 Dresden /Germany
;Tel.: (0351) 4015284

;E s c A P E   P A I N T   V. 0.2   (Copyright by Norman Feske)
;ROUTINEN ZUM NDERN VON FARBPALETTEN

;sie knnen mit dem Pure Assembler von ASH assembliert werden und
;so von Pure Pascal, Pure C etc. aus genutzt werden.


;FUNKTIONEN ZUR BEARBEITUNG DER PALETTEN-DATEN IM HI-COLOR-MODE
;Aufbau eines Farb-Wortes:
;	FEDCB A98765 43210
;	\   / \    / \   /
;	 ro.   grn.   bl.
	
export get_r
export get_g
export get_b
export set_r
export set_g
export set_b
export drawpeorgpic
export draw_l_red
export draw_l_green
export draw_l_blue
export draw_l_white
export draw_l_black

TEXT

;ERMITTELT DEN ROT-ANTEIL EINER FARBE
get_r:
	;d0:	Farbwert (16-Bit)
	move.l	#11, d1
	lsr.w	d1, d0
	lsl.w	d0
	;d0:	Rot-Anteil (0..63)
rts

;ERMITTELT DEN GRN-ANTEIL EINER FARBE
get_g:
	;d0:	Farbwert (16-Bit)
	lsl.w	#5, d0
	move.l	#10, d1
	lsr.w	d1, d0
	;d0:	Grn-Anteil (0..63)
rts

;ERMITTELT DEN BLAU-ANTEIL EINER FARBE
get_b:
	;d0:	Farbwert (16-Bit)
	move.l	#11, d1
	lsl.w	d1, d0
	lsr.w	d1, d0
	lsl.w	d0
	;d0:	Blau-Anteil (0..63)
rts

;SETZT DEN ROT-ANTEIL EINER FARBE
set_r:
	;d0:	neuer Rot-Anteil (0..63)
	;d1:	zu verndernder Farbwert
	lsr		d0
	;alle rot-Bits des Farbwertes lschen
	bclr	#11, d1
	bclr	#12, d1
	bclr	#13, d1
	bclr	#14, d1
	bclr	#15, d1
	;einzelne Bits testen
	move.l	#4, d2
	clr.l	d3
	move.l	#11, d4
r_bit_set_loop:
	btst	d3, d0
	beq		no_r_bit
	bset	d4, d1
no_r_bit:
	addq.l	#1, d3
	addq.l	#1, d4
	dbf		d2, r_bit_set_loop
	move.l	d1, d0
	;d0:	neuer Farbwert
rts


;SETZT DEN GRN-ANTEIL EINER FARBE
set_g:
	;d0:	neuer Grn-Anteil (0..63)
	;d1:	zu verndernder Farbwert
	;alle grn-Bits des Farbwertes lschen
	bclr	#5, d1
	bclr	#6, d1
	bclr	#7, d1
	bclr	#8, d1
	bclr	#9, d1
	bclr	#10, d1
	;einzelne Bits testen
	move.l	#5, d2
	clr.l	d3
	move.l	#5, d4
g_bit_set_loop:
	btst	d3, d0
	beq		no_g_bit
	bset	d4, d1
no_g_bit:
	addq.l	#1, d3
	addq.l	#1, d4
	dbf		d2, g_bit_set_loop
	move.l	d1, d0
	;d0:	neuer Farbwert
rts

;SETZT DEN BLAU-ANTEIL EINER FARBE
set_b:
	;d0:	neuer Blau-Anteil (0..63)
	;d1:	zu verndernder Farbwert
	lsr		d0
	;alle blau-Bits des Farbwertes lschen
	bclr	#0, d1
	bclr	#1, d1
	bclr	#2, d1
	bclr	#3, d1
	bclr	#4, d1
	;einzelne Bits testen
	move.l	#4, d2
	clr.l	d3
	clr.l	d4
b_bit_set_loop:
	btst	d3, d0
	beq		no_b_bit
	bset	d4, d1
no_b_bit:
	addq.l	#1, d3
	addq.l	#1, d4
	dbf		d2, b_bit_set_loop
	move.l	d1, d0
	;d0:	neuer Farbwert
rts


;ZEICHNET AUSSCHNITT DES ORGINALBILDES
drawpeorgpic:
	;d0:	x-Position des Orginalbildes
	;d1:	y-Position des Orginalbildes
	;d2:	x-Auflsung
	;a0:	Orginalbild-Adresse
	;a1:	Screenadresse
	;Offset des Orginalbildes berechnen
	mulu.w	d2, d1
	add.l	d1, d0
	lsl.l	d0
	adda.l	d0, a0				;Offset zur Orginalbildadr. addieren
	
	;Lineoffset bestimmen
	sub.l	#100,d2
	lsl.l	d2
	;d2:	Lineoffset

	;Screenoffset zum Screen addieren
	adda.l	#7052, a1
	;Orginalbild in Screen kopieren
	move.l	#98, d0
dpeop_loop1:
	move.l	#49, d1
dpeop_loop2:
	move.l	(a0)+, (a1)+
	dbf		d1, dpeop_loop2
	adda.l	d2, a0
	adda.l	#440, a1
	dbf		d0, dpeop_loop1
rts


;ZEICHNET ROT-SHADE
draw_l_red:
	;d0:	X-Koordinate
	;d1:	Y-Koordinate
	;a0:	Screenadresse
	subq.l	#7, d0
	subq.l	#7, d1
	
	;Positionsoffset errechnen und auf Screen addieren
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Zieladresse
	
	;Shadevorgang:
	move.l	#14, d2
shade_r_loop1:
	move.l	#14, d1
shade_r_loop2:
	move.w	(a0), d3
	add.l	#%100000000000, d3
	move.w	d3, d0
	move.l	d1, d4
	bsr		get_r
	move.l	d4, d1
	cmpi.w	#62, d0
	bge		no_r_shade
	move.w	d3, (a0)
no_r_shade:
	addq.l	#2, a0
	dbf		d1, shade_r_loop2
	adda.l	#610, a0
	dbf		d2, shade_r_loop1
rts


;ZEICHNET GRN-SHADE
draw_l_green:
	;d0:	X-Koordinate
	;d1:	Y-Koordinate
	;a0:	Screenadresse
	subq.l	#7, d0
	subq.l	#7, d1
	
	;Positionsoffset errechnen und auf Screen addieren
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Zieladresse
	
	;Shadevorgang:
	move.l	#14, d2
shade_g_loop1:
	move.l	#14, d1
shade_g_loop2:
	move.w	(a0), d3
	add.l	#%100000, d3
	move.w	d3, d0
	move.l	d1, d4
	bsr		get_g
	move.l	d4, d1
	cmpi.w	#62, d0
	bge		no_g_shade
	move.w	d3, (a0)
no_g_shade:
	addq.l	#2, a0
	dbf		d1, shade_g_loop2
	adda.l	#610, a0
	dbf		d2, shade_g_loop1
rts


;ZEICHNET BLAU-SHADE
draw_l_blue:
	;d0:	X-Koordinate
	;d1:	Y-Koordinate
	;a0:	Screenadresse
	subq.l	#7, d0
	subq.l	#7, d1
	
	;Positionsoffset errechnen und auf Screen addieren
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Zieladresse
	
	;Shadevorgang:
	move.l	#14, d2
shade_b_loop1:
	move.l	#14, d1
shade_b_loop2:
	move.w	(a0), d3
	addq.l	#1, d3
	move.w	d3, d0
	move.l	d1, d4
	bsr		get_b
	move.l	d4, d1
	cmpi.w	#62, d0
	bge		no_b_shade
	move.w	d3, (a0)
no_b_shade:
	addq.l	#2, a0
	dbf		d1, shade_b_loop2
	adda.l	#610, a0
	dbf		d2, shade_b_loop1
rts


;ZEICHNET SCHWARZ-SHADE
draw_l_black:
	;d0:	X-Koordinate
	;d1:	Y-Koordinate
	;a0:	Screenadresse
	subq.l	#7, d0
	subq.l	#7, d1
	
	;Positionsoffset errechnen und auf Screen addieren
	lsl.l	d0
	mulu.l	#640, d1
	add.l	d0, d1
	adda.l	d1, a0
	;a0:	Zieladresse
	
	;Shadevorgang:
	move.l	#14, d2
shade_s_loop1:

	move.l	#14, d1
shade_s_loop2:
	;Orginale Farbe -> d3
	move.w	(a0), d3

	;Zielfarbe ist in d4 (am Anfang 0)
	clr.l	d4

	;Rotteil abdunkeln

	move.w	d3, d0	
	;Rotanteile aus Zielpixel filtern
	andi.w	#%1111100000000000, d0
	lsr.w	#5, d0
	;Farbsubtraktion
	sub.w	#%0000000001000000, d0
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d0
	bge		no_sr_sub
	move.w	#%0000000000000000, d0
no_sr_sub:
	;Rot nochmal filtern
	lsl.w	#5, d0
	andi.w	#%1111100000000000, d0
	add.w	d0, d4
	
	;Grnteil abdunkeln

	move.w	d3, d0	
	;Grnanteile aus Zielpixel filtern
	andi.w	#%0000011111100000, d0
	;Farbsubtraktion
	sub.w	#%0000000001000000, d0
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d0
	bge		no_sg_sub
	move.w	#%0000000000000000, d0
no_sg_sub:
	;Grn nochmal filtern
	andi.w	#%0000011111100000, d0
	add.w	d0, d4
	
	;Blauteil abdunkeln

	move.w	d3, d0	
	;Blauanteile aus Zielpixel filtern
	andi.w	#%0000000000011111, d0
	;Farbsubtraktion
	sub.w	#%0000000000000001, d0
	;Ergebnis testen: Wenn negativ -> auf Null setzen
	cmpi.w	#%0000000000000000, d0
	bge		no_sb_sub
	move.w	#%0000000000000000, d0
no_sb_sub:
	;Blau nochmal filtern
	andi.w	#%0000000000011111, d0
	add.w	d0, d4
		
	;Zielfarbe anstelle der alten Farbe in den Speicher schreiben
	move.w	d4, (a0)
	
	;nchstes Pixel
	addq.l	#2, a0
	
	dbf		d1, shade_s_loop2
	adda.l	#610, a0
	dbf		d2, shade_s_loop1
rts


END;