export analysepal
export analyseindypal


TEXT


;ROUTINE CONVERTS PAL-FORMAT TO EPP-FORMAT
analysepal:
	;a0:	paldat
	;a1:	destination palette
	
	move.l	#256-1, d0
a_pal_loop:
	
	;read first word: red value
	move.w	(a0)+, d1
	
	lsl.w	#6, d1
	andi.w	#%1111100000000000, d1
	
	;read second word: green value
	move.w	(a0)+, d2
	
	lsl.w	#1, d2
	andi.w	#%0000011111100000, d2
	add.w	d2, d1
	
	;read third word: blue value
	move.w	(a0)+, d2
	
	lsr.w	#5, d2
	andi.w	#%0000000000011111, d2
	add.w	d2, d1
	
	;d1:	result: 16bit RGB value
	move.w	d1, (a1)+
	
	dbf		d0, a_pal_loop
	
rts




;ROUTINE CONVERTS AN INDYPALETTE TO EPP FORMAT
analyseindypal:
	;a0:	Indypalette
	;a1:	Zielpalette (EPP)
	
	move.l	#256-1, d0
a_indypal_loop:

	;read red value
	clr.l	d1
	move.b	(a0)+, d1
	lsl.l	#8, d1
	lsl.l	#3, d1
	andi.w	#%1111100000000000, d1
	
	;read green value
	clr.l	d2
	move.b	(a0)+, d2
	lsl.l	#6, d2
	andi.w	#%0000011111100000, d2
	add.w	d2, d1
	
	;read blue value
	clr.l	d2
	move.b	(a0)+, d2
	andi.w	#%0000000000011111, d2
	add.w	d2, d1
	
	move.w	d1, (a1)+

	dbf		d0, a_indypal_loop

rts



END * OF * FILE