export pushvirtualscreen
export pullvirtualscreen
export flipvirtualscreen
export resizepicture

TEXT


;KOPIERT 320*240-SCREEN IN TEIL EINES BILDES
pushvirtualscreen:
	;d0:	Anfangsoffset
	;d1:	Lineoffset
	;a0:	Quellscreen (320*240)
	;a1:	Zielbildpuffer (beliebig)
	
	;Anfangsoffset addieren
	adda.l	d0, a1
	
	move.w	#240-1, d2			;y-counter
pvs_y_loop:

	move.w	#160-1, d3			;x-counter
pvs_x_loop:

	move.l	(a0)+, (a1)+		;copy 2 pixels

	dbf		d3, pvs_x_loop

	adda.l	d1, a1				;add lineoffset

	dbf		d2, pvs_y_loop

rts



;KOPIERT TEIL EINES BILDES IN 320*240-SCREEN
pullvirtualscreen:
	;d0:	Anfangsoffset (Bildposition)
	;d1:	Lineoffset
	;a0:	Bildpuffer
	;a1:	Screen (320*240)
	
	;Anfangsoffset add.
	adda.l	d0, a0
	
	move.w	#240-1, d2
plvs_y_loop:

	move.w	#160-1, d3
plvs_x_loop:

	move.l	(a0)+, (a1)+
	
	dbf		d3, plvs_x_loop
	
	;add lineoffset
	adda.l	d1, a0
	
	dbf		d2, plvs_y_loop


rts



;VERTAUSCHT TEIL EINES BILDES MIT 320*240-SCREEN
flipvirtualscreen:
	;d0:	Anfangsoffset (Bildposition)
	;d1:	Lineoffset
	;a0:	Bildpuffer
	;a1:	Screen (320*240)
	
	;Anfangsoffset add.
	adda.l	d0, a0
	
	move.w	#240-1, d2
fvs_y_loop:

	move.w	#160-1, d3
fvs_x_loop:

	move.l	(a0), d0
	move.l	(a1), (a0)+
	move.l	d0, (a1)+
	
	dbf		d3, fvs_x_loop
	
	;add lineoffset
	adda.l	d1, a0
	
	dbf		d2, fvs_y_loop


rts



resizepicture:
	movem.l d3-d7/a2-a6,-(sp)
	move.l	40+4(sp),d3
	;d0:	org.breite
	;d1:	org.hhe
	;d2:	ziel breite
	;d3:	ziel_hhe
	;a0:	Quellbild
	;a1:	Zielbild
	moveq 	#0,d5	;Lschfarbe (2x im LONG!!!)

	cmp.w	d0,d2
	bls.s	clip_picture
	
	cmp.w	d1,d3
	bhs.s	noclipy
	move.w	d3,d1
noclipy:
	
	move.w	d2,d4	;Zielbreite
	sub.w	d0,d2	;Breite noch zu lschen
	subq.w	#1,d2
	subq.w	#1,d0	;Breite zu kopieren

	sub.w	d1,d3	;Hhe zu lschen
	subq.w	#1,d1	;Hhe zu kopieren
			
copy_y:
	move.w 	d0,d6
copy_x:	
	move.w	(a0)+,(a1)+
	dbra 	d6,copy_x
	move.w	d2,d6
	bmi.s	skip_clear_x
clear_x:
	move.w	d5,(a1)+
	dbra	d6,clear_x
skip_clear_x:
	dbra	d1,copy_y
	
clear_rest:
	muls    d4,d3	;Words noch zu lschen (Zeilenbreite*Hhenrest)
	ble.s	noclear_y
	lsr.l 	#1,d3
	bcc.s	noodd
	move.w	d5,(a1)+
noodd:
	subq.l	#1,d3
	bmi.s	noclear_y
	swap	d3
clear_rest1:
	swap 	d3
clear_rest2:
	move.l	d5,(a1)+
	dbra	d3,clear_rest2
	swap 	d3
	dbra	d3,clear_rest1
noclear_y:
	
	movem.l (sp)+,d3-d7/a2-a6
rts
clip_picture:
	cmp.w	d1,d3	;Hhe clippen??
	bhs.s	noclip2
	move.w	d3,d1	;Dest-Hhe grer als Src-Hhe
noclip2:

	sub.w	d2,d0	;Zeilenrest
	add.l	d0,d0	;*2 -> Skippixel-Offset
	subq.w	#1,d2	;Zielbreite fr DBRA
	
	sub.w	d1,d3	;Hhenrest (zum Lschen)
	subq.w	#1,d1	;zu kopierende Hhe
copylines:
	move.w	d2,d7
copyline:
	move.w	(a0)+,(a1)+	
	dbra	d7,copyline
	adda.l	d0,a0
	dbra	d1,copylines
	
	addq.w	#1,d2	;Words pro Zeile
	move.w 	d2,d4	
	bra.s	clear_rest
END