export calc_scalepic
export prev_scalepic
export draw_scalepic

TEXT

calc_scalepic:
	;d0:	neue Breite
	;d1:	neue Hhe
	
	;Korrektur
	addq.l	#2, d0
	addq.l	#2, d1
	
	;X-Skalierungstabelle generieren
	lea		x_scale_tab, a2
	;Breite des Orginals
	move.l	#320, d3
	;Breite der Skalierung
	move.l	d0, d2
	;Anfangswerte fr Berechnung
	clr.l	d4
	clr.l	d5
scp_generate_x_tab:
	;Orginalbreite von der Skalierungsbreite subtr.
	sub.l	d3, d2
	subq.l	#1, d2
	;Wert < 0 ? -> Verzweigung
scp_gen_x_tab_bra:
	cmpi.l	#0, d2
	bgt		scp_generate_x_no_bra
	addq.l	#2, d5
	add.l	d0, d2
	addq.l	#1, d2
	bra		scp_gen_x_tab_bra
scp_generate_x_no_bra:
	addq.l	#1, d4
	cmp.l	#320, d4
	bgt		scp_gen_x_tab_end
	cmpi.l	#320*2, d5
	bge		scp_gen_x_tab_end
	;Wert in X-Skalierungstabelle eintragen
	move.l	d5, (a2)+
	bra		scp_generate_x_tab
scp_gen_x_tab_end:

	;Rest der Tabelle lschen
scp_del_x_loop:
	cmpi.l	#400, d4
	bge		scp_del_x_end
	;Tabellenwert lschen
	move.l	#-1,(a2)+
	;Screenpixel lschen
	;move.l	#45, (a1,d4.l)
	addq.l	#1, d4
	bra		scp_del_x_loop
scp_del_x_end:

	;Y-Skalierungstabelle generieren
	lea		y_scale_tab, a2
	;Hhe des Orginals
	move.l	#240, d3
	;Hhe der Skalierung
	move.l	d1, d2
	;Anfangswerte fr Berechnung
	clr.l	d4
	clr.l	d5
scp_generate_y_tab:
	;Hhe der Skalierung von der Orginalhhe subtr.
	sub.l	d3, d2
	subq.l	#1, d2
	;Wert < 0 ? -> Verzweigung
scp_gen_y_tab_bra:
	cmpi.l	#0, d2
	bgt		scp_generate_y_no_bra
	add.l	#640, d5
	add.l	d1, d2
	addq.l	#1, d2
	bra		scp_gen_y_tab_bra
scp_generate_y_no_bra:
	addq.l	#1, d4
	cmpi.l	#240, d4
	bgt		scp_gen_y_tab_end
	cmpi.l	#240*640, d5
	bge		scp_gen_y_tab_end
	;Wert in Y-Skalierungstabelle eintragen
	move.l	d5, (a2)+
	bra		scp_generate_y_tab
scp_gen_y_tab_end:

	;Rest der Tabelle lschen
scp_del_y_loop:
	move.l	#-1,(a2)+
	addq.l	#1, d4
	cmpi.l	#400, d4
	bge		scp_del_y_end
	bra		scp_del_y_loop
scp_del_y_end:	

rts	


;ROUTINE ZUM PREVIEW-ZEICHNEN DER SKALIERUNG
prev_scalepic:
	;a0:	Bildadresse
	;a1:	Screenadresse
	;Preview-Skalierung zeichnen
	move.l	#240/2-1, d0					;y-counter
	lea		y_scale_tab, a2
	;a0:	Y-Skalierungstabelle
scp_prev_y_loop:
	move.l	#320/2-1, d1					;x-counter
	lea		x_scale_tab, a3
	;a1:	X-Skalierungstabelle
scp_prev_x_loop:
	;Farbe auf Schwarz setzen
	clr.l	d3
	;Wert der Y-Scalierungstabelle nehmen und prfen...
	move.l	(a2), d2
	tst.l	d2
	blt		scp_prev_pixel
	;...und den Wert der X-Skalierungstabelle addieren und prfen
	move.l	(a3), d4
	add.l	d4, d2
	tst.l	d4
	blt		scp_prev_pixel
	;Farbe ermitteln
	;d2:	Offset
	move.w	(a0,d2.l), d3
	;Pixel kopieren
scp_prev_pixel:
	move.w	d3, (a1)
	addq.l	#4, a1
	;X der X-Skalierungstabelle erhhen
	addq.l	#8, a3
	dbf		d1, scp_prev_x_loop
	;Y der Y-Skalierungstabelle erhhen
	addq.l	#8, a2
	adda.l	#640, a1
	dbf		d0, scp_prev_y_loop			;Ende der Y-Schleife
rts


;ROUTINE ZUM ZEICHNEN DER SKALIERUNG
draw_scalepic:
	;a0:	Bildadresse
	;a1:	Screenadresse
	;Preview-Skalierung zeichnen
	move.l	#240-1, d0					;y-counter
	lea		y_scale_tab, a2
	;a0:	Y-Skalierungstabelle
scp_draw_y_loop:
	move.l	#320-1, d1					;x-counter
	lea		x_scale_tab, a3
	;a1:	X-Skalierungstabelle
scp_draw_x_loop:
	;Farbe auf Schwarz setzen
	clr.l	d3
	;Wert der Y-Scalierungstabelle nehmen und prfen...
	move.l	(a2), d2
	tst.l	d2
	blt		scp_draw_pixel
	;...und den Wert der X-Skalierungstabelle addieren und prfen
	move.l	(a3), d4
	add.l	d4, d2
	tst.l	d4
	blt		scp_draw_pixel
	;Farbe ermitteln
	move.w	(a0,d2.l), d3
	;Pixel kopieren
scp_draw_pixel:
	move.w	d3, (a1)+
	;X der X-Skalierungstabelle erhhen
	addq.l	#4, a3
	dbf		d1, scp_draw_x_loop
	;Y der Y-Skalierungstabelle erhhen
	addq.l	#4, a2
	dbf		d0, scp_draw_y_loop			;Ende der Y-Schleife
rts


*
*
*




BSS

x_scale_tab:	ds.l	1000	;Tabelle der x-Offsets der Skalierung
y_scale_tab:	ds.l	1000	;Tabelle der y-Offsets der Skalierung

END;