;TRU-ANALYSATOR BY NORMAN FESKE (NO/ESCAPE) IN 01.05.96

;TRUE COLOR 16 BIT: RRRRRGGGGGGBBBBB

;TRU-HEADER:
;offset | numb.of bytes |  function
;----------------------------------------------------------------
; $00   |      4        |  ASCII: "Indy"/"IBLK" - no function
; $04   |      2        |  x-resolution (motorola)
; $06   |      2        |  y-resolution (motorola)
; $08   |     147       |  ???

export analysetru
export analysetrublk



TEXT ****************************************************


analysetru:
	;a0:	Bildadresse
	;a1:	Zieladresse (Screen)
	
	;push registers
	movem.l	d1-d7/a0-a6, -(sp)
	
	cmpi.l	#"Indy", (a0)
	bne		a_tru_end
	
	;clear screen
	move.l	#2*320*240/4-1, d0
	move.l	a1, a2
a_tru_clrscr:
	clr.l	(a2)+
	dbf		d0, a_tru_clrscr
	
	;lineoffset
	clr.l	d2
	move.w	#320, d2
	sub.w	4(a0), d2
	;d2:	lineoffset
	
	;x-res.
	clr.l	d4
	move.w	4(a0), d4
	
	;y-res.-1
	clr.l	d5
	move.w	6(a0), d5
	subq.l	#1, d5
	
	;Headeroffset
	adda.l	#$100, a0
	
	;diff.: Bild breiter/schmaler als org.Bild
	cmpi.l	#320, d4
	bgt		a_tru_hi_res
	
	
	;picture is smaller than resol.
a_tru_low_res:
	
	;y-counter
	move.l	d5, d0
a_tru_loopy:

	;x-res. as x-loop-counter
	move.l	d4, d3
a_tru_loopx:

	;copy pixel
	move.w	(a0)+, (a1)+
	
	;x-counter
	subq.l	#1, d3
	tst.l	d3
	ble		a_tru_next_line

	bra		a_tru_loopx
	
a_tru_next_line:

	;add. lineoffset to screen
	adda.l	d2, a1

	dbf		d0, a_tru_loopy

	bra		a_tru_end
	
	
	;picture width is higher than screensize
a_tru_hi_res:

	;pic-lineoffset
	move.w	d4, d2
	sub.w	#320, d2
	lsl.w	d2
	;d2:	pic.lineoffset
	
	;y-counter
	move.l	d5, d0
a_tru_hloopy:

	;x-screensize. as x-loop-counter
	move.l	#320-1, d3
a_tru_hloopx:

	;copy pixel
	move.w	(a0)+, (a1)+
	
	dbf		d3, a_tru_hloopx
		
	;add. lineoffset to picture
	adda.l	d2, a0

	dbf		d0, a_tru_hloopy


a_tru_end:

	;pull registers
	movem.l	(sp)+, d1-d7/a0-a6

rts




;ROUTINE ANALYSES AN INDYPAINT BLOCK
analysetrublk:
	;a0:	pic.data
	;a1:	blockadress
	
	cmpi.l	#"IBLK", (a0)
	bne		a_tru_blk_end
	
	addq.l	#4, a0
	
	;x-resolution
	clr.l	d1
	move.w	(a0), d1
	
	;y-resolution
	clr.l	d2
	move.w	2(a0), d2
	
	;clear blkflag
	clr.l	d0
	
	;calc. number of pixels
	mulu.l	d1, d2
	
	;against overflow
	cmpi.l	#320*240, d2
	bgt		a_tru_blk_end
	
	;longwise copiing
	lsr.l	d2
	;x-res,y-res,pixeldata -1 (dbra)
	addq.l	#1, d2
	;d2:	loopcounter
	
	;copyloop
a_tru_blk_loop:
	move.l	(a0)+, (a1)+
	dbf		d2, a_tru_blk_loop

	;set blkflag	
	move.l	#1, d0
	
a_tru_blk_end:

rts




END * OF * FILE